#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Antenna Setup',
'/antennaInfo.html'
) ;
my %antInfo ;
getAntennaInfo( \%antInfo ) ;
my @antTypes = keys %antInfo ;
my %antNames ;
my %antNgs ;
for my $type (@antTypes)
{
$antNames{$type} = $antInfo{$type}{'name'} ;
$antNgs{$type} = $antInfo{$type}{'ngs'} ;
$antNgs{$type} =~ s/ /./g ;
}
@antTypes = sort( { ($b != 0 and $a != 0)
? $antNames{$a} cmp $antNames{$b}
: ($a == $b)
? 0
: ($a == 0)
? +1
: -1
}
@antTypes
) ;
my $type = param('update') ;
if ( defined $type and ($type ne '') )
{
param( 'antType', $type ) ;
param( 'antNgs', $type ) ;
param( 'method', $antInfo{$type}{'defMethod'} ) ;
}
else
{
my %antSetup ;
getAntennaSetup( \%antSetup ) ;
param( 'antType', $antSetup{ 'type' } ) ;
param( 'antNgs', $antSetup{ 'type' } ) ;
param( 'method',  $antSetup{ 'method' } ) ;
param( 'serial',  $antSetup{ 'serial' } ) ;
param( 'textSerial',  $antSetup{ 'textSerial' } ) ;
param( 'domeSerial',  $antSetup{ 'domeSerial' } ) ;
param( 'height',  $antSetup{ 'height' } ) ;
}
$type = param( 'antType' ) ;
if ($type > 255)
{
print b( 'WARNING - This antenna type is not fully ',
'compatible with CMR Outputs.<br/><br/>'
) ;
}
print startform( -name=>"theForm",
-action=>'/perl-scripts/gpsadmin/setAntenna.cgi'
) ;
print '<table border=0>' ;
print Tr( td( {align=>'right'}, b( "Numeric Serial Number:" ) ),
td( {align=>'center'}, textfield( 'serial', '', 10, 8 ) )
) ;
print Tr( td( {align=>'right'}, b( "Text Serial Number:" ) ),
td( {align=>'center'}, textfield( 'textSerial', '', 25, 20 ) )
) ;
print Tr( td( {align=>'right'}, b( "Radome Serial Number:" ) ),
td( {align=>'center'}, textfield( 'domeSerial', '', 25, 20 ) )
) ;
print Tr( td( {align=>'right'}, b("Antenna Name:") ),
td( popup_menu ( -name=>'antType',
-values=>\@antTypes,
-labels=>\%antNames,
-onChange=>'newName() ;',
-default=>'Unknown',
),
)
) ;
@antTypes = sort( { ($b != 0 and $a != 0)
? $antNgs{$a} cmp $antNgs{$b}
: ($a == $b)
? 0
: ($a == 0)
? +1
: -1
}
@antTypes
) ;
print Tr( td( {align=>'right'}, b("NGS/IGS Name:") ),
td( popup_menu ( -name=>'antNgs',
-values=>\@antTypes,
-labels=>\%antNgs,
-onChange=>'newNgs() ;',
-default=>'Unknown',
),
)
) ;
print hidden( -name=>'antName',
-value=>$antNames{$type}
) ;
print Tr( td( {align=>'right'}, b( "Antenna Type:" ) ),
td( {align=>'center'}, $type )
) ;
print Tr( td( {align=>'right'}, b( "Character Code:" ) ),
td( {align=>'center'}, $antInfo{$type}{'code'} )
) ;
my $methString ;
my $methCount = $antInfo{$type}{'methodCount'} ;
if ($methCount > 1)
{
my %methodLabels ;
for ( my $m = 0 ; $m < $methCount ; ++$m)
{
$methodLabels{$m} = $antInfo{$type}{'methods'}[$m] ;
}
$methString = popup_menu( -name=>'method',
-values=>[0..$methCount-1],
-labels=>\%methodLabels ,
-default=>$antInfo{$type}{'defMethod'}
) ;
}
else
{
$methString = $antInfo{$type}{'methods'}[0]
. hidden( -name=>'method',
-value=>'0'
) ;
}
print Tr( td( {align=>'right'}, b( "Height:" ) ),
td( {align=>'center'}, textfield( 'height', '', 8, 8 ) )
) ;
print Tr( td( {align=>'right'}, b("Height Reference Point:") ),
td( {align=>'center'},$methString )
) ;
print '</table>' ;
print hr() ;
print button( -name=>"OK",
-value=>"OK",
-onClick=>'Okay()'
) ;
print "&nbsp;" ;
print button( -name=>"Cancel",
-value=>"Cancel",
-onClick=>'parent.loadDataFrame("rconfigDisplay.cgi")',
) ;
print endform() ;
print <<EOF ;
<script>
/************************/
function newNgs()
/************************/
{
f = document.theForm ;
index = f.antNgs.selectedIndex ;
antType = f.antNgs.options[index].value ;
update( antType ) ;
}
/************************/
function newName()
/************************/
{
f = document.theForm ;
index = f.antType.selectedIndex ;
antType = f.antType.options[index].value ;
update( antType ) ;
}
/************************/
function update( antType )
/************************/
/* The user has changed the antenna type.  This requires us to
* redraw the form, showing popups and other info relevant to the new
* antenna type.  To do this we construct a url containing the data
* in the form fields, and the CGI parameter "update=ANTTYPE".
* The request is submitted and the new page comes back.
* We use loadDataFrame to first blank the page before loading the new
* URL.  This prevents inadvertent OK presses, multiple submissions,
* etc.
*/
{
f = document.theForm ;
serial = f.serial.value ;
textSerial = f.textSerial.value ;
domeSerial = f.domeSerial.value ;
height = f.height.value ;
parent.loadDataFrame( 'antenna.cgi?update='
+ escape(antType)
+ '&serial='
+ escape(serial)
+ '&textSerial='
+ escape(textSerial)
+ '&domeSerial='
+ escape(domeSerial)
+ '&height='
+ escape(height)
) ;
} /* end of update() */
/**********************************************************************/
function Okay()
/**********************************************************************/
/* Invoked when the OK button is pressed.
* This just submits the entire form with all parameters.
* Suppressed if we've already done a submission so we won't get
* two of the same request.
*/
{
f = document.theForm ;
// Verify that the antenna serial number is an integer.
if ( parent.isNotAnInteger( f.serial.value, 'Serial number' ) )
return ;
parent.submitForm( document.theForm, '' ) ;
} /* end of Okay() */
</script>
EOF
print end_html() ;
