#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Logged Data Files',
'/dataFilesInfo.html'
) ;
my $Rootdir='/var/gps' ;
print header(-expires=>'+1s') ;
my $dirpath = param('dir') ;
if ( ! $dirpath
or $dirpath =~ /[^\w\/\.]/
or $dirpath =~ /\.\./
or $dirpath =~ /^\/incoming/
)
{
$dirpath = '/' ;
}
if ( $dirpath !~ '/$' )
{
$dirpath .= '/' ;
}
my $sortBy = param('sort') ;
if ( (! $sortBy)
|| ( $sortBy ne 'size'
&& $sortBy ne 'time'
&& $sortBy ne 'timer'
&& $sortBy ne 'sizer'
)
)
{
$sortBy = 'name' ;
}
print <<EOF ;
<style type="text/css">
<!--
a {color:blue ; text-decoration: none }
-->
</style>
EOF
if (my $message = param('msg'))
{
print $message, br(), br() ;
}
my($usedSpace, $availSpace) = ( split " ", qx( df /var/gps ) )[9..10] ;
my ($journalSize) = qx( sudo /usr/local/fireball/ext3JournalSize ) ;
$usedSpace -= $journalSize ;
printf "<b>Logging Space:</b> %.3f Mbytes Used.  %.3f Mbytes Available",
$usedSpace/1024,
$availSpace/1024 ;
print br(),br() ;
my $goodDirectory = chdir( $Rootdir.$dirpath ) ;
my @dirfiles = () ;
my @regfiles = () ;
my %mtimes ;
my %sizes ;
if ($goodDirectory)
{
for my $f (glob '*')
{
my (undef, undef,undef, undef, undef, undef, undef,
$size, undef, $mtime, undef ) = lstat $f ;
if ( -f _ )
{
push( @regfiles, $f )
}
elsif ( -d _ )
{
push( @dirfiles, $f )
unless ( ( $f eq 'incoming' and $dirpath eq '/' )
or ( $f eq 'tmp' and $dirpath eq '/' )
or ( $f eq 'lost+found' and $dirpath eq '/' )
or ( $f eq 'CVS' )
) ;
}
elsif ( -l _ )
{
if ( -d $f )
{
push @dirfiles, $f ;
}
else
{
unlink $f ;
}
}
$mtimes{$f} = $mtime ;
$sizes{$f}  = $size ;
}
if ($sortBy eq 'time')
{
@dirfiles = sort {($mtimes{$b}) <=> ($mtimes{$a})} @dirfiles
}
if ($sortBy eq 'size')
{
@regfiles = sort {($sizes{$b}) <=> ($sizes{$a})} @regfiles
}
elsif ($sortBy eq 'sizer')
{
@regfiles = sort {($sizes{$a}) <=> ($sizes{$b})} @regfiles
}
elsif ($sortBy eq 'time')
{
@regfiles = sort {($mtimes{$b}) <=> ($mtimes{$a})} @regfiles
}
elsif ($sortBy eq 'timer')
{
@regfiles = sort {($mtimes{$a}) <=> ($mtimes{$b})} @regfiles
}
}
my $subdircount  = scalar(@dirfiles) ;
my $regfilecount = scalar(@regfiles) ;
if ($dirpath ne "/")
{
splice @dirfiles, 0, 0, ( '..' ) ;
(undef, undef,undef, undef, undef, undef, undef,
undef, undef, $mtimes{'..'}, undef ) = lstat ".." ;
}
print b( "Directory path $dirpath" ) ;
if ( $goodDirectory )
{
print "<br />&nbsp;&nbsp;&nbsp;&nbsp;",
$subdircount,
" subdirector",
($subdircount == 1) ? 'y' : 'ies',
" and ",
$regfilecount,
" file",
($regfilecount == 1) ? '.' : 's.'
;
}
else
{
print br(), b( "This directory does not exist, or cannot be read.") ;
}
print p() ;
print '<Table border="0">' ;
print Tr( td( "" ),
td( a( {href=>"dataFiles.cgi?sort=name&dir=$dirpath" },
(($sortBy eq 'name') ? '<b>Name</b>' : 'Name')
)
),
td( {width=>"20"} ),
td( {align=>'center'},
a( {href=>( ($sortBy ne 'time')
? "dataFiles.cgi?sort=time&dir=$dirpath"
: "dataFiles.cgi?sort=timer&dir=$dirpath"
)
},
(($sortBy eq 'time' || $sortBy eq 'timer')
? '<b>Modified</b>'
: 'Modified')
)
),
td( {width=>"20"} ),
td( {align=>'center'},
a( {href=>( ($sortBy ne 'size')
? "dataFiles.cgi?sort=size&dir=$dirpath"
: "dataFiles.cgi?sort=sizer&dir=$dirpath"
)
},
(($sortBy eq 'size' || $sortBy eq 'sizer')
? '<b>Size</b>'
: 'Size')
)
),
td( {width=>"20"} ),
td("Delete"),
) ;
print Tr( td( {colspan=>8}, hr() ) ) ;
my @monthList = ("Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec") ;
for my $f (@dirfiles, @regfiles)
{
my $icon ;
my $isRegularFile = 1 ;
my $target ;
my $delete ;
my $active = ( $f =~ m/\.A$/ ) ;
if ($f eq '..')
{
$icon = '/icons/back.gif' ;
$isRegularFile = 0 ;
$target = $dirpath ;
$target =~ s|[^/]*/$|| ;
$target="dataFiles.cgi?sort=$sortBy&dir=".$target ;
}
elsif (-d $f)
{
$icon = '/icons/folder.gif' ;
$isRegularFile = 0 ;
$target="dataFiles.cgi?sort=$sortBy&dir=".$dirpath.$f."/" ;
}
else
{
$icon = '/icons/binary.gif' ;
$target = "/download" . $dirpath . CGI::escape($f) ;
}
my (undef,$min,$hour,$day,$month,$year) = gmtime($mtimes{$f}) ;
$month= $monthList[$month] ;
my $date = sprintf( "%02d-%s-%04d&nbsp;%02d:%02d",
$day,
$month,
$year+1900,
$hour,
$min ) ;
$f = 'Parent Directory' if ($f eq '..') ;
if ( !$active )
{
print "<tr>\n<td> <a href=\"",
$target,
'"> <img border=0 src="',
$icon,
'" /> </a> </td> <td> <a href="',
$target,
'"> <code>',
$f,
'</code> </a></td>' ;
}
else
{
my $noA = $f ;
$noA =~ s/\.A$// ;
print "<tr>\n<td>",
'<img border=0 src="',
$icon,
'" /> </td> <td>',
'<code>',
$noA,
'</code> </a></td>' ;
}
print '<td></td> <td> <code>',
$date,
'</code> </td>'
;
if ( $isRegularFile )
{
my $size = $sizes{$f} ;
$size = ($size >= 1024)
? sprintf( '%0.0fK', $size/1024 )
: sprintf( '%d'    , $size      ) ;
print '<td></td> <td align="right"> <code>',
$size,
'</code> </td> <td></td> <td align="center">' ;
if ( !$active )
{
print '<a href="javascript:rmfile(\'',
$dirpath,
$f,
'\')"><img border="0" alt="Delete" src="/images/redX.gif" />',
'</a>' ;
}
else
{
print 'Logging' ;
}
print '</td>' ;
}
print "</tr>\n" ;
}
if ( $subdircount  == 0
and $regfilecount == 0
)
{
print '<tr>' ;
print td( '&nbsp;'),
td( {colspan=>6}, b("This directory is empty!") )
;
if ( $dirpath ne "/" )
{
print td( {align=>'center'},
a( { href => "javascript:RmDir( \'$dirpath\' )" },
img( { border=>'0',
src=>'/images/redX.gif',
alt=>'Delete This Directory'
}
)
)
) ;
}
print '</tr>' ;
}
elsif ( $dirpath ne "/" )
{
print '<tr>' ;
print td( {colspan=>7, align=>'right'},
b("Delete ALL FILES AND SUBDIRECTORIES in this directory.")
) ;
print '<td align="center">',
'<a href="javascript:RmDir(\'',
$dirpath,
'\')"> <img border="0" alt="Delete" src="/images/redX.gif" />',
'</a></td>' ;
print '</tr>' ;
}
print "</Table>\n" ;
my $time=time() ;
print <<EOF ;
<script>
/********************************************************************/
function RmDir( dirname )
/********************************************************************/
{
/* Check if the user really means to do the deletion.
* confirm() returns true if user hits OKAY.
*/
if ( confirm( 'Delete ALL FILES in directory '
+ dirname
+ "\\nincluding ALL SUBDIRECTORIES?"
)
)
{
// Submit the cgi request to delete this directory.
// Include the timestamp when this page was formatted, so we
// can avoid deleting any files that changed AFTER we viewed
// the directory.
parent.loadDataFrame(
'/perl-scripts/fileaccess/deleteFile.cgi'
+ '?delete='
+ escape(dirname)
+ '&sortBy=$sortBy'
+ '&time=$time'
) ;
}
} /* end of RmDir() */
/********************************************************************/
function rmfile( filename )
/********************************************************************/
{
// Submit the cgi request to delete this file.
parent.loadDataFrame(
'/perl-scripts/fileaccess/deleteFile.cgi'
+'?delete='
+ escape(filename)
+'&sortBy=$sortBy'
) ;
} /* end of rmfile() */
</script>
EOF
print end_html() ;
EXIT:
