#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Reference Frequency Source',
'/extRefInfo.html'
) ;
my $setting = qx( cat /etc/sysconfig/extRefFreq ) ;
$setting = ( $setting =~ m/External/ )
? 'enabled'
: 'disabled'
;
my (undef, $detected) = split( ',',
qx(/usr/local/fireball/extfreq -p)
) ;
$detected = ($detected =~ m/present/)
? 'present'
: 'not detected'
;
print <<EOF ;
<Script>
/**********************************************************************/
function OkButton()
/**********************************************************************/
/* Called when the OK button is pressed.
* Asks for confirmation and then submits the request to the NetRS.
* Questions are asked in two cases:
* o If the user is requesting the external reference but no external
*   source is detected.  This warning comes up even if no change is
*   being made.  If the user says yes, we do what he asks.
*
* o We also confirm if we are changing the source, regardless of which
*   direction or the presence of the external signal.
*/
{
// If the selection is to use the External signal, but the signal
// isn't detected we ask for confirmation.
if ( "$detected" != 'present'
&& document.theForm.refsource[1].checked
)
{
if (confirm("External selected but no External source detected!\\n"
+"Are you sure?" )
)
{
parent.submitForm( document.theForm, "" ) ;
}
return ;
}
// If we aren't changing the settings, go ahead and submit the
// request.
// But if the setting is being changed, ask for confirmation before
// submitting the request.
if ( ( "$setting" == 'disabled'
&& document.theForm.refsource[0].checked
)
|| ( "$setting" == 'enabled'
&& document.theForm.refsource[1].checked
)
|| (confirm( "Reference source is being changed.\\n"
+"Are you sure?"
)
)
)
{
parent.submitForm( document.theForm, "" ) ;
}
} /* end of DefaultsButton() */
</Script>
EOF
print startform(  -name=>'theForm',
-action=>'/perl-scripts/gpsadmin/setExtRef.cgi'
) ;
my @Control = radio_group( -name=>'refsource',
-value=>[ 'Internal', 'External' ],
-nolabels=>1,
-default=> ($setting eq 'disabled')
? 'Internal'
: 'External'
) ;
print table( {border=>'1'},
Tr(
td( {width=>'30', align=>'center'}, $Control[0] ),
td( b('Internal'),br(),
'The internal reference oscillator is used for
tracking GPS signals.'
)
),
Tr(
td( {align=>'center'}, $Control[1] ),
td( b('External'),
br(),
'The 10MHz external reference signal is used for
tracking GPS signals.',
br(),
'WARNING: This receiver will not track satellites '
.'if External is selected and a suitable 10MHz '
.'signal is not available.',
br(),
'An external 10MHz signal ',
($detected eq 'present')
? b('is currently detected.')
: b('is NOT currently detected.')
)
)
) ;
print br(),hr() ;
print <<EOF ;
Note: Changing the Reference Frequency Source will interrupt GPS
tracking, data logging, data streams, etc.
<br /> <br />
EOF
print button( -name=>'OK',
-value=>'OK',
-onClick=>'OkButton() ;',
) ;
print '&nbsp;' ;
print button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>
'parent.loadDataFrame( "/perl-scripts/rconfigDisplay.cgi" ) '
) ;
print endform() ;
print end_html() ;
