#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Firmware Status',
'/firmwareStatus.html'
) ;
print <<EOF ;
<style type="text/css">
<!--
a {color:blue ; text-decoration: none }
-->
</style>
EOF
print <<EOF ;
<script>
function installCheck( filename )
/* Verify that the user really wants to install the selected firmware
* RPM.  Called either from an image link in the firmware file table, or
* from the Install button along the bottom of the page.  Puts up a
* confirmation dialog box and waits for the user's input.  If the user
* says OK load in the firmwareInstall CGI script.
*/
{
if ( confirm( "Installing " + filename
+ "\\nThis can take several minutes?"
+ "\\nAre you sure?"
)
)
{
parent.loadDataFrame(
"/perl-scripts/sysadmin/firmwareInstall.cgi?install="
+ escape( filename )
) ;
}
}
function deleteCheck( filename )
/* Verify that the user really wants to delete the selected firmware
* RPM.  Called from an image link in the firmware file table.
*/
{
if (confirm( "Deleting " + filename + "\\nAre you sure?" ) )
{
parent.loadDataFrame(
"/perl-scripts/sysadmin/firmwareDelete.cgi?delete="
+ escape( filename )
) ;
}
}
</script>
EOF
my $serialNumber = qx(/usr/bin/sudo /usr/local/fireball/warranty -s) ;
chomp $serialNumber ;
$serialNumber = (split("[ :]+",$serialNumber))[1] ;
my $warrantyDate = qx(/usr/bin/sudo /usr/local/fireball/warranty -w) ;
$warrantyDate = (split("[ :]+",$warrantyDate))[2] ;
my $warrantyString ;
if ($warrantyDate != 0)
{
my ($month,$day,$year) = ($warrantyDate =~ /(..)(..)(....)/) ;
$warrantyDate = sprintf( "%04d/%02d/%02d", $year,$month,$day ) ;
$warrantyString = "$day $monthStrings[ $month-1 ] $year" ;
}
else
{
$warrantyString = 'none' ;
$warrantyDate = '2000/01/01' ;
}
print '<table border="0">' ;
my $fwVersion = 'Unknown' ;
my $fwDate    = '01-Jan-2000' ;
if ( -r '/usr/local/fireball/defaults/firmwareVersion' )
{
($fwVersion, $fwDate) = split( "\n", qx( cat /usr/local/fireball/defaults/firmwareVersion ) ) ;
my ($year,$month,$day) = split( '/', $fwDate ) ;
$fwDate = "$day $monthStrings[$month-1] $year" ;
}
print table( {align=>'center', border=>0},
Tr( td( {align=>"right"}, "Firmware Version:" ),
td( {align=>"center"}, b( "$fwVersion&nbsp;&nbsp;&nbsp;$fwDate" ) ) ,
),
Tr( td( {align=>'right'}, "Serial Number:" ),
th( $serialNumber )
),
Tr( td( {align=>'right'}, "Firmware Warranty Date:" ),
th( $warrantyString )
),
) ;
print hr() ;
print h3( {align=>'center'}, 'Uploaded Firmware Files' ) ;
chdir '/var/gps/incoming' ;
opendir FWDIR, '.' ;
my @allfiles ;
foreach my $f ( readdir(FWDIR) )
{
if ( ( ! -d $f )
&& ( $f !~ /^\./ )
)
{
push @allfiles, $f ;
}
}
closedir FWDIR ;
@allfiles = sort( @allfiles ) ;
if (@allfiles)
{
print '<Table border align="center">' ;
print Tr( th( ['File','Type', 'Details', 'Install', 'Delete'] ) ) ;
for my $f ( @allfiles )
{
my $type = 'unknown' ;
my @fileTest = split( ' ', qx( file $f ) ) ;
if ( $fileTest[1] eq 'RPM' )
{
$type = 'RPM package ' ;
}
print Tr(
td( '&nbsp;',
a({ href => 'firmware.cgi?fwfile='.CGI::escape($f) },
$f
),
'&nbsp;'
),
td( $type ),
td( {align=>'center'},
a( { href => 'firmware.cgi?fwfile='.CGI::escape($f) },
img( { src=>'/images/bluedot.gif',
border=>'0',
alt=>'Details'
}
)
)
),
td( {align=>'center'},
a( { href => "javascript:installCheck( '$f' )" },
img( { src=>'/images/bluedot.gif',
border=>'0',
alt=>'Install'
}
)
)
),
td( {align=>'center'},
a( { href => "javascript:deleteCheck( '$f' )" },
img( { src=>'/images/redX.gif',
border=>'0',
alt=>'Delete'
}
)
)
)
) ;
}
print '</Table>' ;
print br(), hr() ;
my $f = param( 'fwfile' ) ;
$f = $allfiles[0] if ( !$f ) ;
print h3( {align=>'center'}, "Firmware file $f" ) ;
if ( ! IsRpmFile( $f ) )
{
print h3(  'This does not appear to be an RPM file '
.'so it cannot be installed.'
) ;
goto EXIT ;
}
my $description =
qx( /usr/lib/rpm/rpmq -q -p $f --qf '%{DESCRIPTION}') ;
my $firmwareDate = ($description =~ m/.*Firmware Date\s+(\S+)/ )[0] ;
if (! $firmwareDate)
{
print h3(  'There is no firmware date in this file '
.'so it cannot be installed.'
) ;
goto EXIT ;
}
my ($year,$month,$day) = ($firmwareDate =~ m|(.+)/(.+)/(.+)|) ;
$firmwareDate = sprintf( "%04d/%02d/%02d", $year,$month,$day ) ;
if ( $warrantyDate ge $firmwareDate
|| $description =~ m/Expected Installation Time.*:.*\./
)
{
print "This file <b>is installable</b> under the terms of "
."your warranty.\n" ;
}
else
{
print h3( 'This file is dated after your Warranty Expiration '
.'date and cannot be installed.'
) ;
}
print '<p><b>Details:</b><pre>' ;
print qx( /usr/lib/rpm/rpmq -q -p $f --qf '\
Name        : %{NAME}
Summary     : %{SUMMARY}
Version     : %{VERSION}-%{RELEASE}
Build Date  : %{BUILDTIME:date}
License     : %{LICENSE}
'
) ;
printf( "Size        : %d bytes\n\n", -s $f ) ;
print $description ;
print '</pre>' ;
print startform( -name=>"theForm" ) ;
print button( -name=>'Install',
-value=>'Install',
-onClick=> "installCheck( '$f' ) ; "
) ;
print endform() ;
}
else
{
print 'There are no firmware files available.', hr() ;
print '<br /><br />' ;
print table( {align=>'center', border=>2},
Tr( td( {align=>'center' },
a( {href=>
'/perl-scripts/sysadmin/firmwareUpload.cgi'},
'Upload<br />Firmware File'
)
),
)
) ;
}
EXIT:
print end_html() ;
