#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
startPage( 'Set Antenna' ) ;
my $errorMessage = '' ;
my $height = param( 'height' ) ;
my $antType = param( 'antType' ) ;
my $antName = param( 'antName' ) ;
my $serial = param( 'serial' ) ;
my $method = param( 'method' ) ;
my $textSerial = param( 'textSerial' ) ;
$textSerial =~ s/^\s*// ;
$textSerial =~ s/\s*$// ;
my $domeSerial = param( 'domeSerial' ) ;
$domeSerial =~ s/^\s*// ;
$domeSerial =~ s/\s*$// ;
if ( $serial eq '' )
{
$errorMessage = 'Serial number must be specified.' ;
}
elsif ( $height !~ m/^\d*\.\d+$/ # .333
and $height !~ m/^\d+\.\d*$/ # 333.
and $height !~ m/^\d+$/     # 333
)
{
$errorMessage = 'Illegal height.' ;
}
elsif ( $antType !~ m/^\d+$/ )
{
$errorMessage = 'Illegal antenna type.' ;
}
elsif ( $antName eq '' )
{
$errorMessage = 'Illegal antenna name.' ;
}
elsif ( $method !~ m/^\d+$/ )
{
$errorMessage = 'Illegal method parameter.' ;
}
else
{
print h2( 'Antenna Changes Accepted' ) ;
$serial = $serial + 0 ;
updateAntennaSetup( $serial,
$antType,
$height,
$method,
$antName,
$textSerial,
$domeSerial
) ;
print <<EOF;
<Script>
parent.loadAfterDelay( 'rconfigDisplay.cgi', 1000 ) ;
</Script>
EOF
goto EXIT ;
}
ERROR:
print <<EOF;
<Script>
alert( '$errorMessage' ) ;
parent.loadAfterDelay( 'antenna.cgi?update='
+ escape('$antType')
+ '&serial='
+ escape('$serial')
+ '&height='
+ escape('$height')
+ '&method='
+ escape('$method')
, 1000) ;
</Script>
EOF
EXIT:
print end_html() ;
