#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
startPage( 'Set Port' ) ;
my %allPortData ;
getPortSetup( \%allPortData ) ;
my $errorMessage = '' ;
my $thePort = param( 'thePort' ) ;
if ( defined(my $newPortNum = param('newPort')) )
{
$newPortNum =~ s/^\s*// ;
$newPortNum =~ s/\s*$// ;
if ($newPortNum !~ /^\d+$/)
{
$errorMessage = "Port Number must be a positive number." ;
goto ERROR ;
}
if ($newPortNum > 65535 or $newPortNum < 1024)
{
$errorMessage = "Port Number must be between 1024 and 65535." ;
goto ERROR ;
}
if ( $newPortNum == 4001 ) # Mfg Test socket
{
$errorMessage = "This Port Number is Reserved." ;
goto ERROR ;
}
my $protocol ;
if ($thePort =~ /TCP/i)
{
$thePort = 'TcpPort'.$newPortNum ;
$protocol = 'tcp' ;
}
elsif ($thePort =~ /UDP/i)
{
$thePort = 'UdpPort'.$newPortNum ;
$protocol = 'udp' ;
}
elsif ($thePort =~ /REP/i)
{
$thePort = 'RepPort'.$newPortNum ;
$protocol = 'rep' ;
}
if (exists($allPortData{$thePort}))
{
$errorMessage = "$thePort is already defined." ;
goto ERROR ;
}
$allPortData{$thePort}{'protocol'} = $protocol ;
$allPortData{$thePort}{'enable'} = 1 ;
}
my ( $protocol, $portnum ) = split 'Port', $thePort ;
$protocol = lc($protocol) ;
my $authenticate = defined( param( 'Authenticate' ) ) ;
$allPortData{$thePort}{'authenticate'} = $authenticate ;
my $theService = lc(param( 'service' )) ;
$theService = 'met' if ($theService eq 'met-tilt') ;
$theService = 'svstatus' if ($theService eq 'sv status') ;
$allPortData{$thePort}{'service'} = $theService ;
if ($protocol eq 'rep')
{
for my $p ( keys %allPortData )
{
next if ($p eq $thePort) ;
next if ($p eq 'MetControls') ;
next if ($p eq 'AuthKey') ;
if ($allPortData{$p}{'protocol'} eq 'rep')
{
delete( $allPortData{$p} ) ;
}
}
}
if ($theService eq 'ppp')
{
my $localIP = param( 'localIP' ) ;
my $remoteIP = param( 'remoteIP' ) ;
if (! $localIP or !$remoteIP)
{
$errorMessage = "Both IP addresses must be specified." ;
goto ERROR ;
}
$localIP =~ s/^\s*(\S*)\s*$/$1/ ;
$remoteIP =~ s/^\s*(\S*)\s*$/$1/ ;
if ( $localIP !~ m/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/
or $1 > 255
or $2 > 255
or $3 > 255
or $4 > 255
or $remoteIP !~ m/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/
or $1 > 255
or $2 > 255
or $3 > 255
or $4 > 255
)
{
$errorMessage = "Bad IP address." ;
goto ERROR ;
}
$allPortData{$thePort}{'localip'} = $localIP ;
$allPortData{$thePort}{'remoteip'} = $remoteIP ;
$allPortData{$thePort}{'pppbaud'} = param('pppbaud') ;
my $flow= param('pppflow') || 'None' ;
$allPortData{$thePort}{'pppflow'} = $flow ;
$allPortData{$thePort}{'connection'} = param('connection') ;
my $string = param('resetString') ;
$allPortData{$thePort}{'reset'} = $string if (defined $string) ;
$string = param('initString1') ;
$allPortData{$thePort}{'init1'} = $string if (defined $string) ;
$string = param('initString2') ;
$allPortData{$thePort}{'init2'} = $string if (defined $string) ;
$string = param('initString3') ;
$allPortData{$thePort}{'init3'} = $string if (defined $string) ;
my $toggle = $allPortData{$thePort}{'ppptoggle'} || 1 ;
$allPortData{$thePort}{'ppptoggle'} = ( ($toggle == 1) ? 10 : 1 ) ;
savePppConfig( \%allPortData ) ;
}
else
{
if ($protocol eq "serial")
{
my $flow = 'none' ;
if ($thePort ne 'SerialPort1')
{
$flow = param('flow') || 'none' ;
$flow = 'xonxoff' if ($flow eq 'Xon/Xoff') ;
}
$allPortData{$thePort}{'flow'} = $flow ;
$allPortData{$thePort}{'parity'} = param('parity') || 'none' ;
$allPortData{$thePort}{'baud'} = param( 'baud' ) ;
}
elsif ($protocol eq 'udp')
{
my $timeout = param('UDPtimeout') ;
$timeout =~ s/ .*$// ;
$allPortData{$thePort}{'udptimeout'} = $timeout ;
}
if ( $theService eq 'rt17' )
{
$allPortData{$thePort}{'interval'}   = param('measInterval' ) ;
$allPortData{$thePort}{'measurements'}
= param('Rt17Measurements') ;
$allPortData{$thePort}{'positions'}  = param('Rt17Positions') ;
$allPortData{$thePort}{'concise'}    = param('Rt17Concise') ;
$allPortData{$thePort}{'iodeslips'}  = param('Rt17extras') ;
$allPortData{$thePort}{'gpsdata'}    = param('Rt17svinfo') ;
$allPortData{$thePort}{'rawgps'}     = param('Rt17Raw') ;
$allPortData{$thePort}{'rawwaas'}    = param('Rt17Waas') ;
$allPortData{$thePort}{'smoothcode'} = param('Rt17smoothCode') ;
$allPortData{$thePort}{'smoothcarrier'}
= param('Rt17smoothCarrier') ;
$allPortData{$thePort}{'useRt27'}
= param('Rt17useRt27') ;
}
elsif ($theService eq 'binex')
{
$allPortData{$thePort}{'interval'}  = param( 'measInterval' ) ;
$allPortData{$thePort}{'smoothing'} = param('smoothing') || 0 ;
$allPortData{$thePort}{'7f02'} = param('7f02') || 0 ;
$allPortData{$thePort}{'7f03'} = param('7f03') || 0 ;
$allPortData{$thePort}{'7f03Doppler'} = param('7f03Doppler') || 0 ;
$allPortData{$thePort}{'7f03Slips'} = param('7f03Slips') || 0 ;
$allPortData{$thePort}{'7f03RxClkOfsAlways'} =
param('Always') || 0 ;
$allPortData{$thePort}{'7f03RxClkOfsRollover'} =
param('Rollover') || 0 ;
$allPortData{$thePort}{'metaInterval'} = param('metaInterval') ;
$allPortData{$thePort}{'siteDesc'} = param('siteDesc') ;
$allPortData{$thePort}{'stationID'} = param('stationID') ;
$allPortData{$thePort}{'antNum'} = param('antNum') ;
$allPortData{$thePort}{'rcvrType'} = param('rcvrType') ;
$allPortData{$thePort}{'rcvrNumber'} = param('rcvrNumber') ;
$allPortData{$thePort}{'firmwareVersion'}
= param('firmwareVersion') ;
$allPortData{$thePort}{'antXYZ'} = param('antXYZ') ;
$allPortData{$thePort}{'antOffset'} = param('antOffset') ;
$allPortData{$thePort}{'statusInterval'} = param('statusInterval') ;
$allPortData{$thePort}{'metTilt'} = param('metTilt') ;
}
elsif ($theService eq 'nmea')
{
my $msg ;
foreach $msg (@nmeaMessages)
{
$allPortData{$thePort}{$msg}  = param( $msg ) ;
}
}
elsif ($theService eq 'svstatus')
{
}
elsif ($theService eq 'ephemerides')
{
}
elsif ($theService eq 'almanacs')
{
}
elsif ($theService eq 'trimcom')
{
for my $p ( keys %allPortData )
{
next if ($p eq $thePort) ;
next if ($p eq 'MetControls') ;
next if ($p eq 'AuthKey') ;
if ($allPortData{$p}{'service'} =~ /trimcom/i)
{
delete( $allPortData{$p} ) ;
}
}
} # Trimcom service
elsif ($theService eq 'met')
{
for my $i (1..6)
{
$allPortData{'MetControls'}{$i} = 'off' ;
my $sched = param( "Sched$i" ) ;
my $cmd = param( "Cmd$i" ) ;
$cmd =~ s/^  *// ;
$cmd =~ s/ *$// ;
if (length($cmd) != 0 && $sched ne 'Off')
{
if ($sched eq 'Once')
{
$sched = 0 ;
}
elsif ($sched =~ /minute/)
{
$sched =~ s/ .*// ;
}
elsif ($sched =~ /second/)
{
$sched =~ s/ .*// ;
$sched .= "S" ;
}
else
{
$sched =~ s/ .*// ;
$sched *= 60 ;
}
$allPortData{'MetControls'}{$i} = "$sched:$cmd" ;
}
}
saveMetConfig( \%allPortData ) ;
for my $p ( qw( SerialPort1 SerialPort2 SerialPort3 SerialPort4 ) )
{
next if ($p eq $thePort) ;
if ($allPortData{$p}{'service'} =~ /met/i)
{
$allPortData{$p}{'service'} = 'ppp' ;
}
}
} # Met service
elsif ( $theService eq 'ppp-dialout' )
{
for my $p ( qw( SerialPort1 SerialPort2 SerialPort3 SerialPort4 ) )
{
next if ($p eq $thePort) ;
if ($allPortData{$p}{'service'} =~ /ppp-dialout/i)
{
$allPortData{$p}{'service'} = 'ppp' ;
}
}
}
elsif ( $theService eq 'cmr' )
{
$allPortData{$thePort}{'cmrStyle'} = param('cmrStyle') ;
} # end of CMR
elsif ( $theService eq 'rtcm' )
{
my $version = param('rtcmVersion' ) ;
$version =~ s/^v// ;
$allPortData{$thePort}{'version'} = $version ;
my $style = lc( param('rtcmStyle') || 'dgps' ) ;
if ($style eq 'custom')
{
$style .= ':' ;
$style .= '1,' if param('Type1') ;
$style .= '2,' if param('Type2') ;
$style .= '3,' if param('Type3') ;
$style .= '9,' if param('Type9') ;
$style .= '14,' if param('Type14') ;
$style .= '18+19,' if param('Type1819') ;
$style .= '22,' if param('Type22') ;
$style .= '23+24,' if param('Type2324') ;
$style .= '59.3,' if param('Type59.3') ;
$style .= '59.13,' if param('Type59.13') ;
$style =~ s/,$// ;
}
$allPortData{$thePort}{'rtcmStyle'} = $style ;
} # end of RTCM
}
saveGpssdConfig( \%allPortData ) ;
print <<EOF;
<h2>New Port Configuration Accepted.</h2>
<Script>
parent.loadAfterDelay( "portSummary.cgi", 1000) ;
</Script>
EOF
ERROR:
if ($errorMessage)
{
print <<EOF ;
<Script>
alert( "$errorMessage" ) ;
</Script>
EOF
print h3("$errorMessage") ;
my $returnURL = '/perl-scripts/portSetup.cgi' ;
my $startC = '?' ;
for my $p (param())
{
$returnURL .= $startC ;
$returnURL .= $p.'='.CGI::escape( param($p) ) ;
$startC = '&' ;
}
print <<EOF ;
<Script>
parent.loadAfterDelay( "$returnURL", 4000 ) ;
</Script>
EOF
}
EXIT:
print end_html() ;
