#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Time::Local ;
use lib '..' ;
use Fireball ;
startPage( 'Set Session' ) ;
my $gpsTime = time() - 315964800 + 13 ;
my $theSessionName ;
my %sessData ;
getSessionData( \%sessData ) ;
if (param('submissionType') eq 'Okay')
{
my $sessname = param('sessname') ;
if ( $sessname eq 'New Session' )
{
$sessname = param('NewSessionName') ;
}
my %oldSessData ;
if (! exists( $sessData{$sessname} ) )
{
$oldSessData{'enable'} = 2 ;
}
else
{
%oldSessData = %{$sessData{$sessname}} ;
}
$sessData{$sessname}{'enable'} = param('Enabled') ? '1' : '0' ;
my $sched = param('schedMode') ;
$sched = 'cont' if ($sched eq 'continuous') ;
$sessData{$sessname}{'sched'} = $sched ;
$sessData{$sessname}{'duration'} = param('duration') ;
if ($sched eq 'daily')
{
$sessData{$sessname}{'time'} = param('hours' ) * 3600
+ param('minutes') * 60 ;
}
elsif ($sched eq 'once')
{
my %StringToMonth = ( 'Jan' => 0,
'Feb' => 1,
'Mar' => 2,
'Apr' => 3,
'May' => 4,
'Jun' => 5,
'Jul' => 6,
'Aug' => 7,
'Sep' => 8,
'Oct' => 9,
'Nov' => 10,
'Dec' => 11
) ;
$sessData{$sessname}{'time'} = timegm( 0, # Seconds
param('minutes'),
param('hours'),
param('day'),
$StringToMonth{param('month')},
param('year')
) - 315964800 ;
}
elsif ($sched eq 'cont')
{
$sessData{$sessname}{'time'} = 0 ;
}
else
{
$sessData{$sessname}{'time'} = 0 ;
}
my $dtype = param( 'Datatype' ) ;
if ( $dtype eq 'T00' )
{
$sessData{$sessname}{'ftype'} = 'T00' ;
my $measInterval = param('measInterval' ) ;
$sessData{$sessname}{'measInterval'} = $measInterval ;
my $posInterval = param('posInterval' ) ;
$sessData{$sessname}{'posInterval'} = $posInterval ;
$sessData{$sessname}{'option1'} = ( param( 'CodeSmoothing' )
? 1 : 0
) ;
$sessData{$sessname}{'option2'} = ( param( 'CarrierSmoothing' )
? 1 : 0
) ;
$sessData{$sessname}{'RT27'} = ( param( 'RT27' )
? 1 : 0
) ;
$sessData{$sessname}{'rawWaas'} = ( param( 'RawWaas' )
? 1 : 0
) ;
}
elsif ( $dtype eq 'Binex' )
{
$sessData{$sessname}{'ftype'} = 'Binex' ;
$sessData{$sessname}{'measInterval'} = param( 'measInterval' ) ;
$sessData{$sessname}{'metaInterval'} = param( 'metaInterval' ) ;
$sessData{$sessname}{'statusInterval'} = param( 'statusInterval' ) ;
$sessData{$sessname}{'metTilt'} = param( 'metTilt' ) ;
$sessData{$sessname}{'smoothing'} = param( 'smoothing' ) || 0 ;
$sessData{$sessname}{'7f02'} = param( '7f02' ) || 0 ;
$sessData{$sessname}{'7f03'} = param( '7f03' ) || 0 ;
$sessData{$sessname}{'7f03Doppler'} = param( '7f03Doppler' ) || 0 ;
$sessData{$sessname}{'7f03Slips'} = param( '7f03Slips' ) || 0 ;
$sessData{$sessname}{'7f03RxClkOfsAlways'}
= param( 'Always' ) || 0 ;
$sessData{$sessname}{'7f03RxClkOfsRollover'}
= param( 'Rollover' ) || 0 ;
$sessData{$sessname}{'siteDesc'} = param('siteDesc') || 0 ;
$sessData{$sessname}{'firmwareVersion'}
= param('firmwareVersion') || 0 ;
$sessData{$sessname}{'stationID'}
= param('stationID') || 0 ;
$sessData{$sessname}{'antXYZ'}
= param('antXYZ') || 0 ;
$sessData{$sessname}{'antNum'}
= param('antNum') || 0 ;
$sessData{$sessname}{'rcvrType'}
= param('rcvrType') || 0 ;
$sessData{$sessname}{'antOffset'}
= param('antOffset') || 0 ;
$sessData{$sessname}{'rcvrNumber'}
= param('rcvrNumber') || 0 ;
}
else
{
$sessData{$sessname}{'ftype'} = 'unknown' ;
$sessData{$sessname}{'measInterval'} = 0 ;
$sessData{$sessname}{'posInterval'} = 0 ;
$sessData{$sessname}{'option1'} = 0 ;
$sessData{$sessname}{'option2'} = 0 ;
}
$sessData{$sessname}{'sessid'} = param( 'sid' ) ;
$sessData{$sessname}{'perday'} = param( 'perDay' ) ? 1 : 0 ;
$sessData{$sessname}{'persessid'} = param( 'perSID'  ) ? 1 : 0 ;
if (  $sessData{$sessname}{'sched'} eq 'manual'
and $sessData{$sessname}{'enable'}
)
{
for my $k (keys %oldSessData)
{
if ($oldSessData{$k} ne $sessData{$sessname}{$k})
{
print h2( "Restarting manual session" ) ;
my $gpsTime = time() - 315964800 + 13 ;
$sessData{$sessname}{'time'} = $gpsTime + 10 ;
last ;
}
}
}
updateSessionData( \%sessData ) ;
print <<EOF;
<h2>Data for Session "$sessname" Accepted.</h2>
Switching to Data Logging Sessions Display.
<Script>
parent.loadAfterDelay( "/perl-scripts/sessions.cgi", 1 ) ;
</Script>
EOF
}
elsif (param('submissionType') eq 'Delete')
{
my $sessname=param('sessname') ;
delete( $sessData{$sessname} ) ;
updateSessionData( \%sessData ) ;
print <<EOF;
<h2>Session "$sessname" has been deleted</h2>
Switching to Data Logging Sessions Display.
<Script>
setTimeout( 'document.location = "/perl-scripts/sessions.cgi"',1000) ;
</Script>
EOF
}
print end_html() ;
