#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Ethernet Configuration',
'/internetEthernetInfo.html'
) ;
my %ethernetSetup ;
getEthernetSetup( \%ethernetSetup ) ;
my $EthMode = $ethernetSetup{ 'ipmode' } ;
my $gateway   = $ethernetSetup{'gateway'} ;
$gateway = $gateway || 'Not Set' ;
my @DnsServers = split( ',', $ethernetSetup{ 'nameServers' } ) ;
if (! @DnsServers)
{
@DnsServers = ('Not Set') ;
}
my $domain = $ethernetSetup{ 'dnsDomain' } || 'Not Set' ;
my $searchPath = $ethernetSetup{ 'dnsSearch' } || 'Not Set' ;
if ($EthMode eq "static")
{
print table
( {border=>0},
Tr( td( {colspan=>2},
"The Ethernet Port is using a <b>Static IP</b> setup:"
)
),
Tr(td("&nbsp;")),
Tr( th( {align=>"right"}, "IP Address:" ),
td( $ethernetSetup{'ip'} ) ),
Tr( th( {align=>"right"}, "MTU:" ),
td( $ethernetSetup{ 'mtu' } ) ),
Tr( th( {align=>"right"}, "Netmask:" ),
td( $ethernetSetup{'netmask'} ) ) ,
Tr( th( {align=>"right"}, "Gateway:" ),
td( $gateway ) ) ,
Tr( th( {align=>"right"}, "Name Servers:" ),
td( join( '<BR>', @DnsServers ) ) ),
Tr( th( {align=>"right"}, "Domain:" ),
td( join( '<BR>', $domain ) ) ),
Tr( th( {align=>"right"}, "Search Path:" ),
td( join( '<BR>', $searchPath ) ) ),
Tr(td("&nbsp;")),
Tr( th( {align=>"right"}, "MAC Address:" ),
td( $ethernetSetup{ 'mac' } ) ),
)
}
elsif ($EthMode eq "dhcp")
{
print table
( {border=>0},
Tr( td( {colspan=>2},
"The Ethernet Port is using a <b>DHCP</b> setup."
)
),
Tr(td("&nbsp;")),
Tr( td( {colspan=>2},
"Currently assigned values are:"
)
),
Tr( th( {align=>"right"}, "IP Address:" ),
td( $ethernetSetup{ 'ip' } ) ),
Tr( th( {align=>"right"}, "MTU:" ),
td( $ethernetSetup{ 'mtu' } ) ),
Tr( th( {align=>"right"}, "Netmask:" ),
td( $ethernetSetup{ 'netmask' } ) ) ,
Tr( th( {align=>"right"}, "Gateway:" ),
td( $gateway ) ) ,
Tr( th( {align=>"right"}, "Name Server:" ),
td( join( '<BR>', @DnsServers ) ) ),
Tr( th( {align=>"right"}, "Domain:" ),
td( join( '<BR>', $domain ) ) ),
Tr( th( {align=>"right"}, "Search Path:" ),
td( join( '<BR>', $searchPath ) ) ),
Tr(td("&nbsp;")),
Tr( th( {align=>"right"}, "MAC Address:" ),
td( $ethernetSetup{ 'mac' } ) ),
)
}
else
{
print "The Ethernet Port is currently <b>Disabled</b>." ;
}
print startform() ;
print button( -name=>'Modify',
-value=>'Modify',
-onClick=>'parent.loadDataFrame(
"/perl-scripts/sysadmin/ethernetSetup.cgi" )'
) ;
print endform() ;
print end_html() ;
