#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Receiver Configuration',
'' # No Help Button
) ;
my @stingerCfg = split( "\n", qx( cat /etc/sysconfig/stinger.cfg ) ) ;
print '<table border="0">' ;
my $identityString= qx|cat /etc/sysconfig/sysname| ;
my $serialNumber = qx(/usr/bin/sudo /usr/local/fireball/warranty -s) ;
chomp $serialNumber ;
$serialNumber = (split("[ :]+",$serialNumber))[1] ;
print Tr( td( {align=>'right', valign=>'top'}, b( 'Identity ' ) ),
td( $identityString
.'<br />SN'
.$serialNumber )
) ;
my $fwVersion = 'Unknown' ;
my $fwDate    = '01-Jan-2000' ;
if ( -r '/usr/local/fireball/defaults/firmwareVersion' )
{
($fwVersion, $fwDate) = split( "\n", qx( cat /usr/local/fireball/defaults/firmwareVersion ) ) ;
my ($year,$month,$day) = split( '/', $fwDate ) ;
$fwDate = "$day $monthStrings[$month-1] $year" ;
}
print Tr( td( {align=>'right'}, b( 'Firmware ' ) ),
td( "$fwVersion&nbsp;&nbsp;$fwDate" )
) ;
my %antInfo ;
getAntennaInfo( \%antInfo ) ;
my %antSetup ;
getAntennaSetup( \%antSetup ) ;
my $type = $antSetup{'type'} ;
print Tr( td( {align=>'right', valign=>'top'}, b( 'Antenna ' ) ),
td( "Type: $type = $antInfo{$type}{'name'}"
."<br />SN$antSetup{'serial'} "
.', "'.$antSetup{'textSerial'}.'"'
."<br />Height: $antSetup{'height'} meters"
."<br />Height Method: "
."$antInfo{$type}{'methods'}[$antSetup{'method'}]"
)
) ;
my $clockSteering = (grep( m/clock_steering/, @stingerCfg ))[0] ;
print Tr( td( {align=>'right'}, b( 'Clock Steering ' ) ),
td( ($clockSteering =~ /off/) ? 'Disabled' : 'Enabled' )
) ;
my $multipath = (grep( m/everest/, @stingerCfg ))[0] ;
print Tr( td( {align=>'right'}, b( 'Multipath Reduction ' ) ),
td( ($multipath =~ /off/) ? 'Disabled' : 'Enabled' )
) ;
my $l2mode = (grep( m/l2_mode/, @stingerCfg ))[0] ;
if ( ! $l2mode )
{
my $l2cs_mode = (grep( m/l2cs_mode/, @stingerCfg ))[0] ;
$l2mode = ($l2cs_mode =~ /on/)
? "l2c_or_enigma"
: "enigma" ;
}
print Tr( td( {align=>'right'}, b( 'L2 Tracking ' ) ),
td( ($l2mode =~ /off/)
? 'Off'
: ($l2mode =~ /l2c_or_enigma/)
? 'L2C or L2-Y-code'
: ($l2mode =~ /l2c_and_enigma/)
? 'L2C and L2-Y-code'
: 'L2-Y-code'
)
) ;
my $elev_mask = (grep( m/elev_mask/, @stingerCfg ))[0] ;
$elev_mask =~ s/.* // ;
print Tr( td( {align=>'right'}, b( 'Elevation Mask ' ) ),
td( $elev_mask.'&deg;' )
) ;
my $pdop_mask = (grep( m/pdop_mask/, @stingerCfg ))[0] ;
$pdop_mask =~ s/.* // ;
print Tr( td( {align=>'right'}, b( 'PDOP Mask ' ) ),
td( $pdop_mask )
) ;
my $pps = (grep( m/pps_mode/, @stingerCfg ))[0] ;
print Tr( td( {align=>'right', valign=>'top'},
b( 'Pulse Per Second Output ' )
),
td( ($pps =~ ' on ')
? 'Enabled, positive-slope timing edge.'
: 'Disabled'
)
) ;
my $extRef = qx( cat /etc/sysconfig/extRefFreq ) ;
my $extRefDetected = qx(/usr/local/fireball/extfreq -p) ;
print Tr( td( {align=>'right', valign=>'top'},
b( 'Reference Frequency ' )
),
td( ( ($extRef =~ /External/)
? 'Using External Source'
: 'Using Internal Source'
)
.br()
.( ($extRefDetected =~ /present/)
? 'External source detected'
: 'External source NOT detected'
)
)
) ;
my $masks = (grep( m/ sv_masks /, @stingerCfg ))[0] ;
my @state = split( " ", $masks ) ;
splice( @state, 0, 2 ) ;
my @disables = ();
my @ignores = ()  ;
for ( my $prn = 1 ; $prn <= 32 ; ++$prn )
{
if ( $state[$prn-1] =~ 'D' )
{
push( @disables, $prn ) ;
}
if ( $state[$prn-1] =~ 'I' )
{
push( @ignores, $prn ) ;
}
}
print Tr( td( {align=>'right', valign=>'top'}, b('GPS Satellites ') ) ,
td(
'Disabled: '
.( (@disables)
? join( ', ', @disables )
: 'None'
)
.'<br />IgnoreHealth: '
.( (@ignores)
? join( ', ', @ignores )
: 'None'
)
)
) ;
my $waasMode = (grep( m/waas_mode/, @stingerCfg ))[0] ;
print '<tr>',
td( {align=>'right', valign=>'top'}, b( 'WAAS ' ) ),
'<td>',
($waasMode =~ / on/)
? 'Enabled for Tracking and Corrections'
: 'Disabled'
;
$masks = (grep( m/waas_sv_masks/, @stingerCfg ))[0] ;
@state = split( " ", $masks) ;
splice( @state, 0, 2 ) ;
my @enables = () ;
@ignores = () ;
for ( my $prn = 120 ; $prn <= 138 ; ++$prn )
{
my $name = $waasStrings{ $prn } ;
push( @enables, $name ) if ( $state[$prn-120] eq 'E' ) ;
push( @ignores, $name ) if ( $state[$prn-120] eq 'I' ) ;
}
print br() ;
my $string = 'Enabled Satellites: ' ;
my $needComma = 0 ;
if (!@enables)
{
print $string, 'None' ;
}
else
{
for my $sv (@enables)
{
$string .= ',' if ( $needComma ) ;
$needComma = 1 ;
if (length($string) > 40)
{
print $string,br() ;
$string = '' ;
}
$string .= " $sv" ;
}
print $string if (length($string)) ;
}
if (@ignores)
{
print br() ;
$string = 'Ignore Health Satellites: ' ;
$needComma = 0 ;
for my $sv (@ignores)
{
$string .= ',' if ( $needComma ) ;
$needComma = 1 ;
if (length($string) > 40)
{
print $string,br() ;
$string = '' ;
}
$string .= " $sv" ;
}
print $string if (length($string)) ;
}
print '</td></tr>' ;
my %refStationData ;
getRefStationData( \%refStationData ) ;
print Tr( td( {align=>'right',
valign=>'top'}, b( 'Reference Station ' ) ),
td( "RTCM Station ID: $refStationData{'rtcmid'}",
"<br />Binex Station ID: $refStationData{'binexid'}",
"<br />CMR Station ID: $refStationData{'cmrid'}",
"<br />CMR Station Name: $refStationData{'cmrStationName'}",
"<br />Description: $refStationData{'rtcmdesc'}",
"<br />Position:",
table( {border=>'0', cellspacing=>'0', cellpadding=>'0'},
Tr( td( {align=>'right'}, ('Lat: ') ),
td( {align=>'right'},
sprintf(
'<code>&nbsp;%02d&deg;%02d\'%08.5f" %s</code>',
$refStationData{'latdeg'},
$refStationData{'latmin'},
$refStationData{'latsec'},
$refStationData{'latns'},
)
),
td( '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' ),
td( {align=>'right'}, ('X: ') ),
td( {align=>'right'},
sprintf( '<code>%12.3f</code> m',
$refStationData{'x'}
)
)
),
Tr( td( {align=>'right'}, ('Lon: ') ),
td( {align=>'right'},
sprintf( '<code>%03d&deg;%02d\'%08.5f" %s</code>',
$refStationData{'londeg'},
$refStationData{'lonmin'},
$refStationData{'lonsec'},
$refStationData{'lonew'},
)
),
td( '&nbsp;' ) ,
td( {align=>'right'}, ('Y: ') ),
td( {align=>'right'},
sprintf( '<code>%12.3f</code> m',
$refStationData{'y'}
)
)
),
Tr( td( {align=>'right'}, ('Height: ') ),
td( {align=>'right'},
sprintf( '<code>%.3f</code> meters',
$refStationData{'height'}
),
),
td( '&nbsp;' ) ,
td( {align=>'right'}, ('Z: ') ),
td( {align=>'right'},
sprintf( '<code>%12.3f</code> m',
$refStationData{'z'}
)
)
),
),
)
) ;
print '<tr>',
td( {align=>'right', valign=>'top'}, b( 'Data Logging ' ) ),
'<td>' ;
print 'Enabled Sessions:' ;
my %sessData ;
getSessionData( \%sessData ) ;
my $gpsTime = time() - 315964800 + 13 ;
my $count = 0 ;
print '<table border="0" cellspacing="0" cellpadding="0"' ;
for my $sess (sort keys %sessData)
{
if ($sessData{$sess}{'enable'})
{
my $type = $sessData{$sess}{'sched'} ;
my $duration = $sessData{$sess}{'duration'} ;
my $time = $sessData{$sess}{'time'} ;
my $sched ;
if ($type eq 'cont')
{
$sched = "Continuous $duration minute sessions."
}
elsif ($type eq 'manual')
{
next if ( $time + $duration*60 < $gpsTime ) ;
$sched = "Manual $duration minute session."
}
elsif ($type eq 'daily')
{
$sched = sprintf( 'Daily at %02d:%02d for %d minutes.',
int( $time / 3600 ),
int( $time % 3600 / 60 ),
$duration
) ;
}
elsif ($type eq 'once')
{
next if ( $time + $duration*60 < $gpsTime ) ;
$sched = "Once only, $duration minute session."
}
++$count ;
print Tr( td( {align=>'right'}, '&nbsp;&nbsp;&nbsp;',$sess.':' ),
td( {align=>'left'}, '&nbsp;&nbsp;&nbsp;', $sched ) ) ;
}
}
print Tr( td( ['&nbsp;&nbsp;&nbsp;','None'] ) ) if ($count == 0) ;
print '</table>' ;
my @sleepmode = split( ' ', qx( cat /etc/sysconfig/sleepmode ) ) ;
print 'Power Saving Mode: ',
( ( $sleepmode[0] eq 'yes')
? ('Enabled.'
.'<br />Failsafe Wakeup: '
.( ($sleepmode[1] eq 'no')
? 'Disabled.'
: "$sleepmode[3] minutes every $sleepmode[2] hours."
)
)
: 'Disabled.'
)
;
my %autoDeleteControls ;
getAutoDeleteControls( \%autoDeleteControls ) ;
print '<br />Reserved Space:&nbsp;&nbsp;&nbsp;&nbsp;' ;
if ( $autoDeleteControls{'Reserved'}{'enable'} )
{
print 'AutoDeleting to ',
sprintf( "%d Mbytes.",
$autoDeleteControls{'Reserved'}{'size'}
) ;
}
else
{
print 'Not AutoDeleting.' ;
}
print '<br />AutoDelete Pools:' ;
if ( scalar( keys %autoDeleteControls ) > 1 )
{
print '<table border="0" cellspacing="0" cellpadding="0"' ;
for my $pool ('a'..'z','Default')
{
if (exists $autoDeleteControls{$pool})
{
print Tr(
td( {width=>10}, '&nbsp;' ),
td( {align=>'right'},
"$pool-pool"
),
td( {width=>10}, '&nbsp;' ),
td( {align=>'right'},
sprintf( "%d Mbytes",
$autoDeleteControls{$pool}{'size'}
)
),
td( {width=>10}, '&nbsp;' ),
td( {align=>'right'},
$autoDeleteControls{$pool}{'enable'}
? 'AutoDeleting.' : 'Not AutoDeleting.'
)
) ;
}
}
print '</table>' ;
}
else
{
print '&nbsp;&nbsp;&nbsp;None Defined.' ;
}
print '</td></tr>' ;
my $macAddress = qx( /usr/local/fireball/getmac ) ;
substr( $macAddress, 10, 0 ) = ':' ;
substr( $macAddress,  8, 0 ) = ':' ;
substr( $macAddress,  6, 0 ) = ':' ;
substr( $macAddress,  4, 0 ) = ':' ;
substr( $macAddress,  2, 0 ) = ':' ;
my $EthMode =
(split( ' ',
qx| grep '^ *iface  *eth0' /etc/sysconfig/interfaces|
)
)[3] ;
my $ipAddress = '0.0.0.0' ;
my $netMask = '255.255.255.0' ;
my @results=split( ' ', qx( /sbin/ifconfig eth0 | grep 'inet addr:' ) );
if (@results)
{
$ipAddress  = (split( ':', $results[1] ))[1] ;
$netMask  = (split( ':', $results[3] ))[1] ;
}
elsif ($EthMode eq 'static')
{
$ipAddress =
(split( ' ', qx(grep address /etc/sysconfig/interfaces) ))[1] ;
$netMask  =
(split( ' ', qx(grep netmask /etc/sysconfig/interfaces) ))[1] ;
}
print Tr( td( {align=>'right', valign=>'top'}, b( 'Ethernet ' ) ),
td( table( {border=>'0', cellspacing=>'0', cellpadding=>'0'},
Tr( td( {align=>'right'}, 'MAC Address:'),
td( '&nbsp;&nbsp;&nbsp;' ),
td( $macAddress )
),
Tr( td( {align=>'right'}, 'IP Address:' ),
td( '' ),
td( "$ipAddress ($EthMode)" )
),
Tr( td( {align=>'right'}, 'Netmask:' ),
td( '' ),
td( $netMask ),
)
)
)
) ;
my %iptablesSetup ;
getIptablesSetup( \%iptablesSetup ) ;
print '<tr>' ;
print td( {align=>'right', valign=>'top'}, b( 'IP Filtering' ) ) ;
print '<td><table border=0 cellspacing=0 cellpadding=0>' ;
print Tr( td( $iptablesSetup{'enable'} ? 'Enabled' : 'Disabled' ) ) ;
if ($iptablesSetup{'rangeCount'} )
{
for (my $i = 0 ; $i < $iptablesSetup{'rangeCount'} ; ++$i )
{
print Tr( td( 'Range:'),
td( {align=>'right'}, $iptablesSetup{'rangeBases'}[$i] ),
td( '&nbsp;&nbsp;/&nbsp;&nbsp;' ),
td( {align=>'right'}, $iptablesSetup{'rangeBits'}[$i] )
) ;
}
}
print '</table></td></tr>' ;
my $shutdownVoltage = getVsleep();
print Tr( td( {align=>'right', valign=>'top'},
b( 'Shutdown Voltage ' )
),
td( sprintf( "%.2f", $shutdownVoltage ), 'Volts' )
) ;
print '</table>' ;
print end_html() ;
