#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Reference Station Setup',
'/refposInfo.html'
) ;
sub strip
{
$_[0] =~ s/^\s+// ;
$_[0] =~ s/\s+$// ;
return $_[0] ;
}
my ($latitude, $longitude, $height ) = ( 0,0,0) ;
my ($ecefX, $ecefY, $ecefZ) = (0,0,0) ;
my ($rtcmID, $cmrID, $binexID, $rtcmDesc, $cmrStationName ) ;
my $mode = 'lla' ;
my %refStationData ;
getRefStationData( \%refStationData ) ;
if (!param())
{
$latitude = $refStationData{'lat'} ;
$longitude = $refStationData{'lon'} ;
$height = $refStationData{'height'} ;
$ecefX = $refStationData{'x'} ;
$ecefY = $refStationData{'y'} ;
$ecefZ = $refStationData{'z'} ;
$rtcmID = $refStationData{'rtcmid'} ;
$cmrID = $refStationData{'cmrid'} ;
$binexID = $refStationData{'binexid'} ;
$cmrStationName = $refStationData{'cmrStationName'} ;
$rtcmDesc = $refStationData{'rtcmdesc'} ;
if (open( CONF, '/etc/sysconfig/ref_stn.config' ))
{
while( <CONF> )
{
if ( my ($tag, $value) = m/^\s*(\S*)\s*:\s*(.*)\s*$/ )
{
if ($tag eq "X" )
{
$mode = 'ecef' ;
last ;
}
}
}
close( CONF ) ;
}
param( 'Mode', $mode ) ;
}
else
{
$mode = param( 'Mode' ) ;
my ($latDeg, $latMin, $latSec, $NS ) ;
my ($lonDeg, $lonMin, $lonSec, $EW ) ;
if (param( 'X'))
{
$ecefX = strip( param( 'X' ) ) ;
$ecefY = strip( param( 'Y' ) ) ;
$ecefZ = strip( param( 'Z' ) ) ;
}
else
{
$latDeg = strip( param( 'latDeg' ) ) ;
$latMin = strip( param( 'latMin' ) ) ;
$latSec = strip( param( 'latSec' ) ) ;
$NS     = param( 'NS' ) ;
$lonDeg = strip( param( 'lonDeg' ) ) ;
$lonMin = strip( param( 'lonMin' ) ) ;
$lonSec = strip( param( 'lonSec' ) ) ;
$EW     = param( 'EW' ) ;
$height = strip( param( 'Height' ) ) ;
}
if (param('SetHere'))
{
CGI::delete( 'SetHere' ) ;
open( SYSINFO, '/usr/local/fireball/sysinfo -p pos_info |' );
(undef, undef, undef, $latitude, $longitude, $height)
= split( ' ', <SYSINFO>) ;
close( SYSINFO ) ;
($ecefX, $ecefY, $ecefZ )
= split( ' ',
qx( /usr/local/fireball/ecefConvert lla $latitude $longitude $height )
) ;
if ( $mode eq 'lla' )
{
CGI::delete( 'latDeg' ) ;
CGI::delete( 'latMin' ) ;
CGI::delete( 'latSec' ) ;
CGI::delete( 'NS' ) ;
CGI::delete( 'lonDeg' ) ;
CGI::delete( 'lonMin' ) ;
CGI::delete( 'lonSec' ) ;
CGI::delete( 'EW' ) ;
CGI::delete( 'Height' ) ;
}
else
{
CGI::delete( 'X' ) ;
CGI::delete( 'Y' ) ;
CGI::delete( 'Z' ) ;
}
} # SetHere
elsif (param('ModeChanged'))
{
CGI::delete( 'ModeChanged' ) ;
my $fixedPointPattern = '^[+-]?(\d*\.\d+|\d+\.\d*|\d+)$' ;
my $posFixedPointPattern = '^(\d*\.\d+|\d+\.\d*|\d+)$' ;
if ( $mode eq 'lla' )
{
if ( $ecefX !~ m/$fixedPointPattern/
|| $ecefY !~ m/$fixedPointPattern/
|| $ecefZ !~ m/$fixedPointPattern/
)
{
print <<EOF ;
<script>
alert( "Couldn't convert XYZ to Lat/Lon/Alt." ) ;
</script>
EOF
}
else
{
($latitude, $longitude, $height )
= split( ' ',
qx( /usr/local/fireball/ecefConvert ecef $ecefX $ecefY $ecefZ )
);
}
} # lla mode
else
{
if ( $latDeg !~ m/^\d+$/
or $latMin !~ m/^\d+$/
or $latSec !~ m/$posFixedPointPattern/
or $lonDeg !~ m/^\d+$/
or $lonMin !~ m/^\d+$/
or $lonSec !~ m/$posFixedPointPattern/
or $height !~ m/$fixedPointPattern/
or $latMin >= 60
or $latSec >= 60.0
or ($latDeg+$latMin/60.0+$latSec/3600.0) > 90.0
or $lonMin >= 60
or $lonSec >= 60.0
or ($lonDeg+$lonMin/60.0+$lonSec/3600.0) > 180.0
)
{
print <<EOF ;
<script>
alert( "Couldn't convert Lat/Lon/Alt to XYZ." ) ;
</script>
EOF
}
else
{
GETLATLON:
$latitude = $latDeg + $latMin/60 + $latSec/3600 ;
$latitude = -$latitude if ($NS eq 'S') ;
$longitude = $lonDeg + $lonMin/60 + $lonSec/3600 ;
$longitude = -$longitude if ($EW eq 'W') ;
($ecefX, $ecefY, $ecefZ )
= split( ' ',
qx( /usr/local/fireball/ecefConvert lla $latitude $longitude $height )
) ;
}
} # xyz mode
} # ModeChanged
else
{
if ( $mode eq 'lla' )
{
goto GETLATLON ;
}
else
{ # mode eq 'ecef'
}
}
}
my ($latDeg, $latMin, $latSec, $NS ) = (0,0,0,'N');
my ($lonDeg, $lonMin, $lonSec, $EW ) = (0,0,0,'E');
if ($latitude < 0.0)
{
$latitude = - $latitude ;
$NS = 'S' ;
}
$latitude += (0.000005 / 3600) ;
$latDeg   = int( $latitude ) ;
$latitude = ($latitude - $latDeg) * 60 ;
$latMin   = int( $latitude ) ;
$latSec   = ($latitude - $latMin) * 60 ;
$latSec   = int($latSec * 100000.0)/100000.0 ;
if ($longitude < 0.0)
{
$longitude = - $longitude ;
$EW = 'W' ;
}
$longitude += (0.000005 / 3600) ;
$lonDeg = int( $longitude ) ;
$longitude = ($longitude - $lonDeg) * 60 ;
$lonMin   = int( $longitude ) ;
$lonSec   = ($longitude - $lonMin) * 60 ;
$lonSec   = int($lonSec * 100000.0)/100000.0 ;
open( SYSINFO, '/usr/local/fireball/sysinfo -p pos_info |' );
my (undef, undef, undef,
$currentLat, $currentLon, $currentHeight)
= split( ' ', <SYSINFO>) ;
close( SYSINFO ) ;
my ($currentX, $currentY, $currentZ )
= split( ' ',
qx( /usr/local/fireball/ecefConvert lla $currentLat $currentLon $currentHeight )
) ;
my $deltaX = $currentX - $ecefX ;
my $deltaY = $currentY - $ecefY ;
my $deltaZ = $currentZ - $ecefZ ;
my $diff = sqrt( $deltaX * $deltaX
+ $deltaY * $deltaY
+ $deltaZ * $deltaZ
) ;
if ($diff > 100)
{
printf( '<br /><h3>Reference position is different from '
.'measured position by %.0d meters!</h3>',
$diff
) ;
}
print startform( -name=>'theForm',
-action=>'/perl-scripts/gpsadmin/setRefpos.cgi',
-onSubmit=>'return Okay()'
) ;
print '<table border=0>' ;
my @modeButtons = radio_group( -name=>'Mode',
-value=>['lla','ecef'],
-nolabels=>1,
-default=>'lla',
-onClick=>'ModeChange()',
) ;
print Tr( td( {-colspan=>'2'}, b('Position:') ) ) ;
print Tr( td( "&nbsp;" ),
td( {-colspan=>'2'},
$modeButtons[0],
" WGS-84 : Lat/Lon/Hgt&nbsp;&nbsp;&nbsp;",
$modeButtons[1], " ECEF : X/Y/Z",
)
) ;
if ($mode eq 'lla')
{
my @NSbuttons = radio_group( -name=>'NS',
-value=>['N','S'],
-default=>$NS,
) ;
print Tr( td( {-align=>'right'}, b('Lat:')),
td( textfield( 'latDeg',
$latDeg,
3,
3
),
b('&deg;'),
textfield( 'latMin',
sprintf( "%02d", $latMin ),
2,
2
),
b("'"),
textfield( 'latSec',
sprintf( "%07.5f", $latSec ),
8,
8
),
b('"'),
$NSbuttons[0],
$NSbuttons[1],
)
) ;
my @EWbuttons = radio_group( -name=>'EW',
-value=>['E','W'],
-default=>$EW,
) ;
print Tr( td( {-align=>'right'}, b('Lon:')),
td( textfield( 'lonDeg',
sprintf( "%03d", $lonDeg ),
3,
3
),
b('&deg;'),
textfield( 'lonMin',
sprintf( "%02d", $lonMin ),
2,
2
),
b("'"),
textfield( 'lonSec',
sprintf( "%07.5f", $lonSec),
8,
8
),
b('"'),
$EWbuttons[0],
$EWbuttons[1],
)
) ;
print Tr( td( {-align=>'right'}, b('Height:')),
td( textfield( 'Height',
sprintf( "%.4f", $height ),
10,
10
),
'meters',
)
) ;
print Tr( td( '&nbsp;' ),
td( button( -name=>'Here',
-onClick=>'HereClicked()'
),
'&nbsp;&nbsp;Set Lat, Lon & Height to the current location.'
),
) ;
}
else
{
print Tr( td( {-align=>'right'}, b('X:')),
td( textfield( 'X',
sprintf( "%13.4f", $ecefX ),
13,
13
),
'meters',
)
) ;
print Tr( td( {-align=>'right'}, b('Y:')),
td( textfield( 'Y',
sprintf( "%13.4f", $ecefY ),
13,
13
),
'meters',
)
) ;
print Tr( td( {-align=>'right'}, b('Z:')),
td( textfield( 'Z',
sprintf( "%13.4f", $ecefZ ),
13,
13
),
'meters',
)
) ;
print Tr( td( '&nbsp;' ),
td( button( -name=>'Here',
-onClick=>'HereClicked()'
),
'&nbsp;&nbsp;Set X, Y and  Z to the current location.'
),
) ;
}
print Tr( td( {-colspan=>'2'}, "&nbsp;")) ;
print Tr( td( {-colspan=>'2'}, b('RTCM, CMR & BINEX Parameters:') ) ) ;
print Tr( td( '&nbsp;' ) ) ;
print Tr( td( {-align=>'right'},
b('RTCM Station ID:'),
br(),
'<font size=-2>Range 0 to 1023</font>&nbsp;&nbsp;'
),
td( {-valign=>'top'},
textfield( "rtcmID", $rtcmID, 7, 4 )
),
) ;
print Tr( td( {-align=>'right'},
b('Binex Station ID:'),
br(),
'<font size=-2>Four Characters</font>&nbsp;&nbsp;'
),
td( {-valign=>'top'},
textfield( "binexID", $binexID, 7, 4 )
),
) ;
print Tr( td( {-align=>'right'},
b('CMR Station ID:'),
br(),
'<font size=-2>Range 0 to 31</font>&nbsp;&nbsp;'
),
td( {-valign=>'top'},
textfield( "cmrID", $cmrID, 7, 2 )
),
) ;
print Tr( td( {-align=>'right'},
b('CMR Station Name:'),
br(),
'<font size=-2>Eight Characters</font>&nbsp;&nbsp;'
),
td( {-valign=>'top'},
textfield( "cmrStationName", $cmrStationName, 15, 8 )
),
) ;
print Tr( td( {-align=>'right'},
b('Description:'),
br(),
'<font size=-2>Fifty Characters</font>&nbsp;&nbsp;'
),
td( {-valign=>'top'},
textfield( "rtcmDesc", $rtcmDesc, 50, 50 )
),
) ;
print '<tr><td></td><td>' ;
print button( -name=>"OK",
-value=>"OK",
-onClick=>'Okay() ;'
) ;
print "&nbsp;" ;
print button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>'parent.loadDataFrame( "portSummary.cgi" )'
) ;
print '</td></tr></table>' ;
print hidden( -name=>'SetHere',
-value=>'0'
) ;
print hidden( -name=>'ModeChanged',
-value=>'0'
) ;
print endform() ;
print <<EOF ;
<script>
/**********************************************************************/
function ModeChange()
/**********************************************************************/
/* The user has changed the Mode between LLA and ECEF modes.  We need
* to redraw the page keeping some of the parameters, but altering
* others.  This is done by submitting the page back to this original
* URL, instead of the default action-target of the form.
* Of course, if we detect no change, then the user has clicked the
* choice that was already selected, so we ignore the action.
*/
{
f = document.theForm ;
// Import the current mode from Perl.
mode = "$mode" ;
// Compare the state of the checkboxes versus the current mode.
// If there was a change, submit the form.
if ( f.Mode[0].checked && (mode != 'lla')
|| f.Mode[1].checked && (mode != 'ecef')
)
{
// Indicate that this is a mode-change request.
f.ModeChanged.value = '1' ;
parent.submitForm( f, '/perl-scripts/refpos.cgi' ) ;
}
} /* end of ModeChange() */
/**********************************************************************/
function HereClicked()
/**********************************************************************/
/* The user has changed the Mode between LLA and ECEF modes.  We need
* to redraw the page keeping some of the parameters, but altering
* others.  This is done by submitting the page back to this original
* URL, instead of the default action-target of the form.
*/
{
f = document.theForm ;
f.SetHere.value = '1' ;
parent.submitForm( f, '/perl-scripts/refpos.cgi' ) ;
} /* end of Update() */
/**********************************************************************/
function Okay()
/**********************************************************************/
/* Invoked when the OK button is pressed.
* This just submits the entire form with all parameters.
*/
{
parent.submitForm( document.theForm, '' ) ;
return false ;
} /* end of Okay() */
</script>
EOF
if ( my $errorMessage = param('msg') )
{
print b( $errorMessage ) ;
}
print end_html() ;
