#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
my $autoRebootLimit = int( getAutoRebootLimit() / 360 ) / 10 ;
titleWithHelp( 'System Reset',
'/resetInfo.html'
) ;
print start_form( -name=>'theForm',
-action=>'/perl-scripts/sysadmin/setAutoReboot.cgi'
) ;
print hidden( -name=>'autoRebootReset',
-value=>'0'
) ;
print table(
Tr( td( {align=>'right'},
button( -name=>'Restart',
-value=>'Restart',
-onClick=>'RestartButton() ;',
)
),
td( "Restart this NetRS" )
),
Tr( td( "&nbsp;" ) ) ,
Tr( td( {align=>'right'},
button( -name=>'Clear',
-value=>'Clear GPS Data',
-onClick=>'ClearButton() ;',
)
),
td( "Clear the GPS satellite Ephemeris and Almanac"
." data,<br />and restart this NetRS."
),
),
Tr( td( {colspan=>'2'}, "<hr/>" ) ) ,
Tr( td, td( b( "AutoReboot" )) ) ,
Tr( td( {align=>'right'},
checkbox( -name=>'autoRebootEnable',
-value=>'1',
-label=>'',
-checked=>($autoRebootLimit != 0),
-onClick=>'autoRebootEnableChanged()',
)
),
td( "Enable AutoReboot Timer." ),
),
Tr( { id=>'limitRow' },
td( {align=>'right'},
textfield( 'autoRebootLimit',
$autoRebootLimit,
7,
7
)
),
td( "Time Limit in Hours." ),
),
Tr( td( {align=>'right'},
button( -value=>'OK',
-onClick=>'autoRebootOkay()',
)
),
),
( ($autoRebootLimit != 0)
? Tr( { id=>'restartRow' },
td( {align=>'right'},
button( -value=>'Restart',
-onClick=>'autoRebootRestart()',
)
),
td( "Restart AutoReboot Timer." ),
)
: ''
) ,
Tr( td( {colspan=>'2'}, "<hr/>" ) ) ,
Tr( td( {align=>'right'},
button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>
'parent.loadDataFrame("/perl-scripts/rconfigDisplay.cgi")'
)
),
),
) ;
print end_form() ;
print <<EOF;
<Script>
/**********************************************************************/
function ClearButton()
/**********************************************************************/
/* Called when the Clear button is pressed.
* Asks for confirmation and then submits the request to the NetRS.
*/
{
if ( confirm( "Reseting Ephemeris & Almanac.\\n"
+"This will restart your NetRS.\\n"
+"Are you sure?" )
)
{
parent.loadDataFrame('/perl-scripts/gpsadmin/doReset.cgi?clear=1') ;
}
} /* end of ClearButton() */
/**********************************************************************/
function RestartButton()
/**********************************************************************/
/* Called when the Restart button is pressed.
* Asks for confirmation and then submits the request to the NetRS.
*/
{
if (confirm( "This will restart your NetRS.\\n"
+"Are you sure?" )
)
{
parent.loadDataFrame(
'/perl-scripts/gpsadmin/doReset.cgi?restart=1' ) ;
}
} /* end of DefaultsButton() */
/**********************************************************************/
function hideElem()
/**********************************************************************/
/* Hides one or more HTML objects as specified by a variable length
* list of parameters.
*/
{
for ( var i = 0 ; i < arguments.length ; ++i )
{
var elem = arguments[i] ;
if ( elem.style.display != "none" )
{
// make element invisible
elem.style.display = 'none' ;
// makes element have no effect on anything else on the page.
// (Otherwise stuff would move around this element)
elem.style.position = 'absolute' ;
}
}
} /* end of hideElem() */
/**********************************************************************/
function showElem(elem)
/**********************************************************************/
/* Makes visible one or more HTML objects as specified by a variable
* length list of parameters.
*/
{
for ( var i = 0 ; i < arguments.length ; ++i )
{
var elem = arguments[i] ;
if ( elem.style.display == "none" )
{
// make element visible
elem.style.display = '' ;
elem.style.position = '' ;
}
}
} /* end of showElem() */
/**********************************************************************/
function showHideElem( show )
/**********************************************************************/
/* Hides or shows one or more HTML objects.
* If parameter 'show' is true then the objects are made visible,
* otherwise they are made invisible.
* Any number of HTML objects can be specified after the show
* parameter.
*/
{
for ( var i = 1 ; i < arguments.length ; ++i )
{
var elem = arguments[i] ;
if ( show )
showElem( elem ) ;
else
hideElem( elem ) ;
}
} /* end of showHideElem() */
/**********************************************************************/
function hideElemById()
/**********************************************************************/
/* Hides one or more HTML objects as specified by a variable length
* list of parameters specifying the 'id' attribute of each element.
*/
{
for ( var i = 0 ; i < arguments.length ; ++i )
{
var elem = document.getElementById( arguments[i] ) ;
if ( ! elem )
{
//alert( "No elem with id " + arguments[i] ) ;
return ;
}
hideElem( elem ) ;
}
} /* end of hideElemById() */
/**********************************************************************/
function showElemById( id )
/**********************************************************************/
/* Makes visible one or more HTML objects as specified by a variable
* length list of parameters specifying the 'id' attribute of each
* element.
*/
{
for ( var i = 0 ; i < arguments.length ; ++i )
{
var elem = document.getElementById( arguments[i] ) ;
if ( ! elem )
{
//alert( "No elem with id " + arguments[i] ) ;
return ;
}
showElem( elem ) ;
}
} /* end of showElemById() */
/**********************************************************************/
function showHideElemById( show )
/**********************************************************************/
/* Hides or shows one or more HTML objects.
* If parameter 'show' is true then the objects are made visible,
* otherwise they are made invisible.
* Any number of HTML objects can be specified by their id attribute
* strings, after the show parameter.
*/
{
for ( var i = 1 ; i < arguments.length ; ++i )
{
if ( show )
showElemById( arguments[i] ) ;
else
hideElemById( arguments[i] ) ;
}
} /* end of showHideElemById() */
/**********************************************************************/
function autoRebootEnableChanged()
/**********************************************************************/
{
showHideElemById( document.theForm.autoRebootEnable.checked,
'limitRow',
'restartRow'
) ;
} /* end of autoRebootEnableChanged() */
// Call the autoRebootEnableChanged() function now to set the initial
// visibility of some items.
autoRebootEnableChanged() ;
/**********************************************************************/
function autoRebootOkay()
/**********************************************************************/
{
var f = document.theForm ;
// Should test here that parameters are okay, especially the
// autoRebootLimit text field.  Must be a positive integer.
var timeLimit = f.autoRebootLimit.value ;
if ( parent.badFixedPointNumber( timeLimit )
|| timeLimit < 0
)
{
alert( 'Bad Time Limit' ) ;
return ;
}
parent.submitForm( f, '' ) ;
} /* end of autoRebootOkay() */
/**********************************************************************/
function autoRebootRestart()
/**********************************************************************/
{
document.theForm.autoRebootReset.value = 1 ;
parent.submitForm( document.theForm, '' ) ;
}
</Script>
EOF
print end_html() ;
