#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use IO::Socket;
use Fireball ;
titleWithHelp( 'Receiver Status - Activity', '/activityInfo.html' ) ;
open( SYSINFO, '/usr/local/fireball/sysinfo -p tracking_status |') ;
my @svList ;
for ( my $i = 0 ; $i < 12 ; $i++ )
{
if ( ($_ = <SYSINFO>) !~ /idle/ )
{
( undef, undef, my $prn, undef, undef,
my $l1stat, my $l2stat, undef       ) = split( ' ' ) ;
if ( hex($l1stat) & 64)
{
push @svList, $prn ;
}
}
else
{
}
}
close( SYSINFO ) ;
my $indent='&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' ;
print "<b>Satellites Tracked:</b>" ;
@svList = sort( {$a <=> $b} @svList ) ;
for my $prn (@svList)
{
if ($prn >= 120 and $prn <= 138)
{
$prn = $waasStrings{ $prn } ;
}
}
$svList[0] = 'None' if (! @svList) ;
print table( Tr( td( "&nbsp;&nbsp;&nbsp;" ),
td( code( join( ' ', @svList ) ) )
)
) ;
print "<p><b>Data Logging:</b><br />";
chdir '/var/run' ;
my @sessions = glob( "gpslog.*" ) ;
if (@sessions)
{
print '<Table>' ;
for my $sess (@sessions)
{
my ( undef, undef, $sessname, undef, undef, undef, undef, undef,
$file, undef
) = split( " ", qx( cat $sess ) ) ;
$file =~ s|^/var/gps|| ;
print "<Tr><td>&nbsp;&nbsp;&nbsp;</td><td>Session</td><td>",
$sessname,
"</td><td>logging to ",
$file,
"</td></tr>"
;
}
print "</Table>" ;
}
else
{
print "${indent}No Sessions Active<br />" ;
}
print '<br /><b>Input/Output:</b><table>' ;
my @clients = getIoStatus() ;
if (@clients)
{
for my $i (0..$#clients)
{
my $status ;
my $name = $clients[$i]{'name'} ;
my $port = $clients[$i]{'port'} ;
my $protocol = $clients[$i]{'protocol'} ;
$protocol = 'TCP' if $protocol eq 'tcp' ;
$protocol = 'UDP' if $protocol eq 'udp' ;
$protocol = 'REP' if $protocol eq 'rep' ;
my $service = $clients[$i]{'service'} ;
$service = 'NMEA' if $service eq 'nmea' ;
$service = 'CMR' if $service eq 'cmr' ;
$service = 'RTCM' if $service eq 'rtcm' ;
$service = 'Rt17' if $service eq 'rt17' ;
$service = 'Binex' if $service eq 'binex' ;
my $ip = $clients[$i]{'ip'} ;
$status = "--$name $port $protocol $service $ip" ;
if ($service eq 'met')
{
$status = "Met/Tilt interface active on Serial Port $port" ;
}
elsif ($protocol eq 'serial')
{
$status = "Streaming $service over Serial Port $port" ;
}
else
{
$status = "Streaming $service to $ip over $protocol Port $port" ;
}
print Tr( td( '&nbsp;&nbsp;&nbsp;' ),
td( $status )
) ;
}
}
else
{
print Tr( td( '&nbsp;&nbsp;&nbsp;' ),
td( 'There are no currently active I/O Streams.' )
) ;
}
print '</table>' ;
my ( $primaryV, $secondaryV, $temperature ) = getVoltages() ;
print '<br /><b>Power Supply Info:</b>' ;
print table( Tr( td( '&nbsp;&nbsp;&nbsp;' ),
td( 'Primary Voltage:' ),
td( sprintf( "%.3f Volts", $primaryV ) )
),
Tr( td( '&nbsp;&nbsp;&nbsp;' ),
td( 'Secondary Voltage:' ),
td( sprintf( "%.3f Volts",  $secondaryV ) )
),
Tr( td( '&nbsp;&nbsp;&nbsp;' ),
td( 'Temperature:' ),
td( "$temperature&deg; C" )
)
) ;
print '<br /><b>Run Time:</b>' ;
open( UPTIME, "/proc/uptime" ) ;
$_ = <UPTIME> ;
close( UPTIME ) ;
my ( $uptime, undef ) = split ;
my $days = int( $uptime / 86400 ) ;
my $hours = int( $uptime / 3600 ) % 24 ;
my $minutes = int( $uptime / 60 ) % 60 ;
print br(),
$indent,
sprintf( "System has been running for "
."%d day%s %d hour%s %d minute%s",
$days,
($days != 1) ? "s" : "",
$hours,
($hours != 1) ? "s" : "",
$minutes,
($minutes != 1) ? "s" : "",
),
br() ;
if (-e "/var/run/dialout.pid")
{
print '<br /><b>PPP Dialout:</b><br />' ;
my $dialoutPid = qx( cat /var/run/dialout.pid ) ;
chomp $dialoutPid ;
my @pidFiles = glob( "/var/run/ppp*.pid" ) ;
my $device = '' ;
for my $pidFile (@pidFiles)
{
my $thisPid = qx(cat $pidFile) ;
chomp $thisPid ;
if ($dialoutPid == $thisPid)
{
$device = $pidFile ;
$device =~ s/\.pid// ;
$device =~ s|/var/run/|| ;
}
}
if ( ! $device)
{
print "${indent}Connecting.....", br() ;
}
else
{
my $ifconfig = qx( /sbin/ifconfig $device ) ;
$ifconfig =~ m/inet addr:(\S*)/ ;
print "${indent}Connected.&nbsp;&nbsp;Assigned IP address is $1" ;
}
}
print hr() ;
print timestamp() ;
my $delay = 6000 - ( (time()+2) % 5 ) * 1000 ;
print "
<script>
// Reload this page every five seconds
parent.loadAfterDelay( window.location.href, $delay) ;
</script>
" ;
print end_html() ;
