#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/ ;
use Fireball ;
titleWithHelp( 'Satellites - Broadcast Data',
'/satDataInfo.html'
) ;
my $sv = param( 'sv' ) ;
if ( (!$sv)
|| ($sv eq 'Select Satellite')
)
{
$sv = 'All' ;
}
elsif ($sv ne 'All')
{
(undef, $sv) = split( ' ', $sv ) ;
if ( $sv !~ /^\d+$/ or $sv < 1 or $sv > 32 )
{
$sv = 'All' ;
}
}
print <<EOF ;
<Script>
/**********************************************************************/
function respondToSelection()
/**********************************************************************/
/* When a choice is made via the popup menus, this function is called.
* A new URL is loaded of the states of the popups, to request the
* specified data.
*/
{
index = document.theForm.dataType.selectedIndex  ;
option = document.theForm.dataType.options[index].value  ;
if (option == 'Select Desired Data') return ;
parent.submitForm( document.theForm, '/perl-scripts/satData.cgi') ;
} /* end of respondToSelection() */
</Script>
EOF
print startform( -name=>'theForm' ) ;
my @items=('Ephemeris Data',
'Almanac Data',
'UTC Data',
'Ionospheric Model') ;
if (!param())
{
splice( @items, 0, 0, ('Select Desired Data') ) ;
}
print popup_menu( -name=>'dataType',
-values=>\@items,
-onChange=>'respondToSelection()' ) ;
my $dt=param('dataType') ;
if ( defined( $dt )
&& ( ($dt eq 'Ephemeris Data')
|| ($dt eq 'Almanac Data')
)
)
{
@items =('All') ;
for (1..32)
{
push @items, "SV $_" ;
}
print popup_menu( -name=>'sv',
-values=>\@items,
-default=>'All',
-onChange=>'respondToSelection()' ) ;
}
print br() ;
if (param())
{
my $type=param('dataType') ;
if ($type eq 'UTC Data')
{
print '<h3>UTC (Universal Coordinated Time) Data</h3><BR>' ;
print '<pre>' ;
open( SYSINFO,
"/usr/local/fireball/sysinfo -p utc_data |"
) ;
while ( ($_ = <SYSINFO>) !~ '^OK' )
{
print $_ ;
}
close( SYSINFO ) ;
print '</pre>' ;
}
elsif ($type eq 'Ionospheric Model')
{
print '<h3>Ionospheric Model Data</h3><BR>' ;
print '<pre>' ;
open( SYSINFO,
"/usr/local/fireball/sysinfo -p iono_data |"
) ;
while ( ($_ = <SYSINFO>) !~ '^OK' )
{
print $_ ;
}
close( SYSINFO ) ;
print '</pre>' ;
}
elsif ($type eq 'Ephemeris Data')
{
print '<h3>Satellite Ephemeris Data</h3><BR>' ;
if ($sv eq 'All')
{
print '<pre>' ;
for ($sv = 1 ; $sv <=32 ; ++$sv)
{
open( SYSINFO,
"/usr/local/fireball/sysinfo -p eph_data $sv |"
) ;
while ( ($_ = <SYSINFO>) !~ '^OK' )
{
print $_ ;
}
close( SYSINFO ) ;
print "\n" ;
}
print '</pre>' ;
}
elsif ($sv != 0)
{
print '<pre>' ;
open( SYSINFO,
"/usr/local/fireball/sysinfo -p eph_data $sv |"
) ;
while ( ($_ = <SYSINFO>) !~ '^OK' )
{
print $_ ;
}
close( SYSINFO ) ;
print '</pre>' ;
}
}
elsif ($type eq 'Almanac Data')
{
print '<h3>Satellite Almanac Data</h3><BR>' ;
if ($sv eq 'All')
{
print '<pre>' ;
for ($sv = 1 ; $sv <=32 ; ++$sv)
{
open( SYSINFO,
"/usr/local/fireball/sysinfo -p alm_data $sv |"
) ;
while ( ($_ = <SYSINFO>) !~ '^OK' )
{
print $_ ;
}
print "\n" ;
}
close( SYSINFO ) ;
print '</pre>' ;
}
elsif ($sv != 0)
{
print '<pre>' ;
open( SYSINFO,
"/usr/local/fireball/sysinfo -p alm_data $sv |"
) ;
while ( ($_ = <SYSINFO>) !~ '^OK' )
{
print $_ ;
}
close( SYSINFO ) ;
print '</pre>' ;
}
}
}
print endform() ;
print hr() ;
print timestamp() ;
print end_html() ;
