#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Satellites - General Information',
'/satGeneralInfo.html'
) ;
open( SYSINFO, '/usr/local/fireball/sysinfo -p tracking_status |' ) ;
my @svList ;
my $i ;
for ( $i = 0 ; $i < 12 ; $i++ )
{
if ( ($_ = <SYSINFO>) !~ /idle/ )
{
( undef, undef, my $prn, undef, undef,
my $l1stat, undef, undef ) = split( ' ' ) ;
if ( hex($l1stat) & 64)
{
push @svList, $prn ;
}
}
else
{
}
}
close( SYSINFO ) ;
$_ = qx( /usr/local/fireball/sysinfo -p gps_hlth ) ;
chomp ;
my @allHealth = split() ;
$_ = qx( /usr/local/fireball/sysinfo -p sv_masks ) ;
my @state = split( " ", $_ ) ;
splice( @state, 0, 2 ) ;
$_ = qx( /usr/local/fireball/sysinfo -p waas_mode ) ;
my $WaasEnabled = (split)[2] ;
$_ = qx( /usr/local/fireball/sysinfo -p waas_sv_masks ) ;
my @waasState = split( " ", $_ ) ;
splice( @waasState, 0, 2 ) ;
printf "<b>Tracking %d Satellites:</b>", scalar( @svList ) ;
print '<pre>' ;
@svList = sort( {$a <=> $b} @svList ) ;
for my $prn (@svList)
{
if ( $prn >= 120 and $prn <= 138 )
{
$prn = $waasStrings{ $prn } ;
}
}
if (@svList)
{
print join( ' ', @svList ) ;
}
else
{
print "None" ;
}
print '</pre>' ;
my @healthySVs ;
my @unhealthySVs ;
my @disabled ;
my @ignored ;
for ( my $i = 0 ; $i < 32 ; ++$i )
{
if ($allHealth[$i] == 0)
{
push( @healthySVs, $i+1 ) ;
}
elsif ($allHealth[$i] != -1)
{
push( @unhealthySVs, $i+1 ) ;
}
if ($state[$i] eq 'D')
{
push( @disabled, $i+1 ) ;
}
elsif ($state[$i] eq 'I')
{
push( @ignored, $i+1 ) ;
}
}
printf( '<b>Total GPS Constellation is %d satellites.</b>',
scalar(@healthySVs) + scalar(@unhealthySVs) ) ;
print p(), b('Healthy GPS Satellites:') ;
print '<pre>' ;
my $count ;
if (@healthySVs)
{
$count = 0 ;
foreach my $prn (@healthySVs)
{
printf( "%2d ", $prn ) ;
if (++$count == 10)
{
print "\n" ;
$count = 0 ;
}
}
}
else
{
print "None" ;
}
print '</pre>' ;
print p(), b( 'Unhealthy GPS Satellites' ) ;
print '<pre>' ;
if (@unhealthySVs)
{
$count = 0 ;
foreach my $prn (@unhealthySVs)
{
printf( "%2d ", $prn ) ;
if (++$count == 10)
{
print "\n" ;
$count = 0 ;
}
}
}
else
{
print "None" ;
}
print '</pre>' ;
print "<p><b>User Disabled GPS Satellites:</b></p>" ;
print '<PRE>' ;
if (@disabled)
{
$count = 0 ;
foreach my $prn (@disabled)
{
printf( "%2d ", $prn ) ;
if (++$count == 10)
{
print "\n" ;
$count = 0 ;
}
}
}
else
{
print "None" ;
}
print '</PRE>' ;
print "<p><b>User Ignore Health GPS Satellites:</b></p>" ;
print '<PRE>' ;
if (@ignored)
{
$count = 0 ;
foreach my $prn (@ignored)
{
printf( "%2d ", $prn ) ;
if (++$count == 10)
{
print "\n" ;
$count = 0 ;
}
}
}
else
{
print "None" ;
}
print '</PRE>' ;
if ( $WaasEnabled eq 'on' )
{
print '<b>User Enabled WAAS/EGNOS Satellites:</b><pre>' ;
$count = 0 ;
my $line = '' ;
for ( my $prn = 120 ; $prn <= 138 ; ++$prn )
{
if ($waasState[$prn-120] =~ m/[EI]/)
{
my $name = $waasStrings{ $prn } ;
if (length($line) > 50 )
{
print $line, ",\n" ;
$line = '' ;
}
$line .= ', ' if ($line) ;
$line .= $name ;
++$count ;
}
}
print $line, "\n" if length($line) ;
print "None" if ($count == 0) ;
}
else
{
print b('WAAS usage is disabled.') ;
}
print hr() ;
print timestamp() ;
my $delay = 6000 - ( (time()+2) % 5 ) * 1000 ;
print "
<script>
parent.loadAfterDelay( window.location.href, $delay) ;
</script>
" ;
print end_html() ;
