#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Satellites - Tracking Information',
'/satTrackingInfo.html'
) ;
my $sortby = 'prn' ;
if (param('sortby'))
{
$sortby = param('sortby') ;
}
print <<EOF ;
<style type="text/css">
<!--
a {color:blue ; text-decoration: none }
-->
</style>
EOF
open( SYSINFO, '/usr/local/fireball/sysinfo -p tracking_status |' ) ;
my $i ;
my @svData ;
for ( $i = 0 ; $i < 12 ; $i++ )
{
if ( ($_ = <SYSINFO>) !~ /idle/ )
{
push @svData, $_ ;
}
else
{
}
}
$_ = <SYSINFO> ;
close( SYSINFO ) ;
$_ = qx( /usr/local/fireball/sysinfo -p gps_hlth ) ;
my @allHealth = split() ;
$_ = qx( /usr/local/fireball/sysinfo -p waas_hlth ) ;
my @waasHealth = split( ' ', $_ ) ;
if ($sortby eq 'prn')
{
@svData = sort( { (split( ' ', $a))[2] <=> (split( ' ', $b))[2] }
@svData
) ;
}
elsif ($sortby eq 'chan')
{
@svData = sort( { (split( ' ', $a))[0] <=> (split( ' ', $b))[0] }
@svData
) ;
}
elsif ($sortby eq 'elev')
{
@svData = sort( { (split( ' ', $b))[3] <=> (split( ' ', $a))[3] }
@svData
) ;
}
elsif ($sortby eq 'azm')
{
@svData = sort( { (split( ' ', $a))[4] <=> (split( ' ', $b))[4] }
@svData
) ;
}
print '<Table width="100%" border=1 >' ;
print Tr( {align=>'center'},
th( a( {href=>'satTracking.cgi?sortby=prn'} ,'PRN') ),
th( a( {href=>'satTracking.cgi?sortby=elev'} ,'Elv') ),
th( a( {href=>'satTracking.cgi?sortby=azm'} ,'Azm') ),
th( 'L1<br />SNR' ),
th( 'L2<br />SNR' ),
th( 'IODE' ),
th( 'URA' ),
th( 'Health' ),
th( a( {href=>'satTracking.cgi?sortby=chan'} ,'Chan') ),
) ;
foreach (@svData)
{
my ($chan, undef, $prn, $elev, $azm, undef, $L2STAT,
$L1SNR, $L2SNR, $IODE, $URA, $L2CSNR) = split( ' ' ) ;
my $health ;
my $l2cs ;
my $l2 ;
if ($L2SNR ne '0.0')
{
if ($L2CSNR ne '0.0')
{
$l2 = $L2SNR . ' / ' . 'C' . $L2CSNR ;
}
else
{
$l2 = $L2SNR ;
}
}
else
{
if ($L2CSNR ne '0.0')
{
$l2 = 'C' . $L2CSNR ;
}
else
{
$l2 = '-' ;
}
}
if ($prn <=32)
{
$health = $allHealth[$prn-1] ;
if ($health == -1)
{
$health = 'unknown' ;
}
elsif ($health == 0)
{
$health = 'healthy' ;
}
}
else
{
$health = ($waasHealth[$prn-120] == 1)
? "healthy"
: "unhealthy" ;
}
if ($elev == -90)
{
$elev = $azm = "-" ;
}
if ($prn >= 120 and $prn <= 138)
{
my $name = $waasStrings{ $prn } ;
if ( $name !~ /^prn/ )
{
$name =~ s/^(WAAS|EGNOS|ESTB)-/$1<br \/>/ ;
$prn = $name ;
}
}
print Tr(
td( {-align=>"center"},
[
$prn,
$elev,
$azm,
($L1SNR != 0) ? $L1SNR : "-",
$l2,
($IODE != -1) ? $IODE : "-",
($URA != -1) ? $URA : "-",
$health,
$chan+1,
]
)
) ;
}
print "</Table><br />" ;
my $unusedChannels = 12 - scalar( @svData ) ;
if ($unusedChannels == 0)
{
print "There are no unused channels." ;
}
elsif ($unusedChannels == 1)
{
print 'There is one unused channel.' ;
}
else
{
print "There are $unusedChannels unused channels." ;
}
print hr() ;
print timestamp() ;
my $delay = 6000 - ( (time()+2) % 5 ) * 1000 ;
print <<EOF ;
<script>
parent.loadAfterDelay( window.location.href, $delay) ;
</script>
EOF
print end_html() ;
