#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Data Logging Status',
'/sessionsInfo.html'
) ;
my $gpsTime = time() - 315964800 + 13 ;
my %sessData ;
getSessionData( \%sessData ) ;
my @ActiveSessions = () ;
for my $f (glob '/var/run/gpslog.*')
{
if ( open( LOG,  $f ) )
{
my $line = <LOG> ;
if ($line)
{
push @ActiveSessions, $line ;
}
close LOG ;
}
}
print startform() ;
print '<div align="center">' ;
print <<END ;
<style>
<!--
td.tight {padding-left: 5px;  padding-right: 5px }
th.tight {padding-left: 5px;  padding-right: 5px ; font-size:smaller}
-->
</style>
END
print '<p><Table border>' ;
print Tr( th( {class=>"tight"}, 'Session<br />Name' ),
th( {class=>"tight"}, 'Schedule' ),
th( {class=>"tight"},
'Duration<br /><font size="-2">[minutes]</font>'
),
th( {class=>"tight"}, 'Status' ),
th( {class=>"tight"}, 'Enable' )
) ;
foreach my $sessname (sort keys( %sessData))
{
my $enable = $sessData{$sessname}{'enable'} ;
my $sched = $sessData{$sessname}{'sched'} ;
my $time = $sessData{$sessname}{'time'} ;
my $duration = $sessData{$sessname}{'duration'} ;
print "<tr align='center'>" ;
my $link= "javascript:parent.loadDataFrame('editSession.cgi?restart="
.CGI::escape($sessname)
."')" ;
print td( {class=>"tight"}, a( {href=>$link}, $sessname) ) ;
if ($sched eq "manual")
{
print td( {class=>"tight"}, 'Manual' ) ;
}
elsif ($sched eq "cont")
{
print td( {class=>"tight"}, "Continuous" ) ;
}
elsif ($sched eq "daily")
{
print td( {class=>"tight"},
sprintf( "Daily at %02d:%02d",
int( $time / 3600 ) ,
int( $time % 3600 / 60 )
)
) ;
}
else
{
my (undef,$min,$hour,$day,$month,$year,undef)
= gmtime( $time + 315964800 ) ;
$month = $monthStrings[$month] ;
print td( {class=>"tight"},
sprintf( '%04d/%3s/%02d@%02d:%02d',
$year+1900, $month, $day, $hour, $min
)
) ;
}
print td( $duration ) ;
my $status = "" ;
for my $s (@ActiveSessions)
{
my (undef, undef, $name, undef, undef, undef,
undef, undef, $fpath) = split( ' ', $s ) ;
if ($sessname eq $name)
{
my ($dir, $fname) = ($fpath =~ m|^/var/gps(/.*/)(.*)| ) ;
$status .= '<br />' if ($status) ;
$status .= "<font size=-1>logging to $dir</font><br />$fname" ;
}
}
if ( ! $status )
{
if ( $sched eq 'cont'
or $sched eq 'daily'
)
{
$status = $enable ? 'Pending' : 'Disabled' ;
}
elsif ( $sched eq 'once' )
{
$status = (! $enable)
? 'Disabled'
: ( $gpsTime >= ($time + $duration*60) )
? 'Completed'
: 'Pending' ;
}
else
{
$status = ( $gpsTime >= ($time + $duration*60) )
? 'Completed'
: ($enable)
? 'Pending'
: 'Disabled' ;
}
}
print td( {class=>"tight"}, $status ) ;
if ( ($sched eq 'manual')
&& ($status =~ /Completed/)
)
{
$enable = '0' ;
}
my $target= 'sessionEnableDisable( "'
. $sessname
. '", "'
. ($enable ? 'disable")' : 'enable")')
;
print td( {class=>"tight"},
checkbox( -name=>'Enabled',
-checked=>$enable,
-value=>'1',
-label=>'',
-onClick=> $target
)
) ;
print "</tr>" ;
}
print '</Table>' ;
print endform() ;
print <<EOF ;
<script>
function sessionEnableDisable( sessname, state )
{
url = '/perl-scripts/gpsadmin/startSessions.cgi?'
+ state
+ '='
+ escape(sessname) ;
parent.loadDataFrame( url ) ;
}
</script>
EOF
if (! scalar( keys(%sessData) ) )
{
print '<p><b>No sessions are currently defined.</b><p>' ;
}
print br() ;
if ( open( SLEEP, '/etc/sysconfig/sleepmode' ) )
{
my $line=<SLEEP> ;
close SLEEP ;
chomp $line ;
my ($Enable,$Periodic,$Hours,$Minutes) = split( ' ', $line ) ;
print a( {href=>"javascript:parent.loadDataFrame('sleepMode.cgi')"},
'Power Saving Mode'
) ;
if ($Enable eq 'yes')
{
print  ' is Enabled.<br />' ;
if ($Periodic eq 'yes')
{
print "Periodic wakeup set to $Minutes minutes every $Hours ",
$Hours > 1 ? "hours." : "hour." ;
}
else
{
print 'Periodic wakeup is disabled.' ;
}
}
else
{
print ' is Disabled.' ;
}
}
print br(),br() ;
my($usedSpace, $availSpace) = ( split " ", qx( df /var/gps ) )[9..10] ;
my ($journalSize) = qx( sudo /usr/local/fireball/ext3JournalSize ) ;
$usedSpace -= $journalSize ;
my $emphasisStart = '' ;
my $emphasisEnd = '' ;
if ($availSpace < 1024)
{
$emphasisStart = '<b><font color="red">' ;
$emphasisEnd = '</font></b>' ;
}
if ($availSpace < 1024)
{
$emphasisStart .= "<blink>" ;
$emphasisEnd = "</blink>".$emphasisEnd ;
}
print "<table border=0>" ;
printf Tr( td( {align=>'right'}, "Logging Space:" ),
td( {class=>'tight', colspan=>5},
sprintf( "%.3f Mbytes Used.&nbsp;&nbsp;&nbsp;"
."%s%.3f Mbytes Available%s",
$usedSpace/1024,
$emphasisStart,
$availSpace/1024,
$emphasisEnd
)
),
)
;
my $link = "javascript:parent.loadDataFrame('autoDelete.cgi')" ;
my %autoDeleteControls ;
getAutoDeleteControls( \%autoDeleteControls ) ;
my $size = $autoDeleteControls{'Reserved'}{'size'} ;
print Tr(
td( {align=>'right'}, a( {href=>$link},'Reserved Space:') ),
td( {class=>'tight', colspan=>5},
$autoDeleteControls{'Reserved'}{'enable'}
?  "AutoDeleting at "
. "$size Mbyte"
. ($size==1 ? '.' : 's.')
: '<b>Not</b> AutoDeleting.'
)
) ;
my %poolStatus ;
getPoolStatus( \%poolStatus ) ;
if ( keys %poolStatus )
{
for my $pool ('a'..'z','Default')
{
if (exists( $poolStatus{$pool} ) )
{
my $ad = $poolStatus{$pool}{'ad'} eq 'yes' ;
my $size = $poolStatus{$pool}{'size'}/1000000 ;
my $maxSize = $poolStatus{$pool}{'maxsize'}/1000000 ;
my $full = ( ( ! $ad ) && ($size >= $maxSize) ) ;
print Tr(
td( {align=>'right'}, a( {href=>$link},"$pool-pool:") ),
td( {class=>'tight', align=>'right'},
"$poolStatus{$pool}{'files'} files"
),
td( {align=>'right'},
sprintf( "%.1f Mb /", $size )
),
td( {align=>'right'},
sprintf( "%.0f Mb", $maxSize )
),
td( {class=>'tight', align=>'right'},
($ad ? '' : 'Not ') . "AutoDeleting"
),
td( $full
? '<font color="red"><blink> FULL</blink></font>'
: '&nbsp;'
)
) ;
}
}
}
else
{
print Tr( td( {colspan=>4, align=>'center'},
"No data logging pools defined."
)
) ;
}
print "</table>" ;
my $firstSessName = (sort keys %sessData)[0] ;
$firstSessName = "New Session" if (! $firstSessName) ;
$firstSessName = CGI::escape( $firstSessName ) ;
$link= "javascript:parent.loadDataFrame('editSession.cgi?restart="
.$firstSessName
."')" ;
print br(),
table( {border=>2,align=>'center',cellpadding=>5},
Tr(
td( {align=>'center', width=>"50%" },
a( {href=>
"javascript:parent.loadDataFrame('editSession.cgi')"
} ,
"Create a New<br />Session"
)
),
td( {align=>'center', width=>"50%"},
a( {href=>
$link
},
"Edit<br />Sessions"
)
),
)
) ;
print '<p>',timestamp() ;
print '</div>' ;
print <<EOF ;
<script>
// Reload this page every ten seconds
parent.loadAfterDelay( window.location.href, 10000) ;
</script>
EOF
print end_html() ;
