#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Data Logging Power Saving Mode',
'/powerSavingInfo.html'
) ;
my ($Enable,$Periodic,$Hours,$Minutes) ;
if ( open( SLEEP, '/etc/sysconfig/sleepmode' ) )
{
my $line=<SLEEP> ;
close SLEEP ;
chomp $line ;
($Enable,$Periodic,$Hours,$Minutes) = split( ' ', $line ) ;
}
else
{
($Enable,$Periodic,$Hours,$Minutes) = ('no','yes',3, 5 ) ;
}
print start_form( -name=>'theForm',
-action=>'/perl-scripts/gpsadmin/setSleepMode.cgi',
-onSubmit=>'return Okay()'
) ;
print hr() ;
print b('Power Down Between Sessions Mode'), br(), br() ;
print 'Shut down receiver between data logging sessions?' ;
my @buttons = radio_group( -name=>'Enable',
-value=>['yes','no'],
-nolabels=>1,
-default=>$Enable,
) ;
print table(
Tr( td( $buttons[0] ),
td( 'Yes, conserve power between sessions.',
'<br />Note that communications will be impossible
while power is off.'
)
),
Tr( td( $buttons[1] ),
td( 'No.  Keep power on between sessions.' )
),
) ;
print hr() ;
print b('Failsafe Wakeup Alarm'), br(), br() ;
print 'Wake up periodically?', br() ;
@buttons = radio_group( -name=>'Periodic',
-value=>['yes','no'],
-nolabels=>1,
-default=>$Periodic,
) ;
print table(
Tr( td( $buttons[0] ),
td( 'Yes, for ',
scrolling_list( -name=>'Minutes',
-values=>['5','10','15','30','60'],
-size=>1,
-default=>$Minutes,
),
'minutes, every',
scrolling_list( -name=>'Hours',
-values=>['1','2','3','4',
'6','8','12','24'],
-size=>1,
-default=>$Hours,
),
'hours, starting at 00:00 UTC.',
)
),
Tr( td( $buttons[1] ),
td( 'No.' )
),
) ;
print <<EOF ;
<b><font color="red">WARNING:</font></b>
Turning off the Failsafe Wakeup Alarm could result in loss of
communications with a remote receiver.
<p>
Periodic wakeups are always aligned to 00:00/24:00 hours UTC.
<br />For example, setting the period to 10 minutes every 8 hours would
force the system to be awake three times every day, from 00:00 to 00:10,
and from 08:00 to 08:10, and from 16:00 to 16:10 (all times in UTC).
EOF
print <<EOF;
<Script>
/**********************************************************************/
function Okay()
/**********************************************************************/
/* Called when the OK button is pressed.
* Submits the contents of the form to the web server.
* If the failsafe wakeup alarm is disabled and Power Saving mode is
* Enabled, posts a warning to the user asking for confirmation.
*/
{
f = document.theForm ;
if ( f.Periodic[0].checked // Failsafe is on
|| f.Enable[1].checked   // Power Saving is off
|| confirm( 'The Failsafe Wakeup Alarm is being disabled.\\n'
+ 'This can result in loss of communications to remote systems!\\n'
+ 'Are you sure you want to do this?')
)
{
parent.submitForm( f, '' ) ;
}
return false ;
} /* end of Okay() */
</Script>
EOF
print hr() ;
print button( -name=>'OK',
-value=>'OK',
-onClick=>'Okay()'
) ;
print button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>'parent.loadDataFrame( "sessions.cgi" )'
) ;
print end_form() ;
print end_html() ;
