########################################################################
package Commands ;
require Exporter ;
use strict ;
use IO::Socket;
use lib '..' ;
use Fireball ;
use Time::Local ;
our @ISA = qw( Exporter ) ;
our @EXPORT = qw( badParmCount
plainTextHeader
ShowPps
SetPps
ShowElevationMask
SetElevationMask
ShowClockSteering
SetClockSteering
ShowMultipathReject
SetMultipathReject
ShowPdopMask
SetPdopMask
ShowSerialNumber
ShowSystemName
SetSystemName
ShowTemperature
ShowVoltage
ShowFirmwareVersion
ShowFirmwareWarranty
ShowFirmwareFiles
ShowFirmwareFile
UploadFirmwareFile
VerifyFirmwareFile
InstallFirmwareFile
DeleteFirmwareFile
ShowPowerSaveMode
SetPowerSaveMode
ShowFailsafeWakeup
SetFailsafeWakeup
ShowGpsHealth
ShowGpsSatControls
SetGpsSatControls
ShowTrackingStatus
ShowWaasSatControls
SetWaasSatControls
ShowWaasTracking
SetWaasTracking
ShowReferenceFrequency
SetReferenceFrequency
ShowLoggedFiles
ShowLoggedFile
DeleteLoggedFiles
DeleteLoggedFile
CreateConfigFile
DeleteConfigFile
UploadConfigFile
ShowConfigFile
ShowConfigFiles
InstallConfigFile
ResetSystem
ResetGpsData
ShowFtpSetup
SetFtpSetup
ShowGuiSecurity
SetGuiSecurity
ShowGuiAccount
ShowGuiAccounts
SetGuiAccount
DeleteGuiAccount
ShowAntennaTypes
ShowAntenna
SetAntenna
ShowEthernet
SetEthernet
EnableSession
DisableSession
ShowSession
ShowSessions
SetSession
DeleteSession
ShowIOport
DeleteIOport
SetIOport
ShowIOports
ShowUtcTime
ShowGpsTime
ShowLoggedFileStats
ShowLoggedFilePools
SetFirmwareWarranty
ShowPosition
ShowLoggingStatus
DownloadLoggedFile
ShowGpsEphemeris
ShowGpsAlmanac
ShowGpsUtcData
ShowGpsIonoData
ShowRefStation
SetRefStation
ShowNtpClient
SetNtpClient
ShowIoStatus
ShowL2Tracking
SetL2Tracking
ShowL2C
SetL2C
ShowAutodelete
SetAutodelete
ShowClientAuthKey
SetClientAuthKey
ShowIpFiltering
SetIpFiltering
ShowHttpPorts
SetHttpPorts
ShowPortAdvertising
SetPortAdvertising
ShowPppDialout
SetPppDialout
ShowTop
ShowPs
ShowAutoReboot
SetAutoReboot
) ;
use CGI qw/:standard/ ;
sub plainTextHeader
{
print CGI::header( -type=>'text/plain',
-expires=>'+0s',
-status=>'200 Okay',
) ;
}
sub badParmCount
{
if ($_[0] < $_[1])
{
print "ERROR: Too Few Parameters.\n" ;
return 1 ;
}
elsif ($_[0] > $_[2])
{
print "ERROR: Too Many Parameters\n" ;
return 1 ;
}
return 0 ;
}
sub ShowFailsafeWakeup
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my ($Enable,$Periodic,$Hours,$Minutes) ;
if ( open( SLEEP, '/etc/sysconfig/sleepmode' ) )
{
my $line=<SLEEP> ;
close SLEEP ;
chomp $line ;
($Enable,$Periodic,$Hours,$Minutes) = split( ' ', $line ) ;
}
print "FailsafeWakeup enable=$Periodic "
. "interval=$Hours duration=$Minutes\n" ;
}
sub SetFailsafeWakeup
{
return if ( badParmCount( scalar( @_ ), 3, 3 ) ) ;
my %parms ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter $p\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
$parms{$id} = $value ;
}
my $newEnable = $parms{'enable'} ;
my $newInterval = $parms{'interval'} ;
my $newDuration = $parms{'duration'} ;
if ( !$newEnable
|| !$newInterval
|| !$newDuration
|| $newEnable !~ /^(yes|no)$/
|| $newInterval !~ /^\d+$/
|| $newDuration !~ /^\d+$/
|| $newInterval > 24
|| $newDuration > 60
)
{
print "ERROR: Invalid parameters\n" ;
return ;
}
my ($PSenable,$FSenable,$hours,$minutes) = ('no','yes',3, 5 ) ;
if ( open( SLEEP, '/etc/sysconfig/sleepmode' ) )
{
my $line=<SLEEP> ;
close SLEEP ;
chomp $line ;
($PSenable,$FSenable,$hours,$minutes) = split( ' ', $line ) ;
}
open( SLEEP, '>/tmp/sleepmode' ) ;
print SLEEP join( ' ',
$PSenable,
$newEnable,
$newInterval,
$newDuration,
),
"\n" ;
close SLEEP ;
system( 'sudo cp /tmp/sleepmode /etc/sysconfig' ) ;
print "OK: " ;
ShowFailsafeWakeup() ;
}
sub ShowPowerSaveMode
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my ($Enable,$Periodic,$Hours,$Minutes) ;
if ( open( SLEEP, '/etc/sysconfig/sleepmode' ) )
{
my $line=<SLEEP> ;
close SLEEP ;
chomp $line ;
($Enable,$Periodic,$Hours,$Minutes) = split( ' ', $line ) ;
}
print "PowerSaveMode enable=$Enable\n" ;
}
sub SetPowerSaveMode
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $newstate = lc( $_[0] ) ;
$newstate =~ s/^enable=// ;
if ($newstate !~ m/^(yes|no)$/)
{
print "ERROR: Invalid parameter $_[0]\n" ;
return ;
}
my ($enable,$periodic,$hours,$minutes) = ('no','yes',3, 5 ) ;
if ( open( SLEEP, '/etc/sysconfig/sleepmode' ) )
{
my $line=<SLEEP> ;
close SLEEP ;
chomp $line ;
($enable,$periodic,$hours,$minutes) = split( ' ', $line ) ;
}
$enable = $newstate ;
open( SLEEP, '>/tmp/sleepmode' ) ;
print SLEEP join( ' ',
$enable,
$periodic,
$hours,
$minutes,
),
"\n" ;
close SLEEP ;
system( 'sudo cp /tmp/sleepmode /etc/sysconfig' ) ;
print "OK: " ;
ShowPowerSaveMode() ;
}
sub ShowPps
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my (undef, undef, $pps_enable, $pps_slope)
= split( " ",
qx(  /usr/bin/sudo /usr/local/fireball/sysinfo -p pps_mode )
) ;
print "PPS enable=",
$pps_enable eq 'on' ? 'yes' : 'no',
" slope=",
($pps_slope eq 'pos' ? 'positive' : 'negative' ),
"\n" ;
}
sub SetPps
{
return if ( badParmCount( scalar( @_ ), 1, 2 ) ) ;
my $newstate = '' ;
foreach my $p (@_)
{
$p = lc($p) ;
if ($p =~ m/^enable=(yes|no)$/ )
{
$p =~ s/^enable=// ;
$newstate = $p ;
}
elsif ($p eq 'slope=positive' )
{
}
else
{
print "ERROR: Bad Parameter: $p\n"  ;
return ;
}
}
if (!$newstate)
{
print "ERROR: Missing 'enable=' Parameter\n"  ;
return ;
}
newStingerConfig( 'put pps_mode '
. (($newstate eq 'yes') ? 'on' : 'off')
." pos\n"
) ;
print "OK: " ;
ShowPps() ;
}
sub ShowElevationMask
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
(undef, undef, my $elevMask, undef)
= split( ' ',
qx( /usr/bin/sudo /usr/local/fireball/sysinfo -p elev_mask)
);
print "ElevationMask mask=", $elevMask, "\n" ;
}
sub SetElevationMask
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $newmask = lc( $_[0] ) ;
$newmask =~ s/^mask=// ;
if ($newmask !~ m/^-?\d+$/)
{
print "ERROR: Invalid parameter $_[0]\n" ;
return ;
}
if ($newmask > 90 || $newmask < -10)
{
print "ERROR: Parameter Out of Range: $newmask\n"  ;
return ;
}
newStingerConfig( "put elev_mask $newmask\n" ) ;
print "OK: " ;
ShowElevationMask() ;
}
sub ShowClockSteering
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
$_ = qx( /usr/local/fireball/sysinfo -p clock_steering ) ;
chomp ;
my (undef, undef, $CSstate) = split( " ", $_ ) ;
print "ClockSteering enable=",
( ($CSstate eq 'on') ? "yes\n" : "no\n" ) ;
}
sub SetClockSteering
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $newstate = lc( $_[0] ) ;
$newstate =~ s/^enable=// ;
if ($newstate !~ m/^(yes|no)$/)
{
print "ERROR: Invalid parameter $_[0]\n" ;
return ;
}
newStingerConfig( 'put clock_steering '
.( ($newstate eq 'yes') ? "on\n" : "off\n")
) ;
print "OK: " ;
ShowClockSteering() ;
}
sub ShowMultipathReject
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
$_ = qx( /usr/local/fireball/sysinfo -p everest ) ;
chomp ;
my (undef, undef, $MPstate) = split( " ", $_ ) ;
print "MultipathReject enable=",
( ($MPstate eq 'on') ? "yes\n" : "no\n" ) ;
}
sub SetMultipathReject
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $newstate = lc( $_[0] ) ;
$newstate =~ s/^enable=// ;
if ($newstate !~ m/^(yes|no)$/)
{
print "ERROR: Invalid parameter $_[0]\n" ;
return ;
}
newStingerConfig( 'put everest '
.( ($newstate eq 'yes') ? "on\n" : "off\n")
) ;
print "OK: " ;
ShowMultipathReject() ;
}
sub ShowPdopMask
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
(undef, undef, my $pdopMask, undef)
= split( ' ',
qx( /usr/bin/sudo /usr/local/fireball/sysinfo -p pdop_mask)
);
print "PdopMask mask=", $pdopMask, "\n" ;
}
sub SetPdopMask
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $newmask = lc( $_[0] ) ;
$newmask =~ s/^mask=// ;
if ($newmask !~ m/^\d+$/)
{
print "ERROR: Invalid parameter $_[0]\n" ;
return ;
}
if ($newmask > 99)
{
print "ERROR: Parameter Out of Range: $newmask\n"  ;
return
}
newStingerConfig( "put pdop_mask $newmask\n" ) ;
print "OK: " ;
ShowPdopMask() ;
}
sub ShowSerialNumber
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my $serialNumber = qx(/usr/bin/sudo /usr/local/fireball/warranty -s) ;
chomp $serialNumber ;
$serialNumber = (split("[ :]+",$serialNumber))[1] ;
print "SerialNumber sn=$serialNumber\n" ;
}
sub ShowSystemName
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my $identityString= qx|cat /etc/sysconfig/sysname| ;
chomp $identityString ;
print "SystemName name=$identityString\n" ;
}
sub SetSystemName
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $name = $_[0] ;
if ( $name =~ /=/
&& $name !~ /^name=/
)
{
print "ERROR: Illegal parameter $name\n" ;
return ;
}
$name =~ s/^name=//i ;
if ( $name =~ /[^\w\-]/ )
{
print "ERROR: Invalid Characters in System Name!\n" ;
return ;
}
open SYSNAME, '>/tmp/sysname' ;
print SYSNAME "$name\n" ;
close SYSNAME ;
system( 'sudo cp /tmp/sysname /etc/sysconfig/sysname' ) ;
system( "sudo /bin/hostname $name" ) ;
print "OK: " ;
ShowSystemName() ;
}
sub ShowTemperature
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my ( $primaryV, $secondaryV, $temperature ) = getVoltages() ;
print "Temperature temp=$temperature\n" ;
}
sub ShowVoltage
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $input = lc( $_[0] ) ;
$input =~ s/^input=// ;
if ($input !~ m/^\d+$/
|| ($input != 1 && $input != 2)
)
{
print "ERROR: Invalid parameter $_[0]\n" ;
return ;
}
my ( $primaryV, $secondaryV, $temperature ) = getVoltages() ;
printf "Voltage input=$input volts=%.2f\n",
($input == 1)
? $primaryV
: $secondaryV ;
}
sub ShowFirmwareVersion
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my $fwVersion = 'Unknown' ;
my $fwDate    = '01-Jan-2000' ;
if ( -r '/usr/local/fireball/defaults/firmwareVersion' )
{
($fwVersion, $fwDate) =
split( "\n",
qx( cat /usr/local/fireball/defaults/firmwareVersion )
) ;
my ($year,$month,$day) = split( '/', $fwDate ) ;
$fwDate = sprintf( "%04d/%02d/%02d", $year, $month, $day ) ;
}
print "FirmwareVersion version=$fwVersion date=$fwDate\n" ;
}
sub ShowFirmwareWarranty
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my $warrantyDate = qx(/usr/bin/sudo /usr/local/fireball/warranty -w) ;
chomp $warrantyDate ;
$warrantyDate = (split("[ :]+",$warrantyDate))[2] ;
if ($warrantyDate != 0)
{
my ($month,$day,$year) = ($warrantyDate =~ /(..)(..)(....)/) ;
$warrantyDate = sprintf( "%04d/%02d/%02d", $year, $month, $day ) ;
}
else
{
$warrantyDate = "none" ;
}
print "FirmwareWarranty date=$warrantyDate\n" ;
}
sub ShowFirmwareFiles
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my @files = sort( glob( '/var/gps/incoming/*' ) ) ;
my $count = scalar( @files ) ;
print "<Show FirmwareFiles>\n" ;
my $maxStringLength = 0 ;
for my $f (@files)
{
my $name = $f ;
$name =~ s|^.*/|| ;
if (length( $name ) > $maxStringLength)
{
$maxStringLength = length( $name )
}
}
for my $f (@files)
{
my $size = -s $f ;
$f =~ s|^.*/|| ;
printf( "%-${maxStringLength}s  %8d bytes\n", $f, $size ) ;
}
print "<end of Show FirmwareFiles>\n" ;
}
sub ShowFirmwareFile
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $filename = $_[0] ;
$filename =~ s/^name=//i ;
chdir '/var/gps/incoming' ;
if ( ! -r $filename )
{
print "ERROR: can't read $filename\n" ;
return ;
}
my @c ;
if (open( RPMFILE, "$filename" ) )
{
$c[0] = ord( getc( RPMFILE ) ) ;
$c[1] = ord( getc( RPMFILE ) ) ;
$c[2] = ord( getc( RPMFILE ) ) ;
$c[3] = ord( getc( RPMFILE ) ) ;
close( RPMFILE ) ;
}
if ( $c[0] != 0xed
|| $c[1] != 0xab
|| $c[2] != 0xee
|| $c[3] != 0xdb
)
{
print  "ERROR: File '$filename' does not appear to be an RPM file "
."so it cannot be installed.\n"
;
return ;
}
print "<Show FirmwareFile name=$filename>\n" ;
my $description =
qx( /usr/lib/rpm/rpmq -q -p $filename --qf '%{DESCRIPTION}') ;
my $firmwareDate = ($description =~ m/.*Firmware Date\s+(\S+)/ )[0] ;
if (! $firmwareDate)
{
print "ERROR: There is no firmware date in this file "
."so it cannot be installed.\n" ;
return ;
}
my ($year,$month,$day) = ($firmwareDate =~ m|(.+)/(.+)/(.+)| ) ;
$firmwareDate = sprintf( "%04d/%02d/%02d", $year,$month,$day ) ;
my $warrantyDate = qx(/usr/bin/sudo /usr/local/fireball/warranty -w) ;
$warrantyDate = (split("[ :]+",$warrantyDate))[2] ;
if ($warrantyDate != 0)
{
($month,$day,$year) = ($warrantyDate =~ /(..)(..)(....)/) ;
$warrantyDate = sprintf( "%04d/%02d/%02d", $year,$month,$day ) ;
}
else
{
$warrantyDate = '2000/01/01' ;
}
if ( $warrantyDate ge $firmwareDate
|| $description =~ m/Expected Installation Time.*:.*\./
)
{
print "This file is installable under the terms of "
."your warranty.\n" ;
}
else
{
print 'This file is dated after your Warranty Expiration '
."date and cannot be installed.\n" ;
}
print "Details:\n" ;
print qx( /usr/lib/rpm/rpmq -q -p $filename --qf '\
Name        : %{NAME}
Summary     : %{SUMMARY}
Version     : %{VERSION}-%{RELEASE}
Build Date  : %{BUILDTIME:date}
License     : %{LICENSE}
'
) ;
printf( "Size        : %d bytes\n\n", -s $filename ) ;
print $description, "\n" ;
print "<end of Show FirmwareFile name=$filename>\n" ;
}
sub ShowConfigFiles
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
print "<Show ConfigFiles>\n" ;
chdir '/etc/sysconfig/configFiles' ;
my @allfiles = glob '*' ;
my $maxLength = 0 ;
for my $f (@allfiles)
{
my $length = length( $f ) ;
$maxLength = $length if ($length > $maxLength ) ;
}
for my $f (@allfiles)
{
printf "ConfigFile name=%-${maxLength}s size=%d\n", $f, (-s $f) ;
}
print "<end of Show ConfigFiles>\n" ;
}
sub ShowConfigFile
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $fname = $_[0] ;
$fname =~ s/^name=//i ;
chdir '/etc/sysconfig/configFiles' ;
if ( ! -f $fname )
{
print "ERROR: Can't find config file $fname\n" ;
return ;
}
print "<Show ConfigFile name=$fname>\n" ;
open FILE, $fname ;
print <FILE> ;
close FILE ;
print "<end of Show ConfigFile name=$fname>\n" ;
}
sub CreateConfigFile
{
return if ( badParmCount( scalar( @_ ), 2, 2 ) ) ;
my $fname = '' ;
my @functions = () ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter $p\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
$id = lc($id) ;
if ( $id eq 'name'
and $value !~ /[^\w\.]/
)
{
$fname = $value ;
}
elsif ( $id eq 'functions' )
{
@functions = split( ',', lc($value) ) ;
}
else
{
print "ERROR: Invalid parameter $p\n" ;
return ;
}
}
if (length($fname) == 0)
{
print "ERROR: Must specify 'name='.\n" ;
return ;
}
if ( ! @functions )
{
print "ERROR: Must specify 'functions=' list.\n" ;
return ;
}
for my $f ( @functions )
{
if ( $f !~ m/^( IOconfig
| RefStation
| Sessions
| miscellaneous
| ExtReference
| Ethernet
| Ftp
| Ntp
| HTTP
| IPfiltering
| Security
| Everything
)$/ix
)
{
print "ERROR: Unknown configuration function $f.\n" ;
return ;
}
}
if (MakeConfigFile( $fname, @functions ) )
{
print "OK: ConfigFile name=$fname created.\n" ;
}
else
{
print "ERROR: Problem creating config file $fname.\n" ;
}
}
sub DeleteConfigFile
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $fname = $_[0] ;
$fname =~ s/^name=//i ;
chdir '/etc/sysconfig/configFiles' ;
if ( $fname =~ /[^\w\.]/
or ! -f $fname
)
{
print "ERROR: Can't find config file $fname\n" ;
return ;
}
system( "sudo /bin/rm -f '/etc/sysconfig/configFiles/$fname'" ) ;
print "OK: ConfigFile name=$fname is deleted.\n" ;
}
sub InstallConfigFile
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $fname = $_[0] ;
$fname =~ s/^name=//i ;
chdir '/etc/sysconfig/configFiles' ;
if ( $fname =~ /[^\w\.]/
or ! -f $fname
)
{
print "ERROR: Can't find config file $fname\n" ;
return ;
}
my $pathname = "/etc/sysconfig/configFiles/$fname" ;
my $status = system( "/usr/local/fireball/clone -t $fname " ) >> 8;
if ($status != 0)
{
print "ERROR: Configuration File $fname is corrupted!\n" ;
return ;
}
my $linkName = 'InstallThisConfig' ;
if ( -r $linkName )
{
system( "sudo rm $linkName" ) ;
}
system( "/usr/bin/sudo /bin/ln -s $fname $linkName" ) ;
system( "/usr/bin/sudo /sbin/boot_status 0 252 f" ) ;
my $spid = qx( cat /var/run/frontpanel_task.pid ) ;
system( "(sleep 5 ; /usr/bin/sudo /bin/kill -SIGUSR2 $spid)&" ) ;
print "OK: Installing ConfigFile name=$fname\n" ;
}
sub UploadConfigFile
{
return if ( badParmCount( scalar( @_ ), 0, 1 ) ) ;
my $pname = '' ;
if (scalar( @_ ))
{
$pname = $_[0] ;
$pname =~ s/name=//i ;
}
my $uname ;
$uname = upload( 'configFile' ) ;
if ( !$uname )
{
print "ERROR: no document attached to upload.\n" ;
return ;
}
my $newFname = $pname || $uname ;
$newFname =~ s/^.*\\// ;
$newFname =~ s/^.*\/// ;
$newFname =~ s/[^\w\.]/_/g ;
my $tmpfilename = tmpFileName($uname) ;
my $size=(-s $tmpfilename) ;
if ($size)
{
system( "sudo cp $tmpfilename /etc/sysconfig/configFiles/$newFname"
) ;
system( "sudo chmod 444 /etc/sysconfig/configFiles/$newFname" ) ;
print "OK: ConfigFile name=$newFname was successfully uploaded.\n" ;
}
else
{
print "ERROR: There was a problem uploading file '$newFname'.\n" ;
return ;
}
close( $uname ) ;
}
sub UploadFirmwareFile
{
return if ( badParmCount( scalar( @_ ), 0, 1 ) ) ;
my $pname = '' ;
if (scalar( @_ ))
{
$pname = $_[0] ;
$pname =~ s/name=//i ;
}
my $uname ;
$uname = upload( 'firmwareFile' ) ;
if ( !$uname )
{
print "ERROR: no document attached to upload.\n" ;
return ;
}
my $newFname = $pname || $uname ;
$newFname =~ s/^.*\\// ;
$newFname =~ s/^.*\/// ;
$newFname =~ s/[^\w\.\-]/_/g ;
my $tmpfilename = tmpFileName($uname) ;
my $size=(-s $tmpfilename) ;
if ($size)
{
my $newPath = '/var/gps/incoming/'.$newFname ;
if ( ! -d '/var/gps/incoming' )
{
mkdir '/var/gps/incoming' ;
}
if ( ! -w '/var/gps/incoming' )
{
system( '/usr/bin/sudo chown netrx:netrx /var/gps/incoming' ) ;
system( '/usr/bin/sudo chmod a+rw /var/gps/incoming' ) ;
}
rename $tmpfilename, $newPath ;
system( "chmod a+rx $newPath" ) ;
close( $uname ) ;
print "OK: FirmwareFile $newFname was successfully uploaded.\n" ;
}
else
{
print "ERROR: There was a problem uploading file '$newFname'.\n" ;
return ;
}
}
sub DeleteFirmwareFile
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
chdir '/var/gps/incoming' ;
my $fname = $_[0] ;
if ($fname =~ /^name=.+/)
{
$fname =~ s/^name=//i ;
if ( $fname =~ /[^\w\.\-]/
or ! -e $fname
)
{
print "ERROR: can't find FirmwareFile $fname\n" ;
return ;
}
system( "sudo /bin/rm -f '/var/gps/incoming/$fname'" ) ;
print "OK: FirmwareFile $fname is deleted.\n" ;
}
elsif ($fname =~ /^all=yes$/i)
{
for $fname (glob('*'))
{
system( "sudo /bin/rm -f '/var/gps/incoming/$fname'" ) ;
}
print "OK: All firmware files deleted.\n" ;
}
}
sub badPatch
{
my $description = $_[0] ;
my $patchBase = '' ;
$patchBase = $1 if ($description =~ m/Patch Base\s*(\S*)/ );
if ($patchBase)
{
my( $thisVersion, $thisDate ) =
split( "\n",
qx( cat /usr/local/fireball/defaults/firmwareVersion )
) ;
if ( $patchBase ne $thisVersion )
{
return "Patch requires $patchBase but installed is $thisVersion."
}
}
return '' ;
}
sub triggerInstall
{
my $filepath = $_[0] ;
my $linkpath = '/var/gps/incoming/TheRPMtoInstall' ;
if ( -r $linkpath )
{
system( "sudo rm $linkpath" ) ;
}
link( $filepath, $linkpath ) ;
system( "/usr/bin/sudo /sbin/boot_status 0 255 f" ) ;
my $spid = qx( cat /var/run/frontpanel_task.pid ) ;
system( "(sleep 5 ; /usr/bin/sudo /bin/kill -SIGUSR2 $spid)&" ) ;
}
sub VerifyOrInstallFirmwareFile
{
my $install  = $_[0] ;
my $filename = $_[1] ;
my $filepath = '/var/gps/incoming/' . $filename ;
if ( $filename =~ /[^\w\.\-]/
or ! -e $filepath
)
{
print "ERROR: Can't find FirmwareFile $filename.\n" ;
return ;
}
if ( ! IsRpmFile( $filepath ) )
{
print "ERROR: FirmwareFile $filename is not a valid RPM file.\n" ;
return ;
}
my $result = Fireball::RpmVerify( $filepath, 0 ) ;
if ( $result )
{
print "ERROR: FirmwareFile $filename is corrupted.\n" ;
return ;
}
my $description ;
if ( ! underWarranty( $filepath,
0,  # Not verbose
\$description
)
)
{
print "ERROR: FirmwareFile $filename is dated past your warranty.\n" ;
return ;
}
$result = badPatch( $description ) ;
if ($result)
{
print "ERROR: Can't install $filename.  $result\n" ;
return ;
}
if (!$install)
{
print "OK: FirmwareFile $filename can be installed.\n" ;
return ;
}
my $installationTime = '200' ;
$installationTime = $1
if ($description =~ m/Expected Installation Time\s*:\s*(\d+)/ );
print "OK: Installing FirmwareFile $filename.  ",
"Expect at least $installationTime seconds to complete.\n" ;
triggerInstall( $filepath ) ;
}
sub VerifyFirmwareFile
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $filename = $_[0] ;
$filename =~ s/^name=//i ;
VerifyOrInstallFirmwareFile( 0, $filename ) ;
}
sub InstallFirmwareFile
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $filename = $_[0] ;
$filename =~ s/^name=//i ;
VerifyOrInstallFirmwareFile( 1, $filename ) ;
}
sub ShowWaasSatControls
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
$_ = qx( /usr/bin/sudo /usr/local/fireball/sysinfo -p waas_sv_masks ) ;
my @state = split( " ", $_ ) ;
splice( @state, 0, 2 ) ;
my $waasCount = scalar( @state ) ;
my @enables = () ;
my @disables = () ;
my @ignores = () ;
for (my $sv = 0 ; $sv < 19 ; ++$sv )
{
my $state = $state[$sv] ;
if ($state eq 'I')
{
push( @ignores, sprintf( '%d', $sv+120 ) ) ;
}
elsif ($state eq 'D')
{
push( @disables, sprintf( '%d', $sv+120 ) ) ;
}
else
{
push( @enables, sprintf( '%d', $sv+120 ) ) ;
}
}
print "WaasSatControls " ;
if ( scalar(@enables) >= 9 )
{
print "enable=all " ;
}
elsif ( scalar(@disables) >= 9 )
{
print "disable=all " ;
}
elsif ( scalar(@ignores) >= 9 )
{
print "ignoreHealth=all " ;
}
if ( scalar(@enables) >= 9 )
{
}
elsif ( scalar(@enables) == 0 )
{
print "enable=none " ;
}
else
{
print "enable=", join( ',', @enables ), " " ;
}
if ( scalar(@disables) >= 9 )
{
}
elsif ( scalar(@disables) == 0 )
{
print "disable=none " ;
}
else
{
print "disable=", join( ',', @disables ), " " ;
}
if ( scalar(@ignores) >= 9 )
{
}
elsif ( scalar(@ignores) == 0 )
{
print "ignoreHealth=none" ;
}
else
{
print "ignoreHealth=",join( ',', @ignores ) ;
}
print "\n" ;
}
sub SetWaasSatControls
{
return if ( badParmCount( scalar( @_ ), 1, 3 ) ) ;
my %parms = ( 'enable'=>'', 'disable'=>'', 'ignorehealth'=>'' ) ;
my $parmcount = 0 ;
my $allFound = 0 ;
for my $p (@_)
{
$p = lc( $p ) ;
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter $p\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
if ( $parms{$id} )
{
print "ERROR: Duplicate parameter $p\n" ;
return ;
}
if ($value eq 'all')
{
if ($allFound)
{
print "ERROR: Only one 'all' parameter allowed.\n" ;
return ;
}
++$allFound ;
}
elsif ( $value =~ /^\d+(,\d+)*$/ )
{
for my $sv ( split( ',',  $value ) )
{
if ( ($sv < 120) || ($sv >138) )
{
print "ERROR: Sv number out of range 120 to 138.\n" ;
return ;
}
}
}
elsif ( $value ne 'none'
&& $value ne ''
)
{
print "ERROR: Invalid parameter $p\n" ;
return ;
}
$parms{$id} = $value ;
++$parmcount ;
}
$_ = qx( /usr/bin/sudo /usr/local/fireball/sysinfo -p waas_sv_masks );
my @state = split( " ", $_ ) ;
splice( @state, 0, 2 ) ;
my @svSet = (0) x 19 ;
if ($parms{'enable'} eq 'all')
{
@state = ('E') x 19 ;
}
if ($parms{'disable'} eq 'all')
{
@state = ('D') x 19 ;
}
if ($parms{'ignorehealth'} eq 'all')
{
@state = ('I') x 19 ;
}
if ($parms{'enable'} =~ /^\d/ )
{
for my $sv ( split( ',',  $parms{'enable'} ) )
{
$state[$sv-120] = 'E' ;
$svSet[$sv-120] = 1 ;
}
}
if ($parms{'disable'} =~ /^\d/ )
{
for my $sv (split( ',',  $parms{'disable'}))
{
if ($svSet[$sv-120])
{
print "ERROR: Can't specify satellite $sv twice.\n" ;
return ;
}
$state[$sv-120] = 'D' ;
$svSet[$sv-120] = 1 ;
}
}
if ($parms{'ignorehealth'} =~ /^\d/ )
{
for my $sv (split( ',',  $parms{'ignorehealth'}))
{
if ($svSet[$sv-120])
{
print "ERROR: Can't specify satellite $sv twice.\n" ;
return ;
}
$state[$sv-120] = 'I' ;
$svSet[$sv-120] = 1 ;
}
}
my $commandLine = 'put waas_sv_masks' ;
for (my $i = 0 ; $i < 19 ; ++$i )
{
$commandLine .= " $state[$i]" ;
}
$commandLine .= "\n" ;
newStingerConfig( $commandLine ) ;
print "OK: " ;
ShowWaasSatControls() ;
}
sub ShowGpsSatControls
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
$_ = qx( /usr/bin/sudo /usr/local/fireball/sysinfo -p sv_masks ) ;
my @state = split( " ", $_ ) ;
splice( @state, 0, 2 ) ;
my @enables = () ;
my @disables = () ;
my @ignores = () ;
for (my $sv = 1 ; $sv <= 32 ; ++$sv )
{
my $state = $state[$sv-1] ;
if ($state eq 'I')
{
push( @ignores, sprintf( '%d', $sv ) ) ;
}
elsif ($state eq 'D')
{
push( @disables, sprintf( '%d', $sv ) ) ;
}
else
{
push( @enables, sprintf( '%d', $sv ) ) ;
}
}
print "GpsSatControls " ;
if ( scalar(@enables) >= 16 )
{
print "enable=all " ;
}
elsif ( scalar(@disables) >= 16 )
{
print "disable=all " ;
}
elsif ( scalar(@ignores) >= 16 )
{
print "ignoreHealth=all " ;
}
if ( scalar(@enables) >= 16 )
{
}
elsif ( scalar(@enables) == 0 )
{
print "enable=none " ;
}
else
{
print "enable=", join( ',', @enables ), " " ;
}
if ( scalar(@disables) >= 16 )
{
}
elsif ( scalar(@disables) == 0 )
{
print "disable=none " ;
}
else
{
print "disable=", join( ',', @disables ), " " ;
}
if ( scalar(@ignores) >= 16 )
{
}
elsif ( scalar(@ignores) == 0 )
{
print "ignoreHealth=none" ;
}
else
{
print "ignoreHealth=",join( ',', @ignores ) ;
}
print "\n" ;
}
sub SetGpsSatControls
{
return if ( badParmCount( scalar( @_ ), 1, 3 ) ) ;
my %parms = ( 'enable'=>'', 'disable'=>'', 'ignorehealth'=>'' ) ;
my $parmcount = 0 ;
my $allFound = 0 ;
for my $p (@_)
{
$p = lc( $p ) ;
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter $p\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
if ( $parms{$id} )
{
print "ERROR: Duplicate parameter $p\n" ;
return ;
}
if ($value eq 'all')
{
if ($allFound)
{
print "ERROR: Only one 'all' parameter allowed.\n" ;
return ;
}
++$allFound ;
}
elsif ( $value =~ /^\d+(,\d+)*$/ )
{
for my $sv ( split( ',',  $value ) )
{
if ( ($sv < 1) || ($sv > 32) )
{
print "ERROR: Sv number out of range 1 to 32.\n" ;
return ;
}
}
}
elsif ( $value ne 'none'
&& $value ne ''
)
{
print "ERROR: Invalid parameter $p\n" ;
return ;
}
$parms{$id} = $value ;
++$parmcount ;
}
$_ = qx( /usr/bin/sudo /usr/local/fireball/sysinfo -p sv_masks ) ;
my @state = split( " ", $_ ) ;
splice( @state, 0, 2 ) ;
my @svSet = (0) x 32 ;
if ($parms{'enable'} eq 'all')
{
@state = ('E') x 32 ;
}
if ($parms{'disable'} eq 'all')
{
@state = ('D') x 32 ;
}
if ($parms{'ignorehealth'} eq 'all')
{
@state = ('I') x 32 ;
}
if ($parms{'enable'} =~ /^\d/ )
{
for my $sv ( split( ',',  $parms{'enable'} ) )
{
$state[$sv-1] = 'E' ;
$svSet[$sv] = 1 ;
}
}
if ($parms{'disable'} =~ /^\d/ )
{
for my $sv (split( ',',  $parms{'disable'}))
{
if ($svSet[$sv])
{
print "ERROR: Can't specify satellite $sv twice.\n" ;
return ;
}
$state[$sv-1] = 'D' ;
$svSet[$sv] = 1 ;
}
}
if ($parms{'ignorehealth'} =~ /^\d/ )
{
for my $sv (split( ',',  $parms{'ignorehealth'}))
{
if ($svSet[$sv])
{
print "ERROR: Can't specify satellite $sv twice.\n" ;
return ;
}
$state[$sv-1] = 'I' ;
$svSet[$sv] = 1 ;
}
}
my $commandLine = 'put sv_masks' ;
for (my $i = 0 ; $i < 32 ; ++$i )
{
$commandLine .= " $state[$i]" ;
}
$commandLine .= "\n" ;
newStingerConfig( $commandLine ) ;
print "OK: " ;
ShowGpsSatControls() ;
}
sub ShowTrackingStatus
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
print "<ShowTrackingStatus>\n" ;
open( SYSINFO,
'/usr/bin/sudo /usr/local/fireball/sysinfo -p tracking_status |');
for ( my $i = 0 ; $i < 12 ; $i++ )
{
if ( ($_ = <SYSINFO>) !~ /idle/ )
{
my ( $chan, undef, $prn, $elev, $azm,
undef, undef, $L1SNR, $L2SNR, $IODE, $URA, $L2CSNR)
= split( ' ' ) ;
printf( "Chan=%-2d PRN=%-3d Elv=%-4d Azm=%-3d L1snr=%-2d",
$chan,
$prn,
$elev,
$azm,
$L1SNR
) ;
if ($prn <= 32)
{
printf( " L2snr=%-2d L2Csnr=%-2d IODE=%-3d URA=%-s",
$L2SNR,
$L2CSNR,
$IODE,
$URA
) ;
}
print "\n" ;
}
}
$_ = <SYSINFO> ;
close( SYSINFO ) ;
print "<end of ShowTrackingStatus>\n" ;
}
sub ShowWaasTracking
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
$_ = qx( /usr/bin/sudo /usr/local/fireball/sysinfo -p waas_mode ) ;
my $WaasEnabled = ( (split)[2] eq 'on') ? 'yes' : 'no' ;
print "WaasTracking enable=$WaasEnabled\n" ;
}
sub SetWaasTracking
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $newstate = lc( $_[0] ) ;
$newstate =~ s/^enable=// ;
if ($newstate !~ m/^(yes|no)$/)
{
print "ERROR: Invalid parameter $_[0]\n" ;
return ;
}
newStingerConfig( 'put waas_mode '
.( ( $newstate eq 'yes') ? "on\n" : "off\n" )
) ;
print "OK: " ;
ShowWaasTracking() ;
}
sub ShowReferenceFrequency
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my $setting = qx( cat /etc/sysconfig/extRefFreq ) ;
$setting = ( $setting =~ m/External/ )
? 'external'
: 'internal'
;
my (undef, $detected) = split( ',',
qx(/usr/local/fireball/extfreq -p)
) ;
$detected = ($detected =~ m/present/)
? 'yes'
: 'no'
;
print "ReferenceFrequency source=$setting",
" externalSignalDetected=$detected\n" ;
}
sub SetReferenceFrequency
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $newSource = lc( $_[0] ) ;
$newSource =~ s/^source=// ;
if ($newSource eq 'external')
{
$newSource = 'External' ;
}
elsif ($newSource eq 'internal')
{
$newSource = 'Internal' ;
}
else
{
print "ERROR: Invalid parameter $_[0]\n" ;
return ;
}
my $setting = qx( cat /etc/sysconfig/extRefFreq ) ;
if ( $setting !~ m/$newSource/i )
{
open( NEWCONFIG, '>/tmp/extRefFreq' ) ;
print NEWCONFIG "REFSOURCE=$newSource\n" ;
close NEWCONFIG ;
system( 'sudo cp /tmp/extRefFreq /etc/sysconfig/extRefFreq' ) ;
system( 'sudo /usr/local/fireball/sysinfo -m'  ) ;
}
print "OK: " ;
ShowReferenceFrequency() ;
}
sub ShowLoggedFiles
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $path = $_[0] ;
$path =~ s/^directory=//i ;
$path =~ s/^([^\/])/\/$1/ ;
if ( ! -d "/var/gps$path"
|| $path =~ m|//|
|| $path =~ m/\.\./
|| $path =~ m|/incoming|
|| $path =~ m|/tmp|
)
{
print "ERROR: Can't find directory '$path'\n" ;
return ;
}
print "<Show LoggedFiles directory=$path>\n" ;
chdir "/var/gps$path" ;
my @files = glob( "*" ) ;
for my $filename (  sort @files )
{
if (-f $filename)
{
next if ( $filename =~ m/\.A$/ ) ;
print "LoggedFile name=$filename size=",
(-s $filename),
"\n" ;
}
else
{
next if ( $filename eq 'CVS'
|| ( ($path eq '/')
&& ( $filename eq 'tmp'
|| $filename eq 'incoming'
|| $filename eq 'lost+found'
)
)
) ;
print "Directory name=$filename\n" ;
}
}
print "<end of Show LoggedFiles directory=$path>\n" ;
}
sub ShowLoggedFile
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $path = $_[0] ;
$path =~ s/^path=//i ;
$path =~ s/^([^\/])/\/$1/ ;
if ( ! -f "/var/gps$path"
|| $path =~ m|//|
|| $path =~ m/\.\./
|| $path =~ m|/incoming|
|| $path =~ m|/tmp|
)
{
print "ERROR: Can't find file $path.\n" ;
return ;
}
print "LoggedFile path=$path size=",
(-s "/var/gps$path"),
"\n" ;
}
sub DeleteLoggedFile
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $path = $_[0] ;
$path =~ s/^path=//i ;
$path =~ s/^([^\/])/\/$1/ ;
if ( ! -f "/var/gps$path"
|| $path =~ m|//|
|| $path =~ m/\.\./
|| $path =~ m|/incoming|
|| $path =~ m|/tmp|
)
{
print "ERROR: Can't find file $path.\n" ;
return ;
}
unlink "/var/gps$path" ;
print "OK: LoggedFile $path is deleted.\n" ;
}
sub DeleteLoggedFiles
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $path = $_[0] ;
$path =~ s/^directory=//i ;
$path =~ s/^([^\/])/\/$1/ ;
if ( $path =~ /[^\w\.\/]/
|| $path =~ m|//|
|| $path =~ m/\.\./
|| $path =~ m|/incoming|
|| $path =~ m|/tmp|
|| ! -d "/var/gps$path"
)
{
print "ERROR: Can't find directory '$path'\n" ;
return ;
}
if ($path eq '/')
{
print "ERROR: Can't delete '/'\n" ;
return ;
}
system( "rm -fr /var/gps$path" ) ;
print "OK: LoggedFile Directory $path is deleted.\n" ;
}
sub ShowGpsHealth
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
$_ = qx( /usr/local/fireball/sysinfo -p gps_hlth ) ;
chomp ;
my @healthCodes = ( 0, split() ) ;
my $healthInfo = '' ;
my $unhealthInfo = '' ;
my $unknownInfo = '' ;
my $prevHealthy = -1 ;
for (my $sv = 1 ; $sv <=32 ; ++$sv)
{
my $h = $healthCodes[$sv] ;
if ( $h == 0 )
{
$healthInfo .= ',' if ($healthInfo) ;
$healthInfo .= $sv ;
}
elsif ($h == -1)
{
$unknownInfo .= ',' if ($unknownInfo) ;
$unknownInfo .= $sv ;
}
else
{
$unhealthInfo .= ',' if ($unhealthInfo) ;
$unhealthInfo .= "$sv:$h" ;
}
}
for (my $sv = 1 ; $sv <=31 ; ++$sv)
{
my $s1 = sprintf( "%d", $sv) ;
my $s2 = sprintf( "%d", $sv+1) ;
my $s3 = sprintf( "%d", $sv+2) ;
$healthInfo =~ s/-$s1,$s2/-$s2/ ;
$healthInfo =~ s/$s1,$s2,$s3/$s1-$s3/ ;
}
$healthInfo = 'none' if (!$healthInfo ) ;
$unhealthInfo = 'none' if (!$unhealthInfo ) ;
$unknownInfo = 'none' if (!$unknownInfo ) ;
print "GpsHealth",
" healthy=$healthInfo" ,
" unhealthy=$unhealthInfo" ,
" unknown=$unknownInfo",
"\n" ;
}
sub ResetSystem
{
my $defaults = 0 ;
return if ( badParmCount( scalar( @_ ), 0, 1 ) ) ;
if (scalar( @_ ) != 0)
{
if ( @_[0] =~ /^defaults=(yes|no)$/i)
{
$defaults = 1 if ($1 =~ /yes/i) ;
}
else
{
print "ERROR: Invalid parameter $_[0]\n" ;
return ;
}
}
if ($defaults)
{
print "OK: Restarting with Factory Defaults.\n" ;
system( "/usr/bin/sudo /sbin/boot_status 0 254 f" ) ;
}
else
{
print "OK: Restarting this NetRS.\n" ;
}
my $spid = qx( cat /var/run/frontpanel_task.pid ) ;
system( "(sleep 5 ; /usr/bin/sudo /bin/kill -SIGUSR2 $spid)&" ) ;
system( "(sleep 30 ; /usr/bin/sudo /sbin/init 6)&" ) ;
}
sub ResetGpsData
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
print "OK: Clearing GpsData and restarting satellite tracking operations.\n" ;
my $spid = qx( cat /var/run/frontpanel_task.pid ) ;
system( "(sleep 5 ; /usr/bin/sudo /bin/kill -SIGHUP $spid)&" ) ;
}
sub ShowFtpSetup
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %ftpSetup ;
getFtpSetup( \%ftpSetup ) ;
if ( ! $ftpSetup{'namedPassword'} )
{
$ftpSetup{'namedPassword'} = 'NotSet' ;
}
if ( ! $ftpSetup{'adminPassword'} )
{
$ftpSetup{'adminPassword'} = 'NotSet' ;
}
print "FtpSetup anon=",
($ftpSetup{'anon'} eq 'enabledDelete')
? 'enabledWithDelete'
: $ftpSetup{'anon'},
" named=",
($ftpSetup{'named'} eq 'enabledDeleting')
? 'enabledWithDelete'
: $ftpSetup{'named'},
" admin=",
$ftpSetup{'admin'},
" namedPassword=$ftpSetup{'namedPassword'}",
" adminPassword=$ftpSetup{'adminPassword'}",
" port=",
($ftpSetup{'ftpEnabled'} eq 'no')
? 'disabled'
: ($ftpSetup{'standardPort'} eq 'yes')
? 21
: $ftpSetup{'alternatePort'},
"\n"
;
}
sub SetFtpSetup
{
return if ( badParmCount( scalar( @_ ), 1, 5 ) ) ;
my %ftpSetup ;
getFtpSetup( \%ftpSetup ) ;
for $_ (@_)
{
if ( m/^anon=(disabled|enabled|enabledWithDelete)$/i )
{
$ftpSetup{'anon'} = m/delete/i
? 'enabledDelete'
: ( m/disabled/i
? 'disabled'
: 'enabled'
) ;
}
elsif ( m/^named=(disabled|enabled|enabledWithDelete)$/i )
{
$ftpSetup{'named'} = m/delete/i
? 'enabledDelete'
: ( m/disabled/i
? 'disabled'
: 'enabled'
) ;
}
elsif ( m/^admin=(disabled|enabled)$/i )
{
$ftpSetup{'admin'} = m/enabled/i
? 'enabled'
: 'disabled' ;
}
elsif ( m/^namedPassword=(.*)$/i )
{
my $pw = $1 ;
if ($pw =~ m/^(NotSet|)$/i)
{
$ftpSetup{'namedPassword'} = '' ;
}
elsif ($pw =~ m/^.{13}$/)
{
$ftpSetup{'namedPassword'} = $pw ;
}
else
{
print "ERROR: Invalid password $_\n" ;
return ;
}
}
elsif ( m/^adminPassword=(.*)$/i )
{
my $pw = $1 ;
if ($pw =~ m/^(NotSet|)$/i)
{
$ftpSetup{'adminPassword'} = '' ;
}
elsif ($pw =~ m/^.{13}$/)
{
$ftpSetup{'adminPassword'} = $pw ;
}
else
{
print "ERROR: Invalid password $_\n" ;
return ;
}
}
elsif ( m/^adminClearPw=(.*)$/i )
{
$ftpSetup{'adminPassword'} = makepw( $1 ) ;
}
elsif ( m/^namedClearPw=(.*)$/i )
{
$ftpSetup{'namedPassword'} = makepw( $1 ) ;
}
elsif ( m/^port=disabled$/i )
{
$ftpSetup{'ftpEnabled'} = 'no' ;
$ftpSetup{'standardPort'} = 'yes' ;
}
elsif ( m/^port=standard$/i )
{
$ftpSetup{'ftpEnabled'} = 'yes' ;
$ftpSetup{'standardPort'} = 'yes' ;
}
elsif ( m/^port=(\d*)$/i )
{
if ($1 == 21)
{
$ftpSetup{'ftpEnabled'} = 'yes' ;
$ftpSetup{'standardPort'} = 'yes' ;
}
elsif ($1 >= 1024 and $1 <= 65535)
{
$ftpSetup{'ftpEnabled'} = 'yes' ;
$ftpSetup{'standardPort'} = 'no' ;
$ftpSetup{'alternatePort'} = $1 ;
}
else
{
print "ERROR: Port $1 out of range 21, 1024..65535.\n" ;
return ;
}
}
else
{
print "ERROR: Invalid parameter $_\n" ;
return ;
}
}
saveFtpSetup( \%ftpSetup ) ;
print "OK: " ;
ShowFtpSetup() ;
}
sub ShowGuiSecurity
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %restrictions ;
getGuiSecurity( \%restrictions ) ;
print "GuiSecurity",
" system=",
$restrictions{ 'sysadmin' } ? 'restricted' : 'unrestricted',
" gps=",
$restrictions{ 'gpsadmin' } ? 'restricted' : 'unrestricted',
" files=",
$restrictions{ 'fileaccess' } ? 'restricted' : 'unrestricted',
"\n" ;
}
sub SetGuiSecurity
{
return if ( badParmCount( scalar( @_ ), 1, 3 ) ) ;
my %restrictions ;
getGuiSecurity( \%restrictions ) ;
for $_ (@_)
{
if ( m/^(system|gps|files)=(restricted|unrestricted)$/i )
{
my $level = lc($1) ;
my $value = lc($2) ;
$restrictions{ $level eq 'system'
? 'sysadmin'
: $level eq 'gps'
? 'gpsadmin'
: 'fileaccess' } = ($value eq 'restricted') ;
}
else
{
print "ERROR: Invalid parameter $_\n" ;
return ;
}
}
updateGuiSecurity( \%restrictions ) ;
print "OK: " ;
ShowGuiSecurity() ;
}
sub ShowGuiAccount
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $name = $_[0] ;
$name =~ s/^name=//i ;
my %accounts ;
getGuiAccounts( \%accounts ) ;
if ( !exists( $accounts{$name} ) )
{
print "ERROR: GuiAccount $name does not exist.\n" ;
return ;
}
printf "GuiAccount name=%-8s", $name ;
print ' password=',
$accounts{$name}{'password'},
' system=',
$accounts{$name}{'sysadmin'} ? 'yes' : 'no ',
' gps=',
$accounts{$name}{'gpsadmin'} ? 'yes' : 'no ',
' files=',
$accounts{$name}{'fileaccess'} ? 'yes' : 'no ',
"\n" ;
}
sub ShowGuiAccounts
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %accounts ;
print "<Show GuiAccounts>\n" ;
getGuiAccounts( \%accounts ) ;
for my $name (sort keys %accounts )
{
ShowGuiAccount( $name ) ;
}
print "<end of Show GuiAccounts>\n" ;
}
sub SetGuiAccount
{
return if ( badParmCount( scalar( @_ ), 1, 5 ) ) ;
my %accounts ;
getGuiAccounts( \%accounts ) ;
my %parms ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter $p\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
if ( $id =~ m/^(system|gps|files)$/i )
{
$value = lc( $value ) ;
if ( ($value ne 'yes') and ($value ne 'no') )
{
print "ERROR: Invalid parameter $p\n" ;
return ;
}
}
elsif ( $id =~ m/^password$/i )
{
if ( $value !~ m/^.{13}$/ )
{
print "ERROR: Invalid encrypted password.\n" ;
return ;
}
}
elsif ( $id =~ m/^clearpassword$/i )
{
if ( $value !~ m/^.{6,}$/ )
{
print "ERROR: Password is too short.\n" ;
return ;
}
}
elsif ( $id =~ m/^name$/i )
{
if ($value =~ m/[\x00-\x20\x7f-\xff]/)
{
print "ERROR: Invalid account name.\n" ;
return ;
}
}
else
{
print "ERROR: Invalid parameter $p.\n" ;
return ;
}
$parms{lc($id)} = $value ;
}
my $name = $parms{'name'} ;
my $password = $parms{'password'} ;
my $clearPassword = $parms{'clearpassword'} ;
my $system = $parms{'system'} ;
my $gps = $parms{'gps'} ;
my $files = $parms{'files'} ;
if (! $name )
{
print "ERROR: Must specify name for GuiAccount.\n" ;
return ;
}
if ($clearPassword)
{
$password = makepw( $clearPassword ) ;
}
if ( ! exists( $accounts{$name} ) )
{
if ( !$password )
{
print "ERROR: Must specify password for new account.\n" ;
return ;
}
$accounts{$name}{'sysadmin'} = 0 ;
$accounts{$name}{'gpsadmin'} = 0 ;
$accounts{$name}{'fileaccess'} = 0 ;
}
if ($password)
{
$accounts{$name}{'password'} = $password ;
}
if ($system)
{
$accounts{$name}{'sysadmin'} = ($system eq 'yes' ? 1 : 0 ) ;
}
if ($gps)
{
$accounts{$name}{'gpsadmin'} = ($gps eq 'yes' ? 1 : 0 ) ;
}
if ($files)
{
$accounts{$name}{'fileaccess'} = ($files eq 'yes' ? 1 : 0 ) ;
}
if ( $name eq 'sysadmin'
&& ( !$accounts{'sysadmin'}{'sysadmin'}
|| !$accounts{'sysadmin'}{'gpsadmin'}
|| !$accounts{'sysadmin'}{'fileaccess'}
)
)
{
print "ERROR: Can't modify permissions on sysadmin account.\n" ;
return ;
}
updateGuiAccounts( \%accounts ) ;
print "OK: " ;
ShowGuiAccount( $parms{'name'} ) ;
}
sub DeleteGuiAccount
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my %accounts ;
getGuiAccounts( \%accounts ) ;
my $name = $_[0] ;
$name =~ s/^name=//i ;
if ( $name eq 'sysadmin' )
{
print "ERROR: Can't delete sysadmin account.\n" ;
return ;
}
if ( !exists( $accounts{$name} ) )
{
print "ERROR: GuiAccount $name does not exist.\n" ;
return ;
}
delete( $accounts{$name} ) ;
updateGuiAccounts( \%accounts ) ;
print "OK: GuiAccount $name is deleted.\n" ;
}
sub ShowAntennaTypes
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
print "<Show AntennaTypes>\n" ;
my %antInfo ;
getAntennaInfo( \%antInfo ) ;
foreach (sort( keys %antInfo ))
{
my $ngsName = $antInfo{$_}{'ngs'} ;
$ngsName =~ s/ /_/g ;
my $name = $antInfo{$_}{'name'} ;
$name =~ s/ /_/g ;
printf "type=%-3d code=%-2s NgsIgs=%-20s name=%s\n",
$_,
$antInfo{$_}{'code'},
$ngsName,
$name ;
}
print "<end of Show AntennaTypes>\n" ;
}
sub ShowAntenna
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %antInfo ;
getAntennaInfo( \%antInfo ) ;
my %antSetup ;
getAntennaSetup( \%antSetup ) ;
my $type = $antSetup{'type'} ;
print "Antenna serialNumber=$antSetup{'serial'}" ;
my $ts = $antSetup{'textSerial'} ;
$ts =~ s/'/\\'/g ;
print " textSerialNumber='$ts'" ;
print " type=$type" ;
$ts = $antSetup{'domeSerial'} ;
$ts =~ s/'/\\'/g ;
print " radomeSerialNumber='$ts'" ;
my $method = $antInfo{$type}{'methods'}[$antSetup{'method'}] ;
$method =~ s/ /_/g ;
print " refPoint=$method" ;
print " height=$antSetup{'height'}" ;
my $name = $antInfo{$type}{'name'} ;
$name =~ s/ /_/g ;
print " name=$name" ;
my $code = $antInfo{$type}{'code'} ;
print " code=$code" ;
my $ngs = $antInfo{$type}{'ngs'} ;
$ngs =~ s/ /_/g ;
print " NgsIgs=$ngs" ;
print "\n";
}
sub SetAntenna
{
return if ( badParmCount( scalar( @_ ), 1, 8 ) ) ;
my %antInfo ;
getAntennaInfo( \%antInfo ) ;
my %antSetup ;
getAntennaSetup( \%antSetup ) ;
my $newRefPoint =
$antInfo{$antSetup{'type'}}{'methods'}[$antSetup{'method'}] ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter $p\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
$id = lc($id) ;
if ($id eq 'serialnumber')
{
if ($value !~ /^\d{1,8}$/)
{
print "ERROR: SerialNumber must an integer < 100000000.\n" ;
return ;
}
$antSetup{'serial'} = $value + 0 ;
}
elsif ($id eq 'textserialnumber')
{
$antSetup{'textSerial'} = $value ;
}
elsif ($id eq 'radomeserialnumber')
{
$antSetup{'domeSerial'} = $value ;
}
elsif ($id eq 'height')
{
if ( $value !~ m/^\d*\.\d+$/ # .333 or 333.333
and $value !~ m/^\d+\.\d*$/ # 333.
and $value !~ m/^\d+$/     # 333
)
{
print "ERROR: Illegal height value '$value'\n" ;
return ;
}
$antSetup{'height'} = $value ;
}
elsif ($id eq 'type')
{
if ( $value !~ /\d+/
or !exists( $antInfo{$value+0} )
)
{
print "ERROR: Unsupported antenna type '$value'\n" ;
return ;
}
$antSetup{'type'} = $value+0 ;
}
elsif ($id eq 'refpoint')
{
$newRefPoint = $value ;
}
elsif ($id eq 'name')
{
my $ucvalue = uc($value) ;
$ucvalue =~ s/[ _]//g ;
my $notfound = 1 ;
for my $type ( keys %antInfo )
{
my $supported = uc( $antInfo{$type}{'name'} ) ;
$supported =~ s/[ _]//g ;
if ( $ucvalue eq $supported )
{
$antSetup{'type'} = $type ;
$notfound = 0 ;
last ;
}
}
if ($notfound)
{
print "ERROR: Invalid antenna name '$value'.\n" ;
return ;
}
}
elsif ($id eq 'code')
{
my $ucvalue = uc($value) ;
my $notfound = 1 ;
for my $type ( keys %antInfo )
{
if ( $ucvalue eq uc( $antInfo{$type}{'code'} ) )
{
$antSetup{'type'} = $type ;
$notfound = 0 ;
last ;
}
}
if ($notfound)
{
print "ERROR: Invalid antenna code '$value'.\n" ;
return ;
}
}
elsif ($id eq 'ngsigs')
{
my $ucvalue = uc($value) ;
$ucvalue =~ s/[ _]//g ;
my $notfound = 1 ;
for my $type ( keys %antInfo )
{
my $supported = uc( $antInfo{$type}{'ngs'} ) ;
$supported =~ s/[ _]//g ;
if ( $ucvalue eq $supported )
{
$antSetup{'type'} = $type ;
$notfound = 0 ;
last ;
}
}
if ($notfound)
{
print "ERROR: Invalid antenna NgsIgs name '$value'.\n" ;
return ;
}
}
else
{
print "ERROR: Invalid parameter $p.\n" ;
return ;
}
}
my $type = $antSetup{'type'} ;
my $ucvalue = uc($newRefPoint) ;
$ucvalue =~ s/[ _]//g ;
my $notfound = 1 ;
for ( my $method = 0 ;
$method < $antInfo{$type}{'methodCount'} ;
++$method
)
{
my $methodString = uc( $antInfo{$type}{'methods'}[$method] ) ;
$methodString =~ s/[ _]//g ;
if ( $ucvalue eq $methodString )
{
$antSetup{'method'} = $method ;
$notfound = 0 ;
last ;
}
}
if ($notfound)
{
print "ERROR: Unsupported antenna refpoint method '$newRefPoint'.\n" ;
return ;
}
updateAntennaSetup( $antSetup{'serial'},
$antSetup{'type'},
$antSetup{'height'},
$antSetup{'method'},
$antInfo{$type}{'name'},
$antSetup{'textSerial'},
$antSetup{'domeSerial'}
) ;
print "OK: " ;
ShowAntenna ;
}
sub ShowEthernet
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %ethernetSetup ;
getEthernetSetup( \%ethernetSetup ) ;
print "Ethernet",
" ipmode=$ethernetSetup{'ipmode'}",
" ip=$ethernetSetup{'ip'}",
" netmask=", $ethernetSetup{'netmask'} || 'NotSet',
" gateway=", $ethernetSetup{'gateway'} || 'NotSet',
" nameServers=", $ethernetSetup{'nameServers'} || 'NotSet',
" dnsDomain=", $ethernetSetup{'dnsDomain'} || 'NotSet',
" dnsSearch=", $ethernetSetup{'dnsSearch'} || 'NotSet',
" mac=$ethernetSetup{'mac'}",
" mtu=$ethernetSetup{'mtu'}",
"\n" ;
}
sub validIP
{
my $ip = $_[0] ;
return '' if ( $ip !~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/ ) ;
return '' if ($1 > 255 || $2 > 255 || $3 > 255 || $4 > 255) ;
return sprintf( '%d.%d.%d.%d', $1, $2, $3, $4 ) ;
}
sub SetEthernet
{
return if ( badParmCount( scalar( @_ ), 1, 10 ) ) ;
my %ethernetSetup ;
getEthernetSetup( \%ethernetSetup ) ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter $p\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
my $lcvalue = lc( $value ) ;
$id = lc($id) ;
if ($id eq 'ipmode')
{
if ($lcvalue ne 'static' && $lcvalue ne 'dhcp')
{
print "ERROR: ipmode must be 'static' or 'dhcp'\n" ;
return ;
}
$ethernetSetup{'ipmode'} = $lcvalue ;
}
elsif ($id eq 'ip')
{
if ( ! ($ethernetSetup{'ip'} = validIP( $value )) )
{
print "ERROR: Invalid IP address, '$value'\n" ;
return ;
}
}
elsif ($id eq 'mtu')
{
if ( $value !~ /^\d{3,4}$/
|| $value > 1500
|| $value < 600
)
{
print "ERROR: Invalid MTU value, '$value'\n" ;
return ;
}
$ethernetSetup{'mtu'} = $value ;
}
elsif ($id eq 'netmask')
{
if ($lcvalue eq 'notset' or $lcvalue eq '')
{
$ethernetSetup{'netmask'} = '' ;
}
elsif ( ! ($ethernetSetup{'netmask'} = validIP( $value )) )
{
print "ERROR: Invalid Netmask '$value'\n" ;
return ;
}
}
elsif ($id eq 'gateway')
{
if ($lcvalue eq 'notset' or $lcvalue eq '')
{
$ethernetSetup{'gateway'} = '' ;
}
elsif ( ! ($ethernetSetup{'gateway'} = validIP( $value )) )
{
print "ERROR: Invalid Gateway IP '$value'\n" ;
return ;
}
}
elsif ($id eq 'nameservers')
{
$value = '' if ($lcvalue eq 'notset') ;
my @nameservers = split( ',', $value ) ;
if (@nameservers > 3)
{
print "ERROR: Too many Nameservers Specified\n" ;
return ;
}
foreach my $ns (@nameservers)
{
my $ns = validIP( $ns ) ;
if (!$ns)
{
print "ERROR: Invalid Nameserver IP\n" ;
return ;
}
}
$ethernetSetup{'nameServers'} = join( ',', @nameservers ) ;
}
elsif ($id eq 'dnsdomain')
{
$value = '' if ($lcvalue eq 'notset') ;
$ethernetSetup{'dnsDomain'} = $value ;
}
elsif ($id eq 'dnssearch')
{
$value = '' if ($lcvalue eq 'notset') ;
$ethernetSetup{'dnsSearch'} = $value ;
}
elsif ($id eq 'mac')
{
}
else
{
print "ERROR: Invalid parameter $p.\n" ;
return ;
}
}
updateEthernetSetup( \%ethernetSetup ) ;
print "OK: Installing new ethernet configurations.  ",
"Wait 15 seconds for that to take effect.\n" ;
}
sub EnableSession
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $sessname = $_[0] ;
if ( $sessname =~ /=/
&& $sessname !~ /^name=/i
)
{
print "ERROR: Invalid parameter $sessname.\n";
return ;
}
$sessname =~ s/^name=//i ;
if ( EnaDisSession( $sessname, 1) )
{
print "OK: Session name=$sessname enable=yes\n" ;
}
else
{
print "ERROR: No Session '$sessname' exists.\n";
}
}
sub DisableSession
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $sessname = $_[0] ;
if ( $sessname =~ /=/
&& $sessname !~ /^name=/i
)
{
print "ERROR: Invalid parameter $sessname.\n";
return ;
}
$sessname =~ s/name=//i ;
if ( EnaDisSession( $sessname, 0) )
{
print "OK: Session name=$sessname enable=no\n" ;
}
else
{
print "ERROR: No Session '$sessname' exists.\n";
}
}
sub formatSchedString
{
my $sched = $_[0] ;
my $time  = $_[1] ;
if ($sched eq 'manual')
{
return 'Manual' ;
}
elsif ($sched eq 'cont')
{
return 'Continuous' ;
}
elsif ($sched eq 'daily')
{
return sprintf( 'Daily@%02d:%02d', $time/3600, $time/60%60 ) ;
}
else # Once-Only Session
{
my (undef,$min,$hour,$day,$month,$year,undef)
= gmtime( $time + 315964800 ) ;
return sprintf( 'Once@%4d/%02d/%02d/%02d:%02d',
$year+1900,
$month+1,
$day,
$time/3600%24, # Hours
$time/60%60 ,  # Minutes
) ;
}
}
sub formatSession
{
my $String = 'Session ' ;
my $name = $_[0] ;
my %sessData = %{$_[1]} ;
return '' if (! exists( $sessData{$name} ) ) ;
$String .= "name=$name" ;
my $sched = $sessData{$name}{'sched'} ;
my $enable = $sessData{$name}{'enable'} ;
my $time = $sessData{$name}{'time'} ;
my $duration = $sessData{$name}{'duration'} ;
my $sessid = $sessData{$name}{'sessid'} ;
my $perDay = $sessData{$name}{'perday'} ;
my $perSessid = $sessData{$name}{'persessid'} ;
$String .= ' enable=' . ( ($enable==1)?'yes':'no ') ;
$String .= ' schedule=' ;
$String .= formatSchedString( $sched, $time ) ;
$String .= " duration=$duration" ;
$String .= " sessid=$sessid" ;
$String .= ' daySubdir=' . ($perDay ? 'yes' : 'no') ;
$String .= ' sessidSubdir=' . ($perSessid ? 'yes' : 'no') ;
my $ftype = $sessData{$name}{'ftype'} ;
my $measInterval = $sessData{$name}{'measInterval'} ;
if ($ftype eq 'T00')
{
my $posInterval = $sessData{$name}{'posInterval'} ;
my $option1 = $sessData{$name}{'option1'} ;
my $option2 = $sessData{$name}{'option2'} ;
my $rt27    = $sessData{$name}{'RT27'} ;
my $rawWaas = $sessData{$name}{'rawWaas'} ;
$String .= " format=T00" ;
$String .= " measInterval=$measInterval posInterval=$posInterval" ;
$String .= " smoothCode=" . ($option1==1 ? 'yes' : 'no') ;
$String .= " smoothCarrier=" . ($option2==1 ? 'yes' : 'no') ;
$String .= " record27=" . ($rt27==1 ? 'yes' : 'no') ;
$String .= " rawWaas=" . ($rawWaas==1 ? 'yes' : 'no') ;
}
elsif ($ftype eq 'Binex')
{
$String .= " format=Binex" ;
$String .= " measInterval="
. ($measInterval || 'off') ;
$String .= " smoothCarrier="
. ($sessData{$name}{'smoothing'} ? 'yes' : 'no') ;
$String .= " 7f02=" . ($sessData{$name}{'7f02'} ? 'yes' : 'no') ;
$String .= " 7f03=" . ($sessData{$name}{'7f03'} ? 'yes' : 'no') ;
$String .= " 7f03Dopplers="
. ($sessData{$name}{'7f03Doppler'} ? 'yes' : 'no') ;
$String .= " 7f03Slips="
. ($sessData{$name}{'7f03Slips'} ? 'yes' : 'no') ;
$String .= " 7f03ClockOffsets=" ;
if ( $sessData{$name}{'7f03RxClkOfsAlways'} )
{
$String .= "always" ;
}
elsif ( $sessData{$name}{'7f03RxClkOfsRollover'} )
{
$String .= "onRollover" ;
}
else
{
$String .= "never" ;
}
$String .= " metaInterval="
. ($sessData{$name}{'metaInterval'} || 'off') ;
$String .= " metaSiteDesc="
. ($sessData{$name}{'siteDesc'} ? 'yes' : 'no') ;
$String .= " metaStnID="
. ($sessData{$name}{'stationID'} ? 'yes' : 'no') ;
$String .= " metaRcvrType="
. ($sessData{$name}{'rcvrType'} ? 'yes' : 'no') ;
$String .= " metaRinexRcvr="
. ($sessData{$name}{'rcvrNumber'} ? 'yes' : 'no') ;
$String .= " metaFirmware="
. ($sessData{$name}{'firmwareVersion'} ? 'yes' : 'no') ;
$String .= " metaAntXYZ="
. ($sessData{$name}{'antXYZ'} ? 'yes' : 'no') ;
$String .= " metaAntOffset="
. ($sessData{$name}{'antOffset'} ? 'yes' : 'no') ;
$String .= " metaRinexAnt="
. ($sessData{$name}{'antNum'} ? 'yes' : 'no') ;
$String .= " metTilt="
. ($sessData{$name}{'metTilt'} ? 'yes' : 'no') ;
$String .= " sysStatusInterval="
. ($sessData{$name}{'statusInterval'} || 'off') ;
}
return $String ;
}
sub ShowSession
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my %sessData ;
getSessionData( \%sessData ) ;
my $name = $_[0] ;
$name =~ s/^name=//i ;
my $result = formatSession( $name, \%sessData ) ;
if ($result)
{
print "$result\n" ;
}
else
{
print "ERROR: No data for session $name\n" ;
}
}
sub ShowSessions
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %sessData ;
getSessionData( \%sessData ) ;
print "<Show Sessions>\n" ;
for my $name (sort keys %sessData)
{
print formatSession( $name, \%sessData ), "\n" ;
}
print "<end of Show Sessions>\n" ;
}
sub SetSession
{
my %parms ;
my $parmcount = 0 ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter $p\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
$parms{lc($id)} = $value ;
++$parmcount ;
}
if ( ( $parmcount == 2)
&& exists( $parms{'name'} )
&& exists( $parms{'enable'} )
)
{
my $name = $parms{'name'} ;
my $enable = lc( $parms{'enable'} ) ;
if ( $enable !~ /^(yes|no)$/ )
{
print "ERROR: enable must be yes or no.\n";
return ;
}
if ( EnaDisSession( $name, ($enable eq 'yes') ) )
{
print "OK: Session name=$name enable=$enable\n";
}
else
{
print "ERROR: No Session $name exists.\n";
}
return ;
}
my %sessData ;
getSessionData( \%sessData ) ;
my $name = $parms{'name'} ;
delete( $parms{'name'} ) ;
if (! $name )
{
print "ERROR: Must specify session 'name='.\n";
return ;
}
my %oldSessData ;
if (! exists( $sessData{$name} ) )
{
$sessData{$name}{'enable'} = 1 ;
$sessData{$name}{'sched'} = 'cont' ;
$sessData{$name}{'time'} = 0 ;
$sessData{$name}{'duration'} = 60 ;
$sessData{$name}{'sessid'} = 'a' ;
$sessData{$name}{'perday'} = 0 ;
$sessData{$name}{'persessid'} = 0 ;
$sessData{$name}{'ftype'} =  'T00' ;
$sessData{$name}{'measInterval'} =  15 ;
$sessData{$name}{'posInterval'} =  60 ;
$sessData{$name}{'option1'} = 0 ;
$sessData{$name}{'option2'} = 0 ;
$sessData{$name}{'RT27'} = 0 ;
$sessData{$name}{'measInterval'} =  1 ;
$sessData{$name}{'smoothing'} = 0 ;
$sessData{$name}{'7f02'} = 0 ;
$sessData{$name}{'7f03'} = 1 ;
$sessData{$name}{'7f03RxClkOfsRollover'} = 0 ;
$sessData{$name}{'7f03RxClkOfsAlways'} = 0 ;
$sessData{$name}{'7f03Slips'} = 0 ;
$sessData{$name}{'7f03Doppler'} = 0 ;
$sessData{$name}{'metaInterval'} = 0 ;
$sessData{$name}{'siteDesc'} = 0 ;
$sessData{$name}{'stationID'} = 0 ;
$sessData{$name}{'antNum'} = 0 ;
$sessData{$name}{'rcvrType'} = 0 ;
$sessData{$name}{'rcvrNumber'} = 0 ;
$sessData{$name}{'firmwareVersion'} = 0 ;
$sessData{$name}{'antXYZ'} = 0 ;
$sessData{$name}{'antOffset'} = 0 ;
$sessData{$name}{'metTilt'} = 1 ;
$sessData{$name}{'statusInterval'} = 0 ;
$oldSessData{'enable'} = 2 ;
}
else
{
%oldSessData = %{$sessData{$name}} ;
}
my $pname ;
my $value ;
if (exists( $parms{'format'} ))
{
$pname = 'format' ;
$value = lc($parms{'format'}) ;
delete( $parms{'format'} ) ;
if ( $value ne 't00'
and $value ne 'binex'
)
{
BADPARM:
print "ERROR: Invalid parameter '$pname=$value'\n" ;
return ;
}
$value = 'T00' if ($value eq 't00') ;
$value = 'Binex' if ($value eq 'binex') ;
$sessData{$name}{'ftype'} = $value ;
}
if (exists( $parms{'schedule'} ) )
{
$pname = 'schedule' ;
$value = lc( $parms{'schedule'} ) ;
delete( $parms{'schedule'} ) ;
if ($value eq 'continuous')
{
$sessData{$name}{'sched'} = 'cont' ;
$sessData{$name}{'time'} = 0 ;
}
elsif ($value eq 'manual')
{
$sessData{$name}{'sched'} = 'manual' ;
}
elsif ($value =~ /^daily@(\d{1,2}):(\d{1,2})$/)
{
goto BADPARM if ( $1 > 23  or $2 > 59 ) ;
$sessData{$name}{'sched'} = 'daily' ;
$sessData{$name}{'time'} = ($1*60+$2)*60 ;
}
elsif ( $value =~
/^once@(\d{4})\/(\d{1,2})\/(\d{1,2})\/(\d{1,2}):(\d{1,2})$/
)
{
$sessData{$name}{'sched'} = 'once' ;
my ($year,$month,$day,$hour,$min) = ($1, $2, $3, $4, $5 ) ;
goto BADPARM if ( $year < 2000 or $year > 2100
or $month > 12 or $month < 1
or $day > 31 or $day < 1
or $hour > 23
or $min > 59
or ( $day == 31
and ( $month == 4
or $month == 6
or $month == 9
or $month == 11
)
)
or ( $month == 2
and ($day > 29)
)
or ( $month == 2
and ($year % 4 != 0)
and ($day > 28)
)
) ;
$sessData{$name}{'time'} = timegm( 0, # Seconds
$min,
$hour,
$day,
$month-1,
$year-1900,
) - 315964800 ;
}
else
{
goto BADPARM ;
}
} # schedule parameter
if ( exists( $parms{'duration'} ) )
{
$pname = 'duration' ;
$value = lc( $parms{'duration'} ) ;
delete( $parms{'duration'} ) ;
goto BADPARM if ( $value !~ /^\d+$/
or $value > 9999
or ( $sessData{$name}{'sched'} eq 'daily'
and $value >= 1440
)
or $value == 0
) ;
$sessData{$name}{'duration'} = $value ;
}
if ( exists( $parms{'measinterval'} ) )
{
$pname = 'measinterval' ;
$value = lc( $parms{'measinterval'} ) ;
delete( $parms{'measinterval'} ) ;
$value = 0 if ($value eq 'off') ;
goto BADPARM if ( $value !~ /^\d+$/
and $value !~/^\d*\.\d+$/
and $value !~/^\d+\.\d*$/
) ;
$value += 0 ;
if ($value == 0 or $value >= 1.0)
{
goto BADPARM if ( $value != 0
and $value != 1
and $value != 2
and $value != 5
and $value != 10
and $value != 15
and $value != 30
and $value != 60
and $value != 300
and $value != 600
) ;
$value = sprintf( '%.0f', $value ) ;
}
else
{
goto BADPARM if ( $value != 0.1
and $value != 0.2
and $value != 0.5
) ;
$value = sprintf( '%.1f', $value ) ;
}
$sessData{$name}{'measInterval'} = $value ;
}
if ( exists( $parms{'sessid'} ) )
{
$pname = 'sessid' ;
$value = lc( $parms{'sessid'} ) ;
delete( $parms{'sessid'} ) ;
goto BADPARM if ($value !~ /^[a-z]$/) ;
$sessData{$name}{'sessid'} = $value ;
}
my %yesNoOptions ;
if ( $sessData{$name}{'ftype'} eq 'T00' )
{
%yesNoOptions =  (
'enable'           => 'enable',
'smoothcode'       => 'option1',
'smoothcarrier'    => 'option2',
'daysubdir'        => 'perday',
'sessidsubdir'     => 'persessid',
'record27'         => 'RT27',
'rawwaas'          => 'rawWaas'
) ;
if ( exists( $parms{'posinterval'} ) )
{
$pname = 'posinterval' ;
$value = lc( $parms{'posinterval'} ) ;
delete( $parms{'posinterval'} ) ;
$value = 0 if ($value eq 'off') ;
goto BADPARM if ( $value !~ /^\d+$/
and $value !~/^\d*\.\d+$/
and $value !~/^\d+\.\d*$/
) ;
$value += 0 ;
if ($value == 0 or $value >= 1.0)
{
goto BADPARM if ( $value != 0
and $value != 1
and $value != 2
and $value != 5
and $value != 10
and $value != 15
and $value != 30
and $value != 60
and $value != 300
and $value != 600
) ;
$value = sprintf( '%.0f', $value ) ;
}
else
{
goto BADPARM if ( $value != 0.1
and $value != 0.2
and $value != 0.5
) ;
$value = sprintf( '%.1f', $value ) ;
}
$sessData{$name}{'posInterval'} = $value ;
}
}
else
{
%yesNoOptions =  (
'enable'           => 'enable',
'smoothcarrier'    => 'smoothing',
'daysubdir'        => 'perday',
'sessidsubdir'     => 'persessid',
'7f02'             => '7f02',
'7f03'             => '7f03',
'smoothcarrier'    => 'smoothing',
'7f03dopplers'     => '7f03Doppler',
'7f03slips'        => '7f03Slips',
'metasitedesc'     => 'siteDesc',
'metastnid'        => 'stationID',
'metarcvrtype'     => 'rcvrType',
'metarinexrcvr'    => 'rcvrNumber',
'metafirmware'     => 'firmwareVersion',
'metaantxyz'       => 'antXYZ',
'metaantoffset'    => 'antOffset',
'metarinexant'     => 'antNum',
'mettilt'          => 'metTilt',
) ;
if ( exists( $parms{'7f03clockoffsets'} ) )
{
$pname = '7f03clockoffsets' ;
$value = lc( $parms{'7f03clockoffsets'} ) ;
delete( $parms{'7f03clockoffsets'} ) ;
if ($value eq 'always')
{
$sessData{$name}{'7f03RxClkOfsAlways'} = 1 ;
$sessData{$name}{'7f03RxClkOfsRollover'} = 0 ;
}
elsif ($value eq 'onrollover')
{
$sessData{$name}{'7f03RxClkOfsAlways'} = 0 ;
$sessData{$name}{'7f03RxClkOfsRollover'} = 1 ;
}
elsif ($value eq 'never')
{
$sessData{$name}{'7f03RxClkOfsAlways'} = 0 ;
$sessData{$name}{'7f03RxClkOfsRollover'} = 0 ;
}
else
{
print "ERROR: Bad 7f03ClockOffsets=$value.\n" ;
return ;
}
}
if ( exists( $parms{'metainterval'} ) )
{
$pname = 'metainterval' ;
$value = lc( $parms{'metainterval'} ) ;
delete( $parms{'metainterval'} ) ;
$value = '0' if ($value eq 'off') ;
if ( $value != 0
and $value != 60
and $value != 300
and $value != 900
and $value != 1800
and $value != 3600
)
{
print "ERROR: Bad metaInterval=$value.\n" ;
return ;
}
$sessData{$name}{'metaInterval'} = $value ;
}
if ( exists( $parms{'sysstatusinterval'} ) )
{
$pname = 'sysstatusinterval' ;
$value = lc( $parms{'sysstatusinterval'} ) ;
delete( $parms{'sysstatusinterval'} ) ;
$value = '0' if ($value eq 'off') ;
if ( $value != 0
and $value != 60
and $value != 300
and $value != 900
and $value != 1800
and $value != 3600
)
{
print "ERROR: Bad sysstatusInterval=$value.\n" ;
return ;
}
$sessData{$name}{'statusInterval'} = $value ;
}
}
for my $pname ( keys %yesNoOptions )
{
if (exists $parms{$pname})
{
$value = $parms{$pname} ;
delete $parms{$pname} ;
if ($value ne 'yes' and $value ne 'no')
{
print "ERROR: Bad yes/no value in $pname=$value.\n" ;
return ;
}
$sessData{$name}{ $yesNoOptions{$pname} } = ($value eq 'yes') ;
}
}
if ( (scalar(keys %parms)) != 0 )
{
print "ERROR: Excess parameters:",
join( ',', keys(%parms) ),
".\n" ;
return ;
}
if ( ( $sessData{$name}{'ftype'} eq 'T00'
&& $sessData{$name}{'measInterval'} < 1.0
&& $sessData{$name}{'option2'}  # T00 smoothing
)
or ( $sessData{$name}{'ftype'} eq 'Binex'
&& $sessData{$name}{'measInterval'} < 1.0
&& $sessData{$name}{'smoothing'}
)
)
{
print "ERROR: Can't smooth carrier on high rate measurements.\n" ;
return ;
}
if (  $sessData{$name}{'sched'} eq 'manual'
and $sessData{$name}{'enable'}
)
{
for my $k (keys %oldSessData)
{
if ($oldSessData{$k} ne $sessData{$name}{$k})
{
my $gpsTime = time() - 315964800 + 13 ;
$sessData{$name}{'time'} = $gpsTime + 10 ;
last ;
}
}
}
updateSessionData( \%sessData ) ;
print "OK: " ;
ShowSession( $name ) ;
}
sub DeleteSession
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $sessname = $_[0] ;
if ( $sessname =~ /=/
&& $sessname !~ /^name=/i
&& $sessname !~ /^all=yes/i
)
{
print "ERROR: Invalid parameter $sessname.\n";
return ;
}
my %sessData ;
getSessionData( \%sessData ) ;
if ( $sessname !~ /^all=yes/i )
{
$sessname =~ s/^name=//i ;
if (! exists( $sessData{$sessname} ) )
{
print "ERROR: No session '$sessname' to delete.\n";
return ;
}
delete( $sessData{$sessname} ) ;
print "OK: Session '$sessname' is deleted.\n" ;
}
else
{
for my $s (keys %sessData)
{
delete( $sessData{$s} ) ;
}
print "OK: All sessions are deleted.\n" ;
}
updateSessionData( \%sessData ) ;
}
sub formatPort
{
my $name = $_[0] ;
my %allPortData = %{$_[1]} ;
$name =~ s/tcpport/TcpPort/i ;
$name =~ s/udpport/UdpPort/i ;
$name =~ s/serialport/SerialPort/i ;
return 0 if ( !exists $allPortData{$name} ) ;
my %portData = %{$allPortData{$name}} ;
print "IOport port=$name" ;
my $protocol = $portData{'protocol'} ;
my $service = $portData{'service'} ;
print " service=", $service ;
$service=lc($service) ;
if ($service eq 'rtcm')
{
print " version=", $portData{'version'} ;
if ($portData{'version'} ne '3.0')
{
print " style=", $portData{'rtcmStyle'} ;
}
}
elsif ($service eq 'cmr')
{
print " style=", $portData{'cmrStyle'} ;
}
elsif ($service eq 'binex')
{
print " measInterval=",
($portData{'interval'} != 0.0)
? $portData{'interval'}
: 'off' ;
print " smoothCarrier=", $portData{'smoothing'} ? 'yes' : 'no' ;
print " 7f02=", $portData{'7f02'} ? 'yes' : 'no' ;
print " 7f03=", $portData{'7f03'} ? 'yes' : 'no' ;
print " 7f03Dopplers=", $portData{'7f03Doppler'} ? 'yes' : 'no' ;
print " 7f03Slips=", $portData{'7f03Slips'} ? 'yes' : 'no' ;
print " 7f03ClockOffsets=" ;
if    ( $portData{'7f03RxClkOfsAlways'} )   {print "always" ;}
elsif ( $portData{'7f03RxClkOfsRollover'} ) {print "onRollover" ;}
else                                        {print( "never" ) ;}
print " metTilt=", $portData{'metTilt'} ? 'yes' : 'no' ;
print " metaInterval=", $portData{'metaInterval'} || 'off' ;
print " metaSiteDesc=", $portData{'siteDesc'} ? 'yes' : 'no' ;
print " metaStnID=", $portData{'stationID'} ? 'yes' : 'no' ;
print " metaRcvrType=", $portData{'rcvrType'} ? 'yes' : 'no' ;
print " metaRinexRcvr=", $portData{'rcvrNumber'} ? 'yes' : 'no' ;
print " metaFirmware=", $portData{'firmwareVersion'} ? 'yes' : 'no';
print " metaAntXYZ=", $portData{'antXYZ'} ? 'yes' : 'no' ;
print " metaAntOffset=", $portData{'antOffset'} ? 'yes' : 'no' ;
print " metaRinexAnt=", $portData{'antNum'} ? 'yes' : 'no' ;
print " sysStatusInterval=", $portData{'statusInterval'} || 'off' ;
}
elsif ($service eq 'rt17')
{
print " interval=", $portData{'interval'} ;
print " measurements=", $portData{'measurements'} ? 'yes' : 'no' ;
print " positions=", $portData{'positions'} ? 'yes' : 'no' ;
print " concise=", $portData{'concise'} ? 'yes' : 'no' ;
print " iodeslips=", $portData{'iodeslips'} ? 'yes' : 'no' ;
print " GPSdata=", $portData{'gpsdata'} ? 'yes' : 'no' ;
print " rawGPS=", $portData{'rawgps'} ? 'yes' : 'no' ;
print " rawWAAS=", $portData{'rawwaas'} ? 'yes' : 'no' ;
print " smoothCode=", $portData{'smoothcode'} ? 'yes' : 'no' ;
print " smoothCarrier=", $portData{'smoothcarrier'} ? 'yes' : 'no' ;
print " record27=", $portData{'useRt27'} ? 'yes' : 'no' ;
}
elsif ($service eq 'nmea')
{
my $msg ;
foreach $msg (@nmeaMessages)
{
print " $msg=", ($portData{$msg} || 'off') ;
}
}
elsif ($service eq 'ppp')
{
print " baud=",$portData{'pppbaud'} ;
print " flow=",$portData{'pppflow'} ;
print " localIP=", $portData{'localip'} ;
print " remoteIP=", $portData{'remoteip'} ;
my $connection = $portData{'connection'} ;
print " connection=", $connection ;
if ($connection =~ /modem/i)
{
print " reset=", $portData{'reset'} ;
print " init1=", $portData{'init1'} ;
print " init2=", $portData{'init2'} ;
print " init3=", $portData{'init3'} ;
}
}
elsif ($service eq 'met')
{
for (my $i = 1 ; $i <= 6 ; ++$i)
{
print " cmd$i=", $allPortData{'MetControls'}{$i} ;
}
}
if ($protocol eq 'serial' and $service ne 'ppp')
{
print " baud=", $portData{'baud'} ;
print " parity=", $portData{'parity'} ;
print " flow=", $portData{'flow'} ;
}
if ($protocol eq 'udp')
{
print " udpTimeout=",$portData{'udptimeout'} ;
}
print " enable=",
$portData{'enable'}
? 'yes'
: 'no' ;
if ( $protocol eq 'udp'
or $protocol eq 'tcp'
)
{
print " clientAuth=",
$portData{'authenticate'}
? "yes"
: "no" ;
}
print "\n" ;
return 1 ;
}
sub ShowIOports
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
print "<Show IOports>\n" ;
my %allPortData ;
getPortSetup( \%allPortData ) ;
for my $p (sort keys %allPortData)
{
next if ( $p eq 'MetControls' ) ;
next if ( $p eq 'AuthKey' ) ;
next if ( $allPortData{$p}{'service'} =~ /^(internal.|metdata)$/ ) ;
formatPort( $p, \%allPortData ) ;
}
print "<end of Show IOports>\n" ;
}
sub ShowIOport
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $name = $_[0] ;
$name =~ s/^port=//i ;
if ($name =~ /=/)
{
print "ERROR: Invalid parameter $_[0].\n" ;
return ;
}
my %allPortData ;
getPortSetup( \%allPortData ) ;
if ( ! formatPort( $name, \%allPortData ) )
{
print "ERROR: IOport '$name' is not defined.\n" ;
return ;
}
}
sub DeleteIOport
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $name = lc($_[0]) ;
$name =~ s/tcpport/TcpPort/i ;
$name =~ s/udpport/UdpPort/i ;
if ( $name !~ /^port=(Tcp|Udp)Port\d+/
and $name ne 'all=yes'
)
{
print "ERROR: Invalid parameter $_[0].\n" ;
return ;
}
my %allPortData ;
getPortSetup( \%allPortData ) ;
if ($name ne 'all=yes')
{
$name =~ s/^port=//i ;
if ( ! exists( $allPortData{$name} ) )
{
print "ERROR: IOport '$name' is not defined.\n" ;
return ;
}
delete( $allPortData{$name} ) ;
print "OK: IOport $name is deleted.\n" ;
}
else
{
for my $p (keys %allPortData)
{
next if ($p !~ /^(Tcp|Udp)Port/) ;
next if ( $p eq 'TcpPort4001' # Mfg Test
or $p eq 'TcpPort8099' # Internal metdata stream
or $p eq 'TcpPort8086' # IoPort status reports
) ;
delete( $allPortData{$p} ) ;
}
print "OK: All TCP and UDP IOports have been deleted.\n" ;
}
saveGpssdConfig( \%allPortData ) ;
}
sub SetIOport
{
my %parms ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter $p\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
$id = lc($id) ;
$value = lc( $value ) if ( $id ne 'reset'
and $id !~ /^init\d$/
and $id !~ /^cmd\d$/
) ;
$parms{$id} = $value ;
}
my $port = $parms{'port'} ;
delete $parms{'port'} ;
if ( ! $port )
{
print "ERROR: Must specify a 'port=' parameter.\n" ;
return ;
}
$port =~ s/tcpport/TcpPort/i ;
$port =~ s/repport/RepPort/i ;
$port =~ s/udpport/UdpPort/i ;
$port =~ s/serialport/SerialPort/i ;
if ( $port !~ /^(Tcp|Udp|Rep|Serial)Port(\d+)/ )
{
print "ERROR: Bad Port Name '$port'.\n" ;
return ;
}
my $protocol = lc( $1 ) ;
my $portnum = $2 ;
if ( ($protocol eq 'serial')
? ( $portnum < 1
or $portnum > 4
)
: ( $portnum > 65535
or $portnum < 1024
or $portnum == 8099
or $portnum == 8086
)
)
{
print "ERROR: Bad Port Number '$portnum'.\n" ;
return ;
}
my %allPortData ;
getPortSetup( \%allPortData ) ;
$allPortData{$port}{'protocol'} = $protocol ;
if ($protocol eq 'rep')
{
for my $p ( keys %allPortData )
{
next if ($p eq $port) ;
next if ($p eq 'MetControls') ;
next if ($p eq 'AuthKey') ;
if ($allPortData{$p}{'protocol'} eq 'rep')
{
delete( $allPortData{$p} ) ;
}
}
}
my $service = $parms{'service'} ;
delete $parms{'service'} ;
if (!$service)
{
print "ERROR: Must specify 'service='.\n" ;
return ;
}
$allPortData{$port}{'service'} = $service ;
if ($protocol eq 'udp')
{
my $udpTimeout = $parms{'udptimeout'} || '10' ;
delete $parms{'udptimeout'} ;
if ( $udpTimeout !~ /^(\d+)$/ )
{
print "ERROR: Bad UdpTimeout.\n" ;
return ;
}
$allPortData{$port}{'udptimeout'} = $udpTimeout ;
}
if ( $protocol eq 'udp'
or $protocol eq 'tcp'
or $protocol eq 'rep'
)
{
my $auth = $parms{'clientauth'} || 'no' ;
delete $parms{'clientauth'} ;
if ( $auth !~ /^(yes|no)$/ )
{
print "ERROR: Bad ClientAuth value.\n" ;
return ;
}
$allPortData{$port}{'authenticate'} = ($auth eq 'yes') ;
}
my $enable = $parms{'enable'} || 'yes' ;
delete $parms{'enable'} ;
if ( $enable !~ /^(yes|no)$/ )
{
print "ERROR: Bad Enable value.\n" ;
return ;
}
$allPortData{$port}{'enable'} = ($enable eq 'yes') ;
if ( $protocol eq 'rep' and $service ne 'binex' )
{
print "ERROR: REP ports only support Binex service.\n" ;
return ;
}
if ($service =~ /^(ephemerides|almanacs|svstatus|trimcom)$/)
{
if ($protocol ne 'tcp')
{
print "ERROR: Service $service only allowed on TCP ports.\n" ;
return ;
}
if ($service eq 'trimcom')
{
for my $p ( keys %allPortData )
{
next if ($p eq $port) ;
next if ($p eq 'MetControls') ;
if ($allPortData{$p}{'service'} =~ /trimcom/i)
{
delete( $allPortData{$p} ) ;
}
}
}
}
elsif ($service eq 'rtcm')
{
my $version = $parms{'version'} ;
delete $parms{'version'} ;
if ( !$version
or $version !~ /^(2\.1|2\.2|2\.3|3\.0)$/
)
{
print "ERROR: Bad or missing RTCM version.\n" ;
return ;
}
$allPortData{$port}{'version'} = $version ;
if ( $version ne '3.0' )
{
my $style = $parms{'style'} ;
delete $parms{'style'} ;
if ( !$style
or $style !~ /^(dgps|rtk|dgps_rtk|custom:.*)$/
)
{
print "ERROR: Bad or missing RTCM style.\n" ;
return ;
}
if ($style =~ /^Custom:(.*)$/i)
{
$allPortData{$port}{'rtcmStyle'} = 'Custom:'.$1 ;
for my $type ( split( ',',$1 ) )
{
if ($type !~ /^(1|2|3|9|14|18\+19|22|23\+24|59\.3|59\.13)$/)
{
print "ERROR: Bad RTCM style Custom option '$type'.\n" ;
return ;
}
}
}
else
{
$allPortData{$port}{'rtcmStyle'} = uc($style) ;
}
}
else
{
$allPortData{$port}{'rtcmStyle'} = 'DGPS' ;
}
} # end of rtcm section
elsif ($service eq 'cmr')
{
my $style = $parms{'style'} ;
delete $parms{'style'} ;
if ( !$style
or $style !~ /^(standard|cmrplus)$/
)
{
print "ERROR: Bad or missing CMR style.\n" ;
return ;
}
$allPortData{$port}{'cmrStyle'} = $style ;
} # end of cmr section
elsif ($service eq 'binex')
{
my $interval = $parms{'measinterval'} ;
delete $parms{'measinterval'} ;
$interval = '0' if ( defined( $interval ) and $interval eq 'off' ) ;
if ( (! defined( $interval ))
or $interval !~ /^(\d+|\d+\.\d*|\d*\.\d+)$/
)
{
BadMeasInterval:
print "ERROR: Bad or missing measInterval.\n" ;
return ;
}
$interval += 0 ;
if ($interval == 0 or $interval >= 1.0)
{
goto BadMeasInterval if ( $interval != 0
and $interval != 1
and $interval != 2
and $interval != 5
and $interval != 10
and $interval != 15
and $interval != 30
and $interval != 60
and $interval != 300
and $interval != 600
) ;
$interval = sprintf( '%.0f', $interval ) ;
}
else
{
goto BadMeasInterval if ( $interval != 0.1
and $interval != 0.2
and $interval != 0.5
) ;
$interval = sprintf( '%.1f', $interval ) ;
}
$allPortData{$port}{'interval'} = $interval ;
$interval = 0 ;
if (exists $parms{'metainterval'})
{
$interval = $parms{'metainterval'} ;
delete $parms{'metainterval'} ;
}
$interval = '0' if ($interval eq 'off') ;
if ( $interval != 0
and $interval != 60
and $interval != 300
and $interval != 900
and $interval != 1800
and $interval != 3600
)
{
print "ERROR: Bad metaInterval=$interval.\n" ;
return ;
}
$allPortData{$port}{'metaInterval'} = $interval ;
$interval = 0 ;
if (exists $parms{'sysstatusinterval'})
{
$interval = $parms{'sysstatusinterval'} ;
delete $parms{'sysstatusinterval'} ;
}
$interval = '0' if ($interval eq 'off') ;
if ( $interval != 0
and $interval != 60
and $interval != 300
and $interval != 900
and $interval != 1800
and $interval != 3600
)
{
print "ERROR: Bad sysStatusInterval=$interval.\n" ;
return ;
}
$allPortData{$port}{'statusInterval'} = $interval ;
my $value = 'never' ;
if (exists $parms{'7f03clockoffsets'})
{
$value = $parms{'7f03clockoffsets'} ;
delete $parms{'7f03clockoffsets'} ;
}
if ($value eq 'always')
{
$allPortData{$port}{'7f03RxClkOfsAlways'} = 1 ;
$allPortData{$port}{'7f03RxClkOfsRollover'} = 0 ;
}
elsif ($value eq 'onrollover')
{
$allPortData{$port}{'7f03RxClkOfsAlways'} = 0 ;
$allPortData{$port}{'7f03RxClkOfsRollover'} = 1 ;
}
elsif ($value eq 'never')
{
$allPortData{$port}{'7f03RxClkOfsAlways'} = 0 ;
$allPortData{$port}{'7f03RxClkOfsRollover'} = 0 ;
}
else
{
print "ERROR: Bad 7f03ClockOffsets=$value.\n" ;
return ;
}
my %yesNoOptions =  (
'7f02'             => '7f02',
'7f03'             => '7f03',
'mettilt'          => 'metTilt',
'smoothcarrier'    => 'smoothing',
'7f03dopplers'     => '7f03Doppler',
'7f03slips'        => '7f03Slips',
'metasitedesc'     => 'siteDesc',
'metastnid'        => 'stationID',
'metarcvrtype'     => 'rcvrType',
'metarinexrcvr'    => 'rcvrNumber',
'metafirmware'     => 'firmwareVersion',
'metaantxyz'       => 'antXYZ',
'metaantoffset'    => 'antOffset',
'metarinexant'     => 'antNum',
) ;
for my $pname ( keys %yesNoOptions )
{
$value = ( $pname ne 'mettilt' ? 'no' : 'yes') ;
if (exists $parms{$pname})
{
$value = $parms{$pname} ;
delete $parms{$pname} ;
}
if ($value ne 'yes' and $value ne 'no')
{
print "ERROR: Bad value in $pname=$value.\n" ;
return ;
}
$allPortData{$port}{ $yesNoOptions{$pname} } = ($value eq 'yes') ;
}
} # end of Binex section
elsif ($service eq 'nmea')
{
my $msg ;
foreach $msg (@nmeaMessages)
{
$allPortData{$port}{$msg} = 0 ;
my $interval = $parms{lc($msg)} ;
if ( defined($interval) )
{
delete $parms{lc($msg)} ;
next if ( $interval eq 'off' ) ;
if ( $interval !~ /^(\d+|\d+\.\d*|\d*\.\d+)$/ )
{
BadNmeaInterval:
print "ERROR: Bad NMEA interval.\n" ;
return ;
}
$interval += 0 ;
next if ($interval == 0) ;
if ($interval >= 1.0)
{
goto BadNmeaInterval if ( $interval != 1
and $interval != 2
and $interval != 5
and $interval != 10
and $interval != 15
and $interval != 30
and $interval != 60
and $interval != 300
and $interval != 600
) ;
$interval = sprintf( '%.0f', $interval ) ;
}
else
{
goto BadNmeaInterval if ( $interval != 0.1
and $interval != 0.2
and $interval != 0.5
) ;
$interval = sprintf( '%.1f', $interval ) ;
}
$allPortData{$port}{$msg} = $interval ;
}
}
}
elsif ($service eq 'rt17')
{
my $interval = $parms{'interval'} ;
delete $parms{'interval'} ;
if ( !$interval
or $interval !~ /^(\d+|\d+\.\d*|\d*\.\d+)$/
)
{
BADRT17INTERVAL:
print "ERROR: Bad or missing RT17 interval.\n" ;
return ;
}
$interval += 0 ;
if ($interval == 0 or $interval >= 1.0)
{
goto BADRT17INTERVAL if ( $interval != 1
and $interval != 2
and $interval != 5
and $interval != 10
and $interval != 15
and $interval != 30
and $interval != 60
and $interval != 300
and $interval != 600
) ;
$interval = sprintf( '%.0f', $interval ) ;
}
else
{
goto BADRT17INTERVAL if ( $interval != 0.1
and $interval != 0.2
and $interval != 0.5
) ;
$interval = sprintf( '%.1f', $interval ) ;
}
$allPortData{$port}{'interval'} = $interval ;
for my $p ( qw( measurements positions concise iodeslips
gpsdata rawgps rawwaas smoothcarrier smoothcode
record27 )
)
{
my $value = $parms{$p} ;
if ( $value )
{
delete $parms{$p} ;
}
else
{
if ( $p eq 'measurements'
or $p eq 'concise'
or $p eq 'iodeslips'
or $p eq 'gpsdata'
)
{
$value = 'yes'
}
else
{
$value = 'no' ;
}
}
if ($value ne 'yes' and $value ne 'no')
{
print "ERROR: Parameter $p must be yes or no..\n" ;
return ;
}
my $index = $p ;
$index = "useRt27" if ($index eq 'record27') ;
$allPortData{$port}{$index} = ($value eq 'yes') ? 1 : 0 ;
}
if ( ! $allPortData{$port}{'measurements'}
and ! $allPortData{$port}{'positions'}
)
{
print "ERROR: RT17 Must enable measurements or positions.\n" ;
return ;
}
if ( $allPortData{$port}{'smoothcarrier'}
and ($allPortData{$port}{'interval'} < 1.0)
)
{
print "ERROR: Can't smooth carrier on high rate data.\n" ;
return ;
}
} # end of rt17 section
elsif ($service eq 'met')
{
if ($protocol ne 'serial')
{
print "ERROR: Met service only allowed on serial ports.\n" ;
return ;
}
my $commandFound = 0 ;
for my $n ( 1..6 )
{
my $cmd = $parms{ "cmd$n" } ;
if (defined $cmd)
{
delete $parms{"cmd$n"} ;
$cmd =~ s/^0+(\d)/$1/ ;
if ( $cmd =~ /^off$/i )
{
$cmd = "off" ;
}
elsif ( $cmd =~
/^(once|0|1|5|10|15|30|60|120|240):.*$/i
)
{
}
elsif ( $cmd =~ /^(1S|5S|15S|30S):.*$/i )
{
$cmd =~ s/^(\d+)s:/$1S:/ ;
}
else
{
printf( "ERROR: Invalid Met command string, %s.\n", $cmd ) ;
return ;
}
if (!$commandFound)
{
$commandFound = 1 ;
$allPortData{'MetControls'}{1} = 'off' ;
$allPortData{'MetControls'}{2} = 'off' ;
$allPortData{'MetControls'}{3} = 'off' ;
$allPortData{'MetControls'}{4} = 'off' ;
$allPortData{'MetControls'}{5} = 'off' ;
$allPortData{'MetControls'}{6} = 'off' ;
}
$allPortData{'MetControls'}{$n} = $cmd ;
}
}
for my $p ( qw( SerialPort1 SerialPort2 SerialPort3 SerialPort4 ) )
{
next if ($p eq $port) ;
if ($allPortData{$p}{'service'} =~ /met/i)
{
$allPortData{$p}{'service'} = 'ppp' ;
}
}
} # end of Met section
elsif ($service eq 'ppp')
{
if ($protocol ne 'serial')
{
print "ERROR: PPP Service only allowed on serial ports.\n" ;
return ;
}
for my $p ( qw( localip remoteip ) )
{
my $value = $parms{$p} ;
delete $parms{$p} ;
if ( !$value
or $value !~ /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/
or $1 > 255
or $2 > 255
or $3 > 255
or $4 > 255
)
{
print "ERROR: Bad or missing $p parameter.\n" ;
return ;
}
$allPortData{$port}{$p} = $value ;
}
my $connection = $parms{'connection'} ;
delete $parms{'connection'} ;
if (!$connection
or ( $connection ne 'modem'
and $connection ne 'direct'
)
)
{
print "ERROR: Bad or missing 'connection' parameter.\n" ;
return ;
}
$allPortData{$port}{'connection'} = $connection ;
if ($connection eq 'modem')
{
for my $p ( qw( init1 init2 init3 reset ) )
{
my $value = $parms{$p} || '' ;
delete $parms{$p} ;
$allPortData{$port}{$p} = $value ;
}
}
my $toggle = $allPortData{$port}{'ppptoggle'} || 1 ;
$allPortData{$port}{'ppptoggle'} = ( ($toggle == 1) ? 10 : 1 ) ;
} # end of ppp section
else
{
print "ERROR: Unknown service type '$service'.\n" ;
return ;
}
if ($protocol eq 'serial')
{
my $baud = $parms{'baud'} || '' ;
delete $parms{'baud'} ;
unless ( $baud == 2400
or $baud == 4800
or $baud == 9600
or $baud == 19200
or $baud == 38400
or $baud == 57600
or $baud == 115200
)
{
print "ERROR: Bad or missing baud parameter.\n" ;
return ;
}
my $parity ;
if ($service ne 'ppp')
{
$parity = $parms{'parity'} || '' ;
delete $parms{'parity'} ;
unless ( $parity eq 'none'
or $parity eq 'even'
or $parity eq 'odd'
)
{
print "ERROR: Bad or missing parity parameter.\n" ;
return ;
}
}
my $flow = $parms{'flow'} || '';
delete $parms{'flow'} ;
$flow = 'none' if ( $port eq 'SerialPort1' and $flow eq '' ) ;
unless ( $flow eq 'none'
or $flow eq 'hardware'
or $flow eq 'xonxoff'
)
{
print "ERROR: Bad or missing flow parameter.\n" ;
return ;
}
if ( $port eq 'SerialPort1' and $flow ne 'none' )
{
print
"ERROR: Can't specify $flow flow control for SerialPort1.\n" ;
return ;
}
if ($service eq 'ppp' and $flow eq 'xonxoff')
{
print "ERROR: No Xon/Xoff flow control on PPP ports.n" ;
return ;
}
if ($service ne 'ppp')
{
$allPortData{$port}{'baud'} = $baud ;
$allPortData{$port}{'parity'} = $parity ;
$allPortData{$port}{'flow'} = $flow ;
}
else
{
$allPortData{$port}{'pppbaud'} = $baud ;
$allPortData{$port}{'pppflow'} = $flow ;
}
} # Non-PPP serial port parameters
if ( (scalar(keys %parms)) != 0 )
{
print "ERROR: Excess parameters:",
join( ',', keys(%parms) ),
".\n" ;
return ;
}
if ($service eq 'ppp')
{
savePppConfig( \%allPortData ) ;
}
if ($service eq 'met')
{
saveMetConfig( \%allPortData ) ;
}
saveGpssdConfig( \%allPortData ) ;
print "OK: " ;
ShowIOport( "port=$port" ) ;
}
sub DownloadLoggedFile
{
if ( scalar( @_ ) == 0 )
{
plainTextHeader() ;
print "ERROR: Too Few Parameters.\n" ;
return ;
}
if ( scalar( @_ ) > 1 )
{
plainTextHeader() ;
print "ERROR: Too Many Parameters.\n" ;
return ;
}
my $path = $_[0] ;
$path =~ s/^path=//i ;
$path =~ s/^([^\/])/\/$1/ ;
my $fullPath = "/var/gps$path" ;
if ( ! -f $fullPath )
{
plainTextHeader() ;
print "ERROR: File $path does not exist.\n" ;
return ;
}
sendBinaryFile( $fullPath ) ;
}
sub ShowLoggingStatus
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my $gpsTime = time() - 315964800 + 13 ;
my %sessData ;
getSessionData( \%sessData ) ;
my @ActiveSessions = () ;
for my $f (glob '/var/run/gpslog.*')
{
if ( $f !~ /[^\w\.]/
and open( LOG,  $f )
)
{
my $line = <LOG> ;
if ($line)
{
push @ActiveSessions, $line ;
}
close LOG ;
}
}
print "<Show LoggingStatus>\n" ;
my $maxSessionName = 0 ;
for my $name (keys %sessData)
{
$maxSessionName = length($name)
if length( $name ) > $maxSessionName ;
}
for my $name (sort keys %sessData)
{
my $enable = $sessData{$name}{'enable'} ;
my $sched = $sessData{$name}{'sched'} ;
my $time = $sessData{$name}{'time'} ;
my $duration = $sessData{$name}{'duration'} ;
my $status = "" ;
for my $s (@ActiveSessions)
{
my (undef, undef, $sessname, undef, undef, undef,
undef, undef, $fname) = split( ' ', $s ) ;
if ($sessname eq $name)
{
$fname =~ s|^/var/gps|| ;
$status = "Logging file=$fname" ;
last ;
}
}
if ( ! $status )
{
if ( $sched eq 'cont'
or $sched eq 'daily'
)
{
$status = $enable ? 'Pending' : 'Disabled' ;
}
elsif ( $sched eq 'once' )
{
$status = (! $enable)
? 'Disabled'
: ( $gpsTime >= ($time + $duration*60) )
? 'Completed'
: 'Pending' ;
}
else
{
$status = ( $gpsTime >= ($time + $duration*60) )
? 'completed'
: ($enable)
? 'pending'
: 'disabled' ;
}
}
printf "Session name=%-${maxSessionName}s status=%s\n",
$name,
$status ;
}
print "<end of Show LoggingStatus>\n" ;
}
sub ShowPosition
{
print "<Show Position>\n" ;
open( SYSINFO, '/usr/local/fireball/sysinfo -p pos_info |' ) ;
my ($seconds, $week) = (0,0) ;
my ($latitude, $longitude, $altitude ) = (0,0,0) ;
my @svsUsed = "None" ;
my ($pdop, $hdop, $vdop, $tdop) = (0,0,0,0) ;
my ($velE, $velN, $velUp) = (0,0,0) ;
my ($clockOffset, $clockDrift) = (0,0) ;
my ($posType, $posCorrections) = ("old", "Autonomous") ;
my $warning = '' ;
my $line = <SYSINFO> ;
chomp $line ;
if ($line !~ /^OK/)
{
$line =~ s/[,:]//g ;
($seconds, $week, $latitude, $longitude, $altitude)
= split(' ',$line) ;
@svsUsed = split( ' ', <SYSINFO> ) ;
($pdop, $hdop, $vdop, $tdop) = split( ' ', <SYSINFO> ) ;
($velE, $velN, $velUp) = split( ' ', <SYSINFO> ) ;
($clockOffset, $clockDrift) = split( ' ', <SYSINFO> ) ;
$clockOffset /= 2.99792458e5 ;
$clockDrift /= 2.99792458e2 ;
($posType, $posCorrections) = split( ' ', <SYSINFO> ) ;
if ($posType eq 'old' )
{
$posType = 'OLD' ;
@svsUsed = () ;
}
$posCorrections = 'Autonomous'
if ($posCorrections eq 'autonomous') ;
$posCorrections =~ s/_/-/ ;
}
close(SYSINFO) ;
my $format = "%-11s %s\n" ;
printf $format, 'GpsWeek', $week ;
printf $format, 'WeekSeconds', $seconds ;
printf $format, 'Latitude', $latitude.' deg' ;
printf $format, 'Longitude', $longitude.' deg' ;
printf $format, 'Altitude', $altitude.' meters' ;
printf $format, 'Qualifiers', "WGS84,$posType,$posCorrections" ;
printf $format, 'Satellites',
join( ',', sort( {$a <=> $b} @svsUsed ) ) ;
printf $format, 'ClockOffset', sprintf( "%.6f msec", $clockOffset ) ;
printf $format, 'ClockDrift', sprintf( "%.6f ppm", $clockDrift ) ;
printf $format, 'VelNorth', sprintf( "%5.2f m/sec", $velN ) ;
printf $format, 'VelEast', sprintf( "%5.2f m/sec", $velE ) ;
printf $format, 'VelUp', sprintf( "%5.2f m/sec", $velUp ) ;
printf $format, 'PDOP', $pdop ;
printf $format, 'HDOP', $hdop ;
printf $format, 'VDOP', $vdop ;
printf $format, 'TDOP', $tdop ;
print "<end of Show Position>\n" ;
}
sub SetFirmwareWarranty
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $code = $_[0] ;
$code =~ s/^code=//i ;
if ($code !~ /^\w{16}$/ )
{
print "ERROR: Warranty code must have 16 characters.\n" ;
return ;
}
my $result = system( "/usr/bin/sudo /usr/local/fireball/warranty -f"
. $code ) ;
if ($result != 0)
{
print "ERROR: Invalid warranty code.\n" ;
return ;
}
print "OK: " ;
ShowFirmwareWarranty() ;
}
sub ShowLoggedFileStats
{
return if ( badParmCount( scalar( @_ ), 0, 1 ) ) ;
my $path= $_[0] ;
if ($path)
{
$path =~ s/^directory=//i ;
$path =~ s/^([^\/])/\/$1/ ;
if ( ! -d "/var/gps$path"
|| $path =~ m|//|
|| $path =~ m/\.\./
|| $path =~ m|/incoming|
|| $path =~ m|/tmp|
)
{
print "ERROR: Can't find directory '$path'\n" ;
return ;
}
}
else
{
$path = '/' ;
}
my $availSpace = ( split " ", qx( df /var/gps ) )[10] ;
$availSpace /= 1000.0 ;
my @dataFiles ;
if ($path ne '/')
{
@dataFiles=qx( find /var/gps$path -type f ) ;
}
else
{
@dataFiles=qx( find /var/gps/2* -type f ) ;
}
my $fileCount = scalar( @dataFiles ) ;
my $usedSpace = 0 ;
for my $f (sort @dataFiles)
{
chomp $f ;
my $size = int( ((-s $f)+1023)/1024 ) ;
$usedSpace += $size ;
}
$usedSpace /= 1024 ;
printf "LoggedFileStats directory=%s "
."fileCount=%d "
."MbytesUsed=%.3f MbytesAvailable=%.3f\n",
$path,
$fileCount,
$usedSpace,
$availSpace
;
}
sub ShowUtcTime
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my ($sec, $min,$hour, $mday, $month, $year, $wday, $yday, undef)
= gmtime() ;
$year += 1900 ;
++$month ;
++$yday ;
print "UtcTime year=$year month=$month day=$mday",
" hour=$hour minute=$min second=$sec",
" julianDay=$yday",
"\n" ;
}
sub ShowGpsTime
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my $gpsTime = time() - 315964800 + 13 ;
my $weeks = int( $gpsTime / 604800.0 ) ;
my $weekseconds = int( $gpsTime ) % 604800 ;
print "GpsTime gpsweek=$weeks weekseconds=$weekseconds\n" ;
}
sub ShowGpsUtcData
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
print "<Show GpsUtcData>\n" ;
open( SYSINFO,
"/usr/bin/sudo /usr/local/fireball/sysinfo -p utc_data |"
) ;
$_ = <SYSINFO> ;
while ( ($_ = <SYSINFO>) !~ '^OK' )
{
print $_ ;
}
close( SYSINFO ) ;
print "<end of Show GpsUtcData>\n" ;
}
sub ShowGpsIonoData
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
print "<Show GpsIonoData>\n" ;
open( SYSINFO,
"/usr/bin/sudo /usr/local/fireball/sysinfo -p iono_data |"
) ;
$_ = <SYSINFO> ;
while ( ($_ = <SYSINFO>) !~ '^OK' )
{
print $_ ;
}
close( SYSINFO ) ;
print "<end of Show GpsIonoData>\n" ;
}
sub ShowGpsEphemeris
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $prn = $_[0] ;
$prn =~ s/^prn=//i ;
if ( $prn !~ /^\d{1,2}$/
|| $prn == 0
|| $prn > 32
)
{
print "ERROR: Invalid PRN number\n" ;
return ;
}
print "<Show GpsEphemeris prn=$prn>\n" ;
open( SYSINFO,
"/usr/bin/sudo /usr/local/fireball/sysinfo -p eph_data $prn |"
) ;
$_ = <SYSINFO> ;
while ( ($_ = <SYSINFO>) !~ '^OK' )
{
print $_ ;
}
close( SYSINFO ) ;
print "<end of Show GpsEphemeris prn=$prn>\n" ;
}
sub ShowGpsAlmanac
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $prn = $_[0] ;
$prn =~ s/^prn=//i ;
if ( $prn !~ /^\d{1,2}$/
|| $prn == 0
|| $prn > 32
)
{
print "ERROR: Invalid PRN number\n" ;
return ;
}
print "<Show GpsAlmanac prn=$prn>\n" ;
open( SYSINFO,
"/usr/bin/sudo /usr/local/fireball/sysinfo -p alm_data $prn |"
) ;
$_ = <SYSINFO> ;
while ( ($_ = <SYSINFO>) !~ '^OK' )
{
print $_ ;
}
close( SYSINFO ) ;
print "<end of Show GpsAlmanac prn=$prn>\n" ;
}
sub ShowRefStation
{
return if ( badParmCount( scalar( @_ ), 0, 1 ) ) ;
my $style = lc($_[0] || 'llh') ;
$style =~ s/^style=//i ;
if ($style ne 'llh' and $style ne 'xyz')
{
print "ERROR: Style must be 'llh' or 'xyz'.\n" ;
return ;
}
my %refStationData ;
getRefStationData( \%refStationData ) ;
print "RefStation " ;
if ($style eq 'llh')
{
print "lat=$refStationData{'lat'} ",
"lon=$refStationData{'lon'} ",
"height=$refStationData{'height'}" ;
}
else
{
printf "x=%.4f y=%.4f z=%.4f",
$refStationData{'x'},
$refStationData{'y'},
$refStationData{'z'} ;
}
my $name=$refStationData{'cmrStationName'} ;
$name =~ s/'/\\'/g ;
my $desc = $refStationData{'rtcmdesc'} ;
$desc =~ s/'/\\'/g ;
print " RtcmId=",$refStationData{'rtcmid'},
" BinexId=",$refStationData{'binexid'},
" CmrId=",$refStationData{'cmrid'},
" CmrStationName='$name'",
" Description='$desc'\n" ;
}
sub SetRefStation
{
my %refStationData ;
getRefStationData( \%refStationData ) ;
my $style = '' ;
my %parms ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter $p\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
$id = lc($id) ;
$parms{$id} = $value ;
if ($id =~ /^(lat|lon|height)$/)
{
if ($style eq 'xyz')
{
NOMIX:
print "ERROR: can't mix llh and xyz.\n" ;
return ;
}
if ( $value !~ /^[+-]?\d+\.?\d*$/ )
{
BADNUM:
print "ERROR: Bad numeric value '$value'.\n" ;
return ;
}
$style = 'llh' ;
$refStationData{'lat'} = $value if ($id eq 'lat') ;
$refStationData{'lon'} = $value if ($id eq 'lon') ;
$refStationData{'height'} = $value if ($id eq 'height') ;
}
elsif ($id =~ /^(x|y|z)$/)
{
goto NOMIX if ($style eq 'llh') ;
goto BADNUM if ( $value !~ /^[+-]?\d+\.?\d*$/ ) ;
$style = 'xyz' ;
$refStationData{$id} = $value ;
}
elsif ($id eq 'rtcmid')
{
if ( $value !~ /^\d{1,4}$/
or $value > 1023
)
{
print "ERROR: RtcmID must be numeric < 1024.\n" ;
return ;
}
$refStationData{'rtcmid'} = $value ;
}
elsif ($id eq 'cmrid')
{
if ( $value !~ /^\d{1,4}$/
or $value > 31
)
{
print "ERROR: CmrID must be numeric < 32.\n" ;
return ;
}
$refStationData{'cmrid'} = $value ;
}
elsif ( $id eq 'name'
or $id eq 'cmrstationname'
)
{
$refStationData{'cmrStationName'} = $value ;
}
elsif ( $id eq 'binexid')
{
$refStationData{'binexid'} = $value ;
}
elsif ($id eq 'description')
{
$refStationData{'rtcmdesc'} = $value ;
}
else
{
print "ERROR: Invalid Parameter type '$id'.\n" ;
return ;
}
}
if ( $style eq 'llh'
and ( !$parms{'lat'}
or !$parms{'lon'}
or !$parms{'height'}
)
or $style eq 'xyz'
and ( !$parms{'x'}
or !$parms{'y'}
or !$parms{'z'}
)
)
{
print "ERROR: Missing position coordinate.\n" ;
return ;
}
$style = 'llh' if !$style ;
updateRefStationData( \%refStationData, ($style eq 'xyz') ) ;
print "OK: " ;
ShowRefStation( "style=$style" ) ;
}
sub ShowNtpClient
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my @servers = getNtpServers() ;
print "NTPclient " ;
if (@servers)
{
print "enable=yes servers=",
join( ',', @servers ),
"\n" ;
}
else
{
print "enable=no\n" ;
}
}
sub SetNtpClient
{
return if ( badParmCount( scalar( @_ ), 1, 2 ) ) ;
my @servers = () ;
my $enable = '' ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter '$p'\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
$id = lc($id) ;
if ($id eq 'enable')
{
$enable = lc($value) ;
if ($enable !~ /^(yes|no)$/)
{
BADPARM:
print "ERROR: bad parameter '$p'\n" ;
return ;
}
}
elsif ($id eq 'servers')
{
@servers = split( ',', $value ) ;
goto BADPARM if ($value =~ / / ) ;
}
else
{
goto BADPARM ;
}
}
if (@servers and $enable eq 'no')
{
print "ERROR: Can't disable and specify servers.\n" ;
return ;
}
if ( $enable eq 'yes' and !@servers)
{
print "ERROR: Must specify servers to enable.\n" ;
return ;
}
if (scalar(@servers) > 3)
{
print "ERROR: More than three servers.\n" ;
return ;
}
saveNtpServers( @servers ) ;
print "OK: " ;
ShowNtpClient() ;
}
sub ShowIoStatus
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my @clients = getIoStatus() ;
print "<Show IOstatus>\n" ;
for (my $c = 0 ; $c < @clients ; ++$c )
{
my $name = $clients[$c]{'name'} ;
my $service = $clients[$c]{'service'} ;
next if ( $service eq 'metdata' ) ;
print "IOport name=$name service=$service" ;
print " remoteIP=$clients[$c]{'ip'}" if ($name !~ /Serial/) ;
print "\n" ;
}
print "<end of Show IOstatus>\n" ;
}
sub ShowL2Tracking
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
$_ = qx( /usr/local/fireball/sysinfo -p l2_mode ) ;
chomp ;
my (undef, undef, $L2state) = split( " ", $_ ) ;
print "L2Tracking mode=",
( ($L2state eq 'enigma')
? "Y\n"
: ($L2state eq 'l2c_or_enigma')
? "CorY\n"
: ($L2state eq 'l2c_and_enigma')
? "CandY\n"
: "Off\n"
) ;
}
sub SetL2Tracking
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $newstate = lc( $_[0] ) ;
$newstate =~ s/^mode=// ;
if ($newstate !~ m/^(off|y|cory|candy)$/)
{
print "ERROR: invalid parameter $_[0]\n" ;
return ;
}
newStingerConfig( 'put l2_mode '
. ( ($newstate eq 'y')
? "enigma\n"
: ($newstate eq 'cory')
? "l2c_or_enigma\n"
: ($newstate eq 'candy')
? "l2c_and_enigma\n"
: "off\n"
)
) ;
print "OK: " ;
ShowL2Tracking() ;
}
sub ShowL2C
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
ShowL2Tracking() ;
}
sub SetL2C
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
my $newstate = lc( $_[0] ) ;
$newstate =~ s/^enable=// ;
if ($newstate !~ m/^(yes|no)$/)
{
print "ERROR: invalid parameter $_[0]\n" ;
return ;
}
SetL2Tracking( ($newstate eq 'yes')
? "CorY"
: "Y"
)  ;
}
sub ShowAutodelete
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %autoDeleteControls ;
getAutoDeleteControls( \%autoDeleteControls ) ;
print "AutoDelete" ;
for my $pool ('Reserved','a'..'z','Default')
{
if (exists $autoDeleteControls{$pool})
{
printf " %s=%d,%s",
$pool,
$autoDeleteControls{$pool}{'size'},
$autoDeleteControls{$pool}{'enable'} ? 'yes' : 'no'
;
}
}
print "\n" ;
}
sub SetAutodelete
{
my $parmCount = scalar( @_ ) ;
return if ( badParmCount( $parmCount, 1, 100 ) ) ;
my %autoDeleteControls ;
$autoDeleteControls{'Reserved'}{'size'} = 1 ;
$autoDeleteControls{'Reserved'}{'enable'} = 0 ;
for my $p (@_)
{
$p = lc($p) ;
if ($p =~ /^enable=(yes|no)$/ )
{
if ( $parmCount > 1)
{
print "ERROR: Bad parameter combination.\n" ;
return ;
} ;
$autoDeleteControls{'Reserved'}{'enable'} = ($1 eq 'yes') ;
goto DONE ;
}
if ( $p !~ /^(reserved|default|[a-z])=(\d+),(yes|no)$/ )
{
print "ERROR: Bad parameter format: $p" ;
return ;
}
my( $pool, $size, $enable) = ($1, $2, $3) ;
$pool = 'Default' if ($pool eq 'default') ;
$pool = 'Reserved' if ($pool eq 'reserved') ;
if ($size == 0)
{
print "ERROR: AutoDelete threshold must be > 0." ;
return ;
}
$autoDeleteControls{$pool}{'enable'} = ($enable eq 'yes') ;
$autoDeleteControls{$pool}{'size'} = $size ;
}
DONE:
saveAutoDeleteControls( \%autoDeleteControls ) ;
print "OK: " ;
ShowAutodelete() ;
}
sub ShowLoggedFilePools
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %poolStatus ;
getPoolStatus( \%poolStatus ) ;
print "<Show LoggedFilePools>\n" ;
for my $pool ('a'..'z','Default')
{
if (exists( $poolStatus{$pool} ) )
{
my $ad = $poolStatus{$pool}{'ad'} eq 'yes' ;
my $size = $poolStatus{$pool}{'size'}/1000000 ;
my $maxSize = $poolStatus{$pool}{'maxsize'}/1000000 ;
my $full = ( ( ! $ad ) && ($size >= $maxSize) ) ;
printf "pool=%-7s files=%-3d size=%-5.1f maxSize=%-3.0f "
."autoDelete=%-3s full=%s\n",
$pool,
$poolStatus{$pool}{'files'},
$size,
$maxSize,
($ad ? 'Yes' : 'No'),
($full ? 'Yes' : 'No'),
;
}
}
print "<end of Show LoggedFilePools>\n" ;
}
sub ShowClientAuthKey
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %allPortData ;
getPortSetup( \%allPortData ) ;
print "ClientAuthKey key=$allPortData{'AuthKey'}\n" ;
}
sub SetClientAuthKey
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
$_ = $_[0] ;
my $key ;
if ( m/^key=([0-9a-f]{16})$/i )
{
$key = lc($1) ;
}
elsif ( m/^clearkey=(.{7})$/i )
{
$key = qx( /usr/local/fireball/makeKey $1 ) ;
}
else
{
print "ERROR: Invalid parameter $_\n" ;
return ;
}
my %allPortData ;
getPortSetup( \%allPortData ) ;
$allPortData{'AuthKey'} = $key ;
saveGpssdConfig( \%allPortData ) ;
print "OK: " ;
ShowClientAuthKey() ;
}
sub ShowIpFiltering
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %iptablesSetup ;
getIptablesSetup( \%iptablesSetup ) ;
my $rangeCount = $iptablesSetup{'rangeCount'} ;
print "IpFiltering enable=",
$iptablesSetup{'enable'} ? 'yes' : 'no' ;
for ( my $i = 0 ; $i < $rangeCount ; ++$i )
{
print " range",
($i+1),
'=',
$iptablesSetup{'rangeBases'}[$i],
'/',
$iptablesSetup{'rangeBits'}[$i]
;
}
print "\n" ;
}
sub SetIpFiltering
{
return if ( badParmCount( scalar( @_ ), 1, 20 ) ) ;
my %iptablesSetup ;
my $rangeCount = 0 ;
my @rangeBases ;
my @rangeBits ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter '$p'\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
$id = lc($id) ;
$value = lc($value) ;
if ($id eq 'enable')
{
if ($value !~ /^(yes|no)$/)
{
BADPARM:
print "ERROR: bad parameter '$p'\n" ;
return ;
}
$iptablesSetup{'enable'} = ($value eq 'yes' ? 1 : 0) ;
}
elsif ($id =~ '^range\d*$')
{
goto BADPARM if ( !$value ) ;
my $ip = $value ;
my $netmask = 32 ;
if ($value =~ /\/\d{1,2}$/)
{
($ip, $netmask) = $value =~ /^(.*)\/(\d{1,2})$/ ;
}
if ( $ip !~ /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/
or $1 > 255
or $2 > 255
or $3 > 255
or $4 > 255
or $netmask < 8
or $netmask > 32
)
{
print "ERROR: Bad Ip address '$value'\n" ;
return ;
}
push( @rangeBases, $ip ) ;
push( @rangeBits, $netmask ) ;
++$rangeCount ;
}
else
{
goto BADPARM ;
}
}
$iptablesSetup{'rangeCount'} = $rangeCount ;
$iptablesSetup{'rangeBases'} = \@rangeBases ;
$iptablesSetup{'rangeBits' } = \@rangeBits ;
if ( $iptablesSetup{'enable'}
&& $rangeCount == 0
)
{
print "ERROR: IpFiltering must have at least one filter range.\n" ;
return ;
}
saveIptablesSetup( \%iptablesSetup ) ;
print "OK: " ;
ShowIpFiltering() ;
}
sub ShowHttpPorts
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %httpSetup ;
getHttpSetup( \%httpSetup ) ;
print "HttpPorts httpPort80=",
$httpSetup{'httpPort80'} ? 'yes' : 'no',
" httpAltPort=",
$httpSetup{'httpAltEnable'} ? 'yes,' : 'no,',
$httpSetup{'httpAltPort'},
" httpsPort443=",
$httpSetup{'httpsPort443'} ? 'yes' : 'no',
" httpsAltPort=",
$httpSetup{'httpsAltEnable'} ? 'yes,' : 'no,',
$httpSetup{'httpsAltPort'},
"\n" ;
;
}
sub SetHttpPorts
{
return if ( badParmCount( scalar( @_ ), 1, 4 ) ) ;
my %httpSetup ;
getHttpSetup( \%httpSetup ) ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter '$p'\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
$id = lc($id) ;
$value = lc($value) ;
if ($id eq 'httpport80')
{
if ($value !~ /^(yes|no)$/)
{
BADPARM:
print "ERROR: bad parameter '$p'\n" ;
return ;
}
$httpSetup{'httpPort80'} = ($value eq 'yes' ? 1 : 0) ;
}
elsif ($id eq 'httpsport443')
{
if ($value !~ /^(yes|no)$/)
{
goto BADPARM ;
}
$httpSetup{'httpsPort443'} = ($value eq 'yes' ? 1 : 0) ;
}
elsif ($id eq 'httpaltport')
{
if ($value eq 'no')
{
$httpSetup{'httpAltEnable'} = 0 ;
}
elsif ($value =~ /^(yes|no),\d{4,5}$/)
{
my( $enable, $port ) = split( ',', $value ) ;
goto BADPARM if ($port >65535 || $port <1024) ;
$httpSetup{'httpAltEnable'} =  ($enable eq 'yes' ? 1 : 0) ;
$httpSetup{'httpAltPort'} = $port ;
}
else
{
goto BADPARM ;
}
}
elsif ($id eq 'httpsaltport')
{
if ($value eq 'no')
{
$httpSetup{'httpsAltEnable'} = 0 ;
}
elsif ($value =~ /^(yes|no),\d{4,5}$/)
{
my( $enable, $port ) = split( ',', $value ) ;
goto BADPARM if ($port >65535 || $port <1024) ;
$httpSetup{'httpsAltEnable'} =  ($enable eq 'yes' ? 1 : 0) ;
$httpSetup{'httpsAltPort'} = $port ;
}
else
{
goto BADPARM ;
}
}
else
{
goto BADPARM ;
}
}
if ( ! $httpSetup{'httpPort80'}
&& ! $httpSetup{'httpsPort443'}
&& ! $httpSetup{'httpAltEnable'}
&& ! $httpSetup{'httpsAltEnable'}
)
{
print "ERROR: Must have at least one HTTP or HTTPS port enabled.\n";
return ;
}
saveHttpSetup( \%httpSetup ) ;
print "OK: " ;
ShowHttpPorts() ;
}
sub ShowPortAdvertising
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %advertiseControls ;
getAdvertiseControls( \%advertiseControls ) ;
print "PortAdvertising ",
"enable=",
$advertiseControls{'enable'} ? 'yes' : 'no',
" interval=",
$advertiseControls{'interval'}
;
my @ports = @{$advertiseControls{'ports'}} ;
my @IPs = @{$advertiseControls{'IPs'}} ;
for my $i (0..$#ports)
{
printf " target%d=%s:%d", $i+1, $IPs[$i], $ports[$i] ;
}
print "\n" ;
}
sub SetPortAdvertising
{
return if ( badParmCount( scalar( @_ ), 1, 20 ) ) ;
my %advertiseControls ;
$advertiseControls{'ports'} = [] ;
$advertiseControls{'IPs'} = [] ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter '$p'\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
$id = lc($id) ;
$value = lc($value) ;
if ($id eq 'enable')
{
if ($value !~ /^(yes|no)$/)
{
BADPARM:
print "ERROR: bad parameter '$p'\n" ;
return ;
}
$advertiseControls{'enable'} = ($value eq 'yes' ? 1 : 0) ;
}
elsif ($id eq 'interval')
{
if ( $value !~ /^\d{1,5}$/
|| $value > 86400
)
{
goto BADPARM ;
}
$advertiseControls{'interval'} = $value ;
}
elsif ($id =~ '^target\d*$')
{
goto BADPARM if ( !$value ) ;
my ($ip, $port) = $value =~ /^(.*):(\d{1,5})$/ ;
if ( $ip !~ /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/
or $1 > 255
or $2 > 255
or $3 > 255
or $4 > 255
or $port > 65535
)
{
print "ERROR: Bad target address or port '$value'\n" ;
return ;
}
push( @{$advertiseControls{'IPs'}}, $ip ) ;
push( @{$advertiseControls{'ports'}}, $port ) ;
}
else
{
goto BADPARM ;
}
}
if ( ! defined( $advertiseControls{'enable'} ) )
{
print "ERROR: Must define 'enable' parameter.\n" ;
return ;
}
if ( ! defined( $advertiseControls{'interval'} ) )
{
print "ERROR: Must define 'interval' parameter.\n" ;
return ;
}
saveAdvertiseControls( \%advertiseControls ) ;
print "OK: " ;
ShowPortAdvertising() ;
}
sub ShowPppDialout
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my %pppDialoutControls ;
getPppDialoutControls( \%pppDialoutControls ) ;
print "PppDialout",
" papPassword=$pppDialoutControls{'papPw'}" ,
" chapPassword=$pppDialoutControls{'chapPw'}" ;
my $count = 1 ;
my @lines = split( /\n/, $pppDialoutControls{'options'} ) ;
foreach (@lines)
{
chomp ;
print " opt$count='$_'" ;
++$count ;
}
$count = 1 ;
@lines = split( /\n/, $pppDialoutControls{'chatScript'} ) ;
foreach (@lines)
{
chomp ;
s/'/\\'/g ;
print " chat$count='$_'" ;
++$count ;
}
print "\n" ;
}
sub SetPppDialout
{
return if ( badParmCount( scalar( @_ ), 1, 1000 ) ) ;
my %pppDialoutControls ;
getPppDialoutControls( \%pppDialoutControls ) ;
my $newOptions = '' ;
my $newChat = '' ;
for my $p (@_)
{
if ($p !~ /=/)
{
print "ERROR: Must fully specify id=value for parameter '$p'\n" ;
return ;
}
my ($id, $value) = split( '=', $p ) ;
$id = lc($id) ;
my $lcvalue = lc($value) ;
if ($id eq 'pappassword')
{
$pppDialoutControls{'papPw'} = $lcvalue ;
}
elsif ($id eq 'chappassword')
{
$pppDialoutControls{'chapPw'} = $lcvalue ;
}
elsif ($id eq 'clearpappassword')
{
$value = qx( /usr/local/fireball/makeKey $value ) ;
chomp $value ;
$pppDialoutControls{'papPw'} = $value ;
}
elsif ($id eq 'clearchappassword')
{
$value = qx( /usr/local/fireball/makeKey $value ) ;
chomp $value ;
$pppDialoutControls{'chapPw'} = $value ;
}
elsif ($id =~ /^opt\d*$/)
{
$newOptions .= "$value\n" ;
}
elsif ($id =~ /^chat\d*$/)
{
$newChat .= "$value\n" ;
}
else
{
print "ERROR: invalid parameter '$p' \n" ;
return ;
}
}
$pppDialoutControls{'options'} = $newOptions if ( $newOptions ) ;
$pppDialoutControls{'chatScript'} = $newChat if ( $newChat ) ;
savePppDialoutControls( \%pppDialoutControls ) ;
print "OK: " ;
ShowPppDialout() ;
}
sub ShowTop
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
print `/usr/bin/top -b -n 1` ;
}
sub ShowPs
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
print `/bin/ps` ;
}
sub ShowAutoReboot
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my $autoRebootLimit = getAutoRebootLimit() ;
print "AutoReboot seconds=$autoRebootLimit\n" ;
}
sub SetAutoReboot
{
return if ( badParmCount( scalar( @_ ), 0, 1 ) ) ;
if (scalar( @_ ) != 0)
{
my $newLimit = lc( $_[0] ) ;
$newLimit =~ s/^seconds=// ;
if ($newLimit !~ m/^\d+$/)
{
print "ERROR: Invalid parameter $_[0]\n" ;
return ;
}
saveAutoRebootLimit( $newLimit ) ;
}
autoRebootReset() ;
print "OK: " ;
ShowAutoReboot() ;
}
1 ;
