#!/usr/bin/perl -w
use strict ;
no strict 'refs' ;
use CGI qw/:standard/;
use IO::Socket;
use Time::Local ;
use lib '..' ;
use Fireball ;
use Commands ;
my @verbs = qw(
Show
Set
Enable
Disable
Verify
Install
Delete
Reset
Upload
Create
Download
) ;
my @commands = qw(
ShowPps
SetPps
ShowAutodelete
SetAutodelete
ShowClockSteering
SetClockSteering
ShowMultipathReject
SetMultipathReject
ShowElevationMask
SetElevationMask
ShowPdopMask
SetPdopMask
ShowSerialNumber
ShowSystemName
SetSystemName
ShowTemperature
ShowVoltage
ShowFirmwareVersion
ShowFirmwareWarranty
ShowFirmwareFiles
ShowFirmwareFile
VerifyFirmwareFile
InstallFirmwareFile
UploadFirmwareFile
DeleteFirmwareFile
ShowSessions
ShowSession
SetSession
EnableSession
DisableSession
DeleteSession
ShowPowerSaveMode
SetPowerSaveMode
ShowFailsafeWakeup
SetFailsafeWakeup
ShowGpsHealth
ShowGpsSatControls
SetGpsSatControls
ShowTrackingStatus
ShowWaasSatControls
SetWaasSatControls
ShowWaasTracking
SetWaasTracking
ShowReferenceFrequency
SetReferenceFrequency
ShowLoggedFiles
ShowLoggedFile
DeleteLoggedFiles
DeleteLoggedFile
CreateConfigFile
DeleteConfigFile
UploadConfigFile
ShowConfigFile
ShowConfigFiles
InstallConfigFile
ResetSystem
ResetGpsData
ShowFtpSetup
SetFtpSetup
ShowGuiSecurity
SetGuiSecurity
ShowGuiAccount
ShowGuiAccounts
SetGuiAccount
DeleteGuiAccount
ShowAntennaTypes
ShowAntenna
SetAntenna
ShowEthernet
SetEthernet
ShowIOports
ShowIOport
SetIOport
ShowClientAuthKey
SetClientAuthKey
DeleteIOport
ShowUtcTime
ShowGpsTime
ShowLoggedFileStats
ShowLoggedFilePools
SetFirmwareWarranty
ShowPosition
ShowLoggingStatus
DownloadLoggedFile
ShowGpsEphemeris
ShowGpsAlmanac
ShowGpsUtcData
ShowGpsIonoData
ShowRefStation
SetRefStation
ShowNtpClient
SetNtpClient
ShowIoStatus
ShowL2Tracking
SetL2Tracking
ShowL2C
SetL2C
ShowHttpPorts
SetHttpPorts
ShowIpFiltering
SetIpFiltering
ShowPortAdvertising
SetPortAdvertising
ShowPppDialout
SetPppDialout
ShowShutdownVoltage
SetShutdownVoltage
ShowTop
ShowPs
ShowAutoReboot
SetAutoReboot
) ;
sub ShowShutdownVoltage
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
my $vsleep = getVsleep() ;
printf "ShutdownVoltage volts=%.3f\n", $vsleep ;
}
sub SetShutdownVoltage
{
return if ( badParmCount( scalar( @_ ), 1, 1 ) ) ;
if ( $_[0] !~ m/volts=(\d+(.\d*)?)/ )
{
print "ERROR: invalid parameter $_[0]\n" ;
return ;
}
my $vsleep = $1 ;
if ( $vsleep < 10.68
|| $vsleep > 11.4
)
{
print "ERROR: voltage $vsleep outside of range 10.68 to 11.4\n" ;
return ;
}
saveVsleep( $vsleep ) ;
print "OK: " ;
ShowShutdownVoltage() ;
}
sub ShowDummy
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
print "dummy\n" ;
}
sub SetDummy
{
return if ( badParmCount( scalar( @_ ), 0, 0 ) ) ;
print "OK: " ;
dummy() ;
}
my $command = $ENV{'SCRIPT_NAME'} ;
my $query=$ENV{'QUERY_STRING'} ;
$command .= " $query" if ($query) ;
$command =~ s|/prog/|| ;
$command =~ s|&| |g ;
while ($command =~ /(%[0-9a-f]{2})/i)
{
my $c = chr( hex(substr($1, 1 ) ) ) ;
$command =~ s//$c/ ;
}
my $verb;
my $object ;
my $parms ;
($verb, $object, $parms ) =
( $command =~ m/^(\S+)\s+(\S+)\s*(.*)$/) ;
if (! $verb)
{
plainTextHeader() ;
print "ERROR: Invalid command format '$command'\n" ;
goto EXIT ;
}
my $parameters = '' ;
my $inQuotes = 0 ;
$parms =~ s/\\'/\f/g ;
for (my $i = 0 ; $i < length( $parms ) ; ++$i )
{
my $c = substr( $parms, $i, 1 ) ;
if (! $inQuotes)
{
$inQuotes = ($c eq "'" ) ;
$parameters .= $c if ( $c ne "'" ) ;
}
else
{
$c = "\b" if ($c eq ' ') ;
$inQuotes = ($c ne "'" ) ;
$parameters .= $c if ($c ne "'") ;
}
}
$parameters =~ s/\f/'/g ;
my (@parameters) = ( $parameters =~ m/(\S+)/g ) ;
for my $p (@parameters)
{
$p =~ s/[\b]/ /g ;
}
my ($foundVerb) = grep m/^$verb$/i, @verbs ;
if (! $foundVerb )
{
plainTextHeader() ;
print "ERROR: Invalid verb '$verb'\n" ;
goto EXIT ;
}
my ($foundCommand) = grep m/^$verb$object$/i, @commands ;
if (! $foundCommand )
{
plainTextHeader() ;
print "ERROR: Invalid verb/object combination '$verb $object'\n" ;
goto EXIT ;
}
if (exists &$foundCommand)
{
if (lc($verb) ne 'download')
{
plainTextHeader() ;
}
&$foundCommand( @parameters ) ;
}
else
{
plainTextHeader() ;
print "ERROR: No subroutine $foundCommand.  Perhaps not yet implemented.\n" ;
}
EXIT:
