#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/ ;
use lib '..' ;
use Fireball ;
titleWithHelp( 'Security - Accounts',
'/securityAccounts.html'
) ;
my %accounts ;
getGuiAccounts( \%accounts ) ;
my $popupDefault = "New Account" ;
my $error='' ;
if (param())
{
if ( param('restart') )
{
my $restartName = param('restart') ;
if ($restartName eq 'NewAccount')
{
$restartName='New Account' ;
}
CGI::delete_all() ;
$popupDefault=$restartName ;
goto paramDone ;
}
my $pw1 = param('Password1' ) ;
my $pw2 = param('Password2' ) ;
if ( param('account')  and (param('account') eq 'New Account') )
{
my $newname=param('AccountName') ;
$newname =~ s/^ *// ;
$newname =~ s/ *$// ;
if ($newname eq '')
{ $error='An Account Name must be specified' ;
goto paramDone ;
}
elsif ( $newname =~ m/.*[\x00-\x20\x7f-\xff].*/ )
{ $error='This is an invalid Account Name' ;
goto paramDone ;
}
elsif (grep /^$newname$/, keys %accounts )
{ $error='That Account Name is already in use.' ;
goto paramDone ;
}
elsif ( $pw1 eq '' )
{ $error='A Password must be specified.' ;
goto paramDone ;
}
elsif ( $pw1 ne $pw2 )
{ $error='Passwords do not match.' ;
param('Password1','' ) ;
param('Password2','' ) ;
goto paramDone ;
}
$accounts{$newname}{'password'} = makepw( $pw1 ) ;
$accounts{$newname}{'sysadmin'} = ( param('SysAdmin') ? 1 : 0 ) ;
$accounts{$newname}{'gpsadmin'} = ( param('GPSadmin') ? 1 : 0 ) ;
$accounts{$newname}{'fileaccess'} = ( param('FileAccess') ? 1 : 0 );
updateGuiAccounts( \%accounts ) ;
}
elsif ( param('delete') )
{
my $accname = param('delete') ;
if ($accname ne 'sysadmin')
{
delete $accounts{$accname} ;
updateGuiAccounts( \%accounts ) ;
}
}
else
{
my $accname=param('account') ;
$popupDefault=$accname ;
if ( ($pw1 ne '') || ($pw2 ne '') )
{
if ( $pw1 ne $pw2 )
{
$error='Passwords do not match.' ;
param('Password1','' ) ;
param('Password2','' ) ;
goto paramDone ;
}
$accounts{$accname}{'password'} = makepw( $pw1 ) ;
}
$accounts{$accname}{'sysadmin'} = ( param('SysAdmin') ? 1 : 0 ) ;
$accounts{$accname}{'gpsadmin'} = ( param('GPSadmin') ? 1 : 0 ) ;
$accounts{$accname}{'fileaccess'} = ( param('FileAccess') ? 1 : 0 );
$accounts{'sysadmin'}{'sysadmin'} = 1 ;
$accounts{'sysadmin'}{'gpsadmin'} = 1 ;
$accounts{'sysadmin'}{'fileaccess'} = 1 ;
updateGuiAccounts( \%accounts ) ;
}
print h1('Account Changes Accepted.') ;
print '
Switching to Account Information display.
<Script>
setTimeout( \'document.location = "/perl-scripts/sysadmin/accounts.cgi"\',1000) ;
</Script>' ;
print end_html() ;
goto EXIT ;
}
paramDone:
print startform( {name=>'theForm'} ) ;
print <<EOF ;
<Script>
function restart()
/* The account to modify is selected by a popupmenu, which is populated
* with 'New Account' and all of the existing accounts.  When this
/* selector is changed, we re-format the entire screen with that
* particular account's information.  This is triggered by an onChange
* condition on the popup, which calls this javascript function.
* This function calls the cgi script with the special parameter
* 'restart=accountname'.
* In the special case of the 'New Account' item on the popup, we
* send the account name without the space character.  That avoids
* some HTML nasties.
*/
{
selectedIndex=document.theForm.account.selectedIndex ;
selectedName=document.theForm.account.options[selectedIndex].text ;
if (selectedIndex == 0)
selectedName = 'NewAccount' ;
parent.loadDataFrame(
'/perl-scripts/sysadmin/editAccount.cgi?restart='
+ selectedName
) ;
}
function deleteQuery()
/* When the user presses the 'Delete Account' button, this function
* is called.  The name of the account being displayed is extracted from
* the form.  Then a confirmation dialog box is displayed asking if
* that's really what the user wants.  After confirmation we post the
* request by calling the URL with ?delete=acctname as the CGI
* parameter.
*/
{
selectedIndex=document.theForm.account.selectedIndex ;
selectedName=document.theForm.account.options[selectedIndex].text ;
if (confirm( 'Delete Account ' + selectedName ) )
{
parent.loadDataFrame(
'/perl-scripts/sysadmin/editAccount.cgi?delete='
+ selectedName
) ;
}
}
</Script>
EOF
my @values=('New Account') ;
push @values, (sort keys %accounts) ;
print '<Table align=center width=100% >' ;
print Tr( th( {align=>'right'}, 'Select Account' ),
td( {align=>'left'},
popup_menu( -name=>'account',
-values=>\@values,
-onChange=>'restart() ;',
-default=>$popupDefault
) ) ) ;
if ( $popupDefault eq 'New Account' )
{
print Tr( th( {-align=>'right'}, 'Account Name' ),
td( {-align=>'left'},
textfield( 'AccountName', '', 12, 12 ) )
) ;
}
print Tr( th( {-align=>'right'}, 'Password' ),
td( password_field( 'Password1', '', 12, 12 ) )
) ;
print Tr( th( {-align=>'right', -width=>'50%'}, 'Re-Enter Password' ),
td( {-align=>'left', -width=>'50%'},
password_field( 'Password2', '', 12, 12 ) )
) ;
if ( ($popupDefault ne 'sysadmin') )
{
print Tr( th( {rowspan=>3, align=>'right'}, 'Access<br />Rights' ),
td( checkbox( -name=>'SysAdmin',
-value=>'yes',
-label=>' System Controls',
-checked=>($accounts{$popupDefault}{'sysadmin'})
)
)
) ;
print Tr( td( checkbox( -name=>'GPSadmin',
-value=>'yes',
-label=>' GPS Controls',
-checked=>($accounts{$popupDefault}{'gpsadmin'})
)
)
) ;
print Tr( td( checkbox( -name=>'FileAccess',
-value=>'yes',
-label=>' File Access',
-checked=>($accounts{$popupDefault}{'fileaccess'})
)
)
) ;
}
if ( $popupDefault eq 'New Account' )
{
print Tr(
td( {align=>'right'},
submit( 'create', 'Create Account' )
),
td( button( -name=>'reset', -value=>'Reset Form',
-onClick=> "parent.loadDataFrame(
'/perl-scripts/sysadmin/editAccount.cgi?restart=$popupDefault'
) "
)
,
button( -name=>"cancel", -value=>"Cancel",
-onClick=>
'parent.loadDataFrame( "/perl-scripts/sysadmin/accounts.cgi" )'
)
)
) ;
}
else
{
print Tr(
td( table( {width=>"100%"},
td( {align=>'left'},
( $popupDefault ne "sysadmin" )
? button( -name=>"delete",
-value=>"Delete Account",
-onClick=>'deleteQuery();'
)
: " "
) ,
td( {align=>'right'}, submit( 'create',
( $popupDefault ne 'New Account' )
? 'Accept Changes'
: 'Create Account'
)
)
) ),
td( button( -name=>'reset',
-value=>'Reset Form',
-onClick=> "parent.loadDataFrame(
'/perl-scripts/sysadmin/editAccount.cgi?restart=$popupDefault'
)"
) ,
button( -name=>'cancel',
-value=>'Cancel',
-onClick=>
'parent.loadDataFrame( "/perl-scripts/sysadmin/accounts.cgi" )'
)
)
) ;
}
print "\n</Table>\n</Form>\n" ;
if ( length $error )
{
print "<Script>
alert( \"$error\" ) ;
</Script>
" ;
print "$error" ;
}
print end_html() ;
EXIT:
