#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
titleWithHelp( 'Ethernet Configuration',
'/internetEthernetInfo.html'
) ;
my %ethernetSetup ;
getEthernetSetup( \%ethernetSetup ) ;
my $EthMode = $ethernetSetup{ 'ipmode' } ;
my $macAddress = $ethernetSetup{ 'mac' } ;
my $ipAddress = $ethernetSetup{ 'ip' } ;
my $netMask = $ethernetSetup{ 'netmask' } ;
my $gateway = $ethernetSetup{ 'gateway' } ;
my $mtu     = $ethernetSetup{ 'mtu'     } ;
my @results = qx| cat /etc/resolv.conf | ;
my @DnsServers = split( ',', $ethernetSetup{ 'nameServers' } ) ;
my $domain = $ethernetSetup{ 'dnsDomain' } ;
my $searchPath = $ethernetSetup{ 'dnsSearch' } ;
my $mode ;
if (!param())
{
$mode=$EthMode ;
}
else
{
my $NewMode = param( 'Mode' ) ;
my $network ;
my $broadcast ;
my $NewIP ;
my $NewNetmask ;
my $NewGateway ;
my $NewMTU ;
if (param("submissionType") eq "Okay")
{
$ethernetSetup{'ipmode'} = $NewMode ;
if ($NewMode eq 'static')
{
$NewIP = param( 'IP' ) ;
$NewIP = '.'.$NewIP ;
$NewIP =~ s/\.0+(\d+)/.$1/g ;
$NewIP =~ s/^\.// ;
$ethernetSetup{'ip'} = $NewIP ;
$NewNetmask = param( 'Netmask' ) ;
$NewNetmask = '.'.$NewNetmask ;
$NewNetmask =~ s/\.0+(\d+)/.$1/g ;
$NewNetmask =~ s/^\.// ;
$ethernetSetup{'netmask'} = $NewNetmask ;
$NewGateway = param( 'Gateway' ) ;
$NewGateway = '.'.$NewGateway ;
$NewGateway =~ s/\.0+(\d+)/.$1/g ;
$NewGateway =~ s/^\.// ;
$ethernetSetup{'gateway'} = $NewGateway ;
}
$ethernetSetup{ 'mtu' } = param( 'mtu' ) ;
$ethernetSetup{ 'dnsDomain' } = param( 'Domain' ) ;
my $path = param( 'SearchPath' ) ;
$path =~ s/ +/,/ ;
$ethernetSetup{ 'dnsSearch' } = $path ;
my @servers = () ;
if (my $ns = param( 'Nameserver1' ))
{
$ns = '.'.$ns ;
$ns =~ s/\.0+(\d+)/.$1/g ;
$ns =~ s/^\.// ;
push( @servers, $ns ) ;
}
if (my $ns = param( 'Nameserver2' ))
{
$ns = '.'.$ns ;
$ns =~ s/\.0+(\d+)/.$1/g ;
$ns =~ s/^\.// ;
push( @servers, $ns ) ;
}
if (my $ns = param( 'Nameserver3' ))
{
$ns = '.'.$ns ;
$ns =~ s/\.0+(\d+)/.$1/g ;
$ns =~ s/^\.// ;
push( @servers, $ns ) ;
}
$ethernetSetup{ 'nameServers' } = join( ',', @servers ) ;
updateEthernetSetup( \%ethernetSetup ) ;
print <<EOF ;
<h2>Ethernet Configuration Accepted.</h2>
The Ethernet port is now being reconfigured.  This may take
about 15 seconds.
<BR><h3>Warning</h3>
The IP address of the target system may have been changed.  This web
interface may require redirection to a new URL.
<Script>
alert( "Warning\\nA change to the Ethernet configuration may have "+
"disabled the web interface." ) ;
parent.loadAfterDelay( '/perl-scripts/internetEthernet.cgi', 15000) ;
</Script>
EOF
goto EXIT ;
}
}
print <<EOF ;
<Script>
/**********************************************************************/
function modeChange()
/**********************************************************************/
/* One of the mode-selection radio buttons has been clicked.
* This may require us to redraw the screen, but only if the mode has
* been changed in specific ways.
* If mode is changing away from or to static, then an update is
* necessary, because the static IP portions of the form must be
* erased or drawn.  Otherwise, we don't have to change anything.
* This is detected by the javascript variable staticStuffDisplayed,
* which is set true only if the static IP data was sent.  If the
* state of the Static IP checkbox no longer matches the displayed
* form, we reload the data.
* When we submit the form data, we set the value of the hidden field
* "submissionType" to "modeChange" so that the CGI script knows that
* we aren't submitting changes, but rather are updating the form.
*/
{
f=document.theForm ;
if ( f.Mode[1].checked != (staticStuffDisplayed) )
{
f.submissionType.value = "modeChange" ;
parent.submitForm( f, "/perl-scripts/sysadmin/ethernetSetup.cgi" ) ;
}
} /* end of modeChange() */
/**********************************************************************/
function Okay()
/**********************************************************************/
/* Invoked when the OK button is pressed.
* This just submits the entire form with all parameters.
* The hidden field "submisionType" is given a value of Okay so
* that the processing CGI script can tell that we want to accept the
* data for real, instead of just updating the form.
*/
{
df=document.theForm ;
if (df.IP != null)
{
// Remove leading & trailing spaces from the string.
value = df.IP.value = parent.strip(df.IP.value) ;
if ( parent.notValidIP( value ) )
{
alert( "Invalid IP Address : " + value ) ;
return ;
}
}
if (df.Netmask != null)
{
// Remove leading & trailing spaces from the string.
value = df.Netmask.value = parent.strip(df.Netmask.value) ;
if ( parent.notValidIP( value ) )
{
alert( "Invalid Netmask : " + value ) ;
return ;
}
}
if (df.Gateway != null)
{
// Remove leading & trailing spaces from the string.
value = df.Gateway.value = parent.strip(df.Gateway.value) ;
if ( (value != "") && parent.notValidIP( value ) )
{
alert( "Invalid Gateway : " + value ) ;
return ;
}
}
if (df.Nameserver1 != null)
{
// Remove leading & trailing spaces from the string.
value = df.Nameserver1.value = parent.strip(df.Nameserver1.value) ;
if ( (value != "") && parent.notValidIP( value ) )
{
alert( "Invalid Nameserver : " + value ) ;
return ;
}
}
if (df.Nameserver2 != null)
{
// Remove leading & trailing spaces from the string.
value = df.Nameserver2.value = parent.strip(df.Nameserver2.value) ;
if ( (value != "") && parent.notValidIP( value ) )
{
alert( "Invalid Nameserver2 : " + value ) ;
return ;
}
}
if (df.Nameserver3 != null)
{
// Remove leading & trailing spaces from the string.
value = df.Nameserver3.value = parent.strip(df.Nameserver3.value) ;
if ( (value != "") && parent.notValidIP( value ) )
{
alert( "Invalid Nameserver3 : " + value ) ;
return ;
}
}
if (df.mtu != null)
{
// Remove leading & trailing spaces from the string.
value = df.mtu.value = parent.strip(df.mtu.value) ;
if ( parent.isNotAnInteger( value, "MTU" ) )
{
return ;
}
if ( (value < 600) || (value > 1500) )
{
alert( "MTU out of range 600 to 1500" ) ;
return ;
}
}
df.submissionType.value = "Okay" ;
parent.submitForm( df, "/perl-scripts/sysadmin/ethernetSetup.cgi" ) ;
} /* end of Okay() */
</script>
EOF
print startform( -name=>"theForm",
-onSubmit=>'return Okay()'
) ;
my @modeButtons = radio_group( -name=>'Mode',
-value=>['dhcp','static','disable'],
-nolabels=>1,
-default=>$EthMode,
-onClick=>"modeChange() ;"
) ;
print p(), $modeButtons[0], " DHCP" ;
print p(), $modeButtons[1], " Static IP" ;
if ( param("Mode")
? (param("Mode") eq "static")
: ($EthMode eq "static")
)
{
print table(
Tr( td( {align=>"right"}, "IP Address" ),
td( textfield( 'IP', $ipAddress, 15, 15 ) ) ) ,
Tr( td( {align=>"right"}, "MTU" ),
td( textfield( 'mtu', $mtu, 15, 4 ),
'<font size="-2">600 to 1500</font>'
)
),
Tr( td( {align=>"right"}, "Netmask" ),
td( textfield( 'Netmask', $netMask, 15, 15 ) ) ) ,
Tr( td( {align=>"right"}, "Gateway" ),
td( textfield( 'Gateway', $gateway, 15, 15 ) ) ) ,
Tr( td( {align=>"right"}, "Name Server" ),
td( textfield( 'Nameserver1', $DnsServers[0], 15, 15 ))),
Tr( td( {align=>"right"}, "Name Server2" ),
td( textfield( 'Nameserver2', $DnsServers[1], 15, 15 ))),
Tr( td( {align=>"right"}, "Name Server3" ),
td( textfield( 'Nameserver3', $DnsServers[2], 15, 15 ))),
Tr( td( {align=>"right"}, "DNS Domain Name" ),
td( textfield( 'Domain', $domain, 30, 60 ))),
Tr( td( {align=>"right"}, "DNS Search Path" ),
td( textfield( 'SearchPath', $searchPath, 30, 60 ))),
) ;
print "<Script>staticStuffDisplayed = true ; </Script>"
}
else
{
print "<Script>staticStuffDisplayed = false ; </Script>",
br(),
br(),
table(
Tr( td( {align=>"right"}, "MTU" ),
td( textfield( 'mtu', $mtu, 15, 4 ),
'<font size="-2">600 to 1500</font>'
)
),
) ;
}
print p(), b("MAC Address: "), $macAddress, br() ;
print p(),button( -name=>"OK",
-value=>"OK",
-onClick=>"Okay() ;",
) ;
print "&nbsp;" ;
print button( -name=>"Cancel",
-value=>"Cancel",
-onClick=>
'parent.loadDataFrame( "/perl-scripts/internetEthernet.cgi" )'
) ;
print hidden( -name=>"submissionType",
-value=>""
) ;
print endform() ;
EXIT:
print end_html() ;
