#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
titleWithHelp( 'Firmware - Install',
'' # No help button
) ;
my $errorMessage ;
my $testResults ;
my $basename = param('install') ;
my $fname='/var/gps/incoming/'.$basename ;
if ( param('install') )
{
print b( "Installing file $basename" ) ;
}
else
{
$errorMessage = 'No Firmware file to install.' ;
goto ERROR ;
}
if ( ! IsRpmFile( $fname ) )
{
$errorMessage = 'This does not appear to be an RPM file '
.'so it cannot be installed.' ;
goto ERROR ;
}
print p(),b( 'File is an RPM file' ) ;
print p(),b( 'Checking Warranty' ), br() ;
if (!param('phase'))
{
print <<EOF ;
<script>
URL = '/perl-scripts/sysadmin/firmwareInstall.cgi?install='
+ escape( "$basename" )
+ '&phase=1' ;
parent.loadAfterDelay( URL, 1000 ) ;
</script>
EOF
goto EXIT ;
}
my $description ;
if ( underWarranty( $fname, 1, \$description ) )
{
print 'This firmware file is installable under the terms of your '
.'warranty.<p>' ;
}
else
{
$errorMessage = 'This file is dated after your Warranty Expiration '
.'date and cannot be installed.' ;
goto ERROR ;
}
print '<p><b>Verifying the RPM file</b><br />' ;
if (param('phase') eq '1' )
{
print <<EOF ;
<script>
URL = '/perl-scripts/sysadmin/firmwareInstall.cgi?install='
+ escape( "$basename" )
+ '&phase=2' ;
parent.loadAfterDelay( URL, 1000 ) ;
</script>
EOF
goto EXIT ;
}
$testResults  = RpmVerify( $fname ) ;
if ($testResults ne '')
{
$errorMessage = "RPM file is corrupted!" ;
goto ERROR ;
}
else
{
print 'Package verifies okay.<br />' ;
}
$testResults = '' ;
my $patchBase = '' ;
my $installationTime = '200' ;
$installationTime = $1
if ($description =~ m/Expected Installation Time\s*:\s*(\d+)/ );
$patchBase = $1 if ($description =~ m/Patch Base\s*(\S*)/ );
print "Installation time: $installationTime seconds.<br />" ;
if ($patchBase)
{
my( $thisVersion, $thisDate ) = split( "\n",
qx( cat /usr/local/fireball/defaults/firmwareVersion )
) ;
print 'This is a <b>PATCH upgrade</b>.<br />' ;
print table(
Tr( td( 'Required Patch Base:'),
td( b($patchBase) )
),
Tr( td( 'Installed Version:'),
td( b($thisVersion) )
),
) ;
if ( $patchBase ne $thisVersion )
{
$errorMessage =
"Installed firmware version doesn't match patch requirement!" ;
goto ERROR ;
}
}
else
{
print 'This is a FULL upgrade.<br />' ;
}
print '<p><b>Beginning Installation.</b><br />' ;
my $linkName = '/var/gps/incoming/TheRPMtoInstall' ;
if ( -r $linkName )
{
system( "sudo rm $linkName" ) ;
}
link( $fname, $linkName ) ;
print <<EOF ;
<Script>
parent.Filename = "$basename" ;
parent.expectedInstallTime = $installationTime ;
parent.loadAfterDelay( '/installFrame.html', 1000) ;
</Script>
EOF
system( "/usr/bin/sudo /sbin/boot_status 0 255 f" ) ;
my $spid = qx( cat /var/run/frontpanel_task.pid ) ;
system( "(sleep 5 ; /usr/bin/sudo /bin/kill -SIGUSR2 $spid)&" ) ;
goto EXIT ;
ERROR:
if ($errorMessage)
{
print <<EOF ;
<Script>
alert( "$errorMessage" ) ;
</Script>
EOF
print "<p><b>$errorMessage</b>" ;
if ($testResults)
{
print "<br />RPM test results:<pre>$testResults</pre>" ;
}
print startform( -name=>"theForm" ) ;
print button( -name=>'Done',
-value=>'Done',
-onClick=>
'parent.loadDataFrame( "/perl-scripts/firmware.cgi" )'
) ;
print endform() ;
}
EXIT:
print end_html() ;
