#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
titleWithHelp( 'FTP Setup',
'/ftpInfo.html'
) ;
my %ftpSetup ;
getFtpSetup( \%ftpSetup ) ;
my $errorMessage = '' ;
if (!param())
{
param( 'anon', $ftpSetup{'anon'} ) ;
param( 'netrs', $ftpSetup{'named'} ) ;
param( 'admin', $ftpSetup{'admin'} ) ;
param( 'alternatePort', $ftpSetup{'alternatePort'} ) ;
param( 'ftpPort',
($ftpSetup{'ftpEnabled'} eq 'no')
? 'disabled'
: ($ftpSetup{'standardPort'} eq 'yes')
? 'standard'
: 'alternate'
) ;
{
}
}
else
{
$ftpSetup{'anon'}  = param( 'anon' ) ;
$ftpSetup{'named'} = param( 'netrs' ) ;
$ftpSetup{'admin'} = param( 'admin' ) ;
my $ftpPort = param('ftpPort') ;
if ($ftpPort eq 'standard')
{
$ftpSetup{'ftpEnabled'} = 'yes' ;
$ftpSetup{'standardPort'} = 'yes' ;
}
elsif ($ftpPort eq 'alternate')
{
$ftpSetup{'ftpEnabled'} = 'yes' ;
$ftpSetup{'standardPort'} = 'no' ;
}
else
{
$ftpSetup{'ftpEnabled'} = 'no' ;
$ftpSetup{'standardPort'} = 'yes' ;
}
my $port = param( 'alternatePort' ) ;
if ( $ftpSetup{'standardPort'} eq 'no'
and ( $port !~ /^\d+$/
or $port < 1024
or $port > 65535
)
)
{
$errorMessage = 'Alternate port must be 1024 to 65535' ;
goto PARAMDONE ;
}
$ftpSetup{'alternatePort'} = $port + 0 ;
my $pw1 ;
my $pw2 ;
$pw1 = param( 'netrspw1' ) || '' ;
$pw2 = param( 'netrspw2' ) || '' ;
if ( $pw1 or $pw2 )
{
if ($pw1 ne $pw2)
{
$errorMessage = 'netrsFTP Passwords must match.' ;
goto PARAMDONE ;
}
$ftpSetup{'namedPassword'} = makepw( $pw1 ) ;
}
$pw1 = param( 'adminpw1' ) || '' ;
$pw2 = param( 'adminpw2' ) || '' ;
if ( $pw1 or $pw2 )
{
if ($pw1 ne $pw2)
{
$errorMessage = 'adminFTP Passwords must match' ;
goto PARAMDONE ;
}
$ftpSetup{'adminPassword'} = makepw( $pw1 ) ;
}
if ( ($ftpSetup{'named'} ne 'disabled')
and !$ftpSetup{'namedPassword'}
)
{
$errorMessage = 'netrsFTP needs a password.' ;
goto PARAMDONE ;
}
if ( ($ftpSetup{'admin'} ne 'disabled')
and !$ftpSetup{'adminPassword'}
)
{
$errorMessage = 'adminFTP needs a password.' ;
goto PARAMDONE ;
}
saveFtpSetup( \%ftpSetup ) ;
print h3( 'New FTP setup accepted.' ) ;
print h3( ($ftpSetup{'ftpEnabled'} eq 'yes')
? 'Restarting FTP Server.'
: 'FTP Server is disabled.'
) ;
print <<EOF ;
<Script>
parent.loadAfterDelay( "/perl-scripts/ftp.cgi", 2000) ;
</Script>
EOF
goto EXIT ;
}
PARAMDONE:
if ( $errorMessage )
{
print << "EOF" ;
<Script>
alert( "$errorMessage" ) ;
</Script>
EOF
print b( $errorMessage ) ;
}
print startform( -name=>"theForm" ) ;
print '<table border=0>' ;
my @buttons ;
print Tr( td( br(), b("Anonymous FTP") )  ) ;
@buttons=radio_group( -name=>'anon',
-values=>[ 'enabledDelete',
'enabled',
'disabled'
],
-nolabels=>1,
-default=>"enabled",
) ;
print Tr( td( table( {width=>"100%", border=>1},
Tr( td( $buttons[0] ),
td( "<b>Enabled  with Delete</b><br />"
." Anyone using the names 'anonymous' or "
."'ftp' can use FTP to access logged data "
."files.  No password is required."
."<br />Anonymous user <em>can</em> delete "
."files."
)
) ,
Tr( td( $buttons[1] ),
td( "<b>Enabled without Delete</b><br />"
."Anyone using the names 'anonymous' or "
."'ftp' can use FTP to access logged data "
."files.  No password is required.<br />"
."Anonymous user <em>cannot</em> delete "
."files."
)
) ,
Tr( td( $buttons[2]),
td( "<b>Disabled</b><br />
Anonymous FTP is not available." )
)
)
)
);
print Tr( td( br(), b("Named FTP") )  ) ;
print '<tr><td>' ;
@buttons=radio_group( -name=>'netrs',
-values=>[ 'enabledDelete',
'enabled',
'disabled'
],
-nolabels=>1,
-default=>"enabled",
) ;
print table( {width=>"100%", border=>1},
Tr( td( $buttons[0] ),
td( "<b>Enabled  with Delete</b><br />"
."User 'netrsFTP' can access logged data files "
."using FTP and the proper password.<br />"
."User 'netrsFTP' <em>can</em> delete files."
)
) ,
Tr( td( $buttons[1] ),
td( "<b>Enabled without Delete</b><br />"
."User 'netrsFTP' can access logged data files "
."using FTP and the proper password.<br />"
."User 'netrsFTP' <em>cannot</em> delete files."
)
) ,
Tr( td( $buttons[2]),
td( "<b>Disabled</b><br />"
."User 'netrsFTP' cannot use FTP."
)
)
) ;
print '</td><td width="1"></td><td valign="top">' ;
print table( {border=>'0'},
Tr( th( {-align=>'right'}, 'netrsFTP Password' ),
td( password_field( 'netrspw1', '', 12, 12 ) )
),
Tr( th( {-align=>'right'}, 'Re-enter Password' ),
td( password_field( 'netrspw2', '', 12, 12 ) )
),
) ;
print <<EOF ;
<div align="right">
<font size="-1"'>
If both fields are left blank, the
<br /> password will not be changed.</font></div></td>
</tr>
<tr>
<td>
EOF
print Tr( td( br(), b("Administration FTP") )  ) ;
print '<tr><td valign="top">' ;
@buttons=radio_group( -name=>'admin',
-values=>[ 'enabled', 'disabled' ],
-nolabels=>1,
-default=>"enabled",
) ;
print table( {width=>"100%", border=>1},
Tr( td( $buttons[0] ),
td( "<b>Enabled</b><br />
User 'adminFTP' can upload or delete firmware
files, using FTP and the proper password.
"
)
) ,
Tr( td( $buttons[1] ),
td( "<b>Disabled</b><br />
User 'adminFTP' cannot use FTP.
"
)
) ,
) ;
print '</td><td></td><td valign="top">' ;
print table(
Tr( th( {-align=>'right'}, 'adminFTP Password' ),
td( password_field( 'adminpw1', '', 12, 12 ) )
) ,
Tr( th( {-align=>'right'}, 'Re-enter Password' ),
td( password_field( 'adminpw2', '', 12, 12 ) )
)
) ;
print <<EOF ;
<div align="right">
<font size="-1"'>
If both fields are left blank, the
<br /> password will not be changed.</font></div></td>
</tr>
EOF
print Tr( td( br(), b("FTP Server Port") )  ) ;
@buttons=radio_group( -name=>'ftpPort',
-values=>[ 'standard', 'alternate', 'disabled' ],
-nolabels=>1,
) ;
print Tr( td( table( {width=>"100%", border=>1},
Tr( td( $buttons[0] ),
td( "<b>Use Standard Port</b><br />"
."Clients must connect to Port 21"
)
) ,
Tr( td( $buttons[1] ),
td( "<b>Use Alternate Port</b>",
textfield( 'alternatePort',
'',
10,
5
)
)
) ,
Tr( td( $buttons[2] ),
td( "<b>Disable FTP</b>"
)
) ,
)
)
) ;
print "</table>" ;
print p(),button( -name=>'OK',
-value=>'OK',
-onClick=>'parent.submitForm( document.theForm,
"/perl-scripts/sysadmin/ftpConfig.cgi")'
) ;
print "&nbsp;" ;
print button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>
'parent.loadDataFrame( "/perl-scripts/ftp.cgi" )'
) ;
print endform() ;
EXIT:
print end_html() ;
