#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;
titleWithHelp( 'PPP Dialout Configuration',
'/pppDialoutInfo.html'
) ;
my %pppDialoutControls ;
getPppDialoutControls( \%pppDialoutControls ) ;
my $errorMessage = '' ;
if (param())
{
my $pw1;
my $pw2;
$pw1 = param( 'PapPw1' ) || '' ;
$pw2 = param( 'PapPw2' ) || '' ;
if ( $pw1 eq '' && $pw2 eq '' )
{
$pppDialoutControls{'papPw'} = '' ;
}
else
{
if ($pw1 ne $pw2)
{
$errorMessage = 'PAP Passwords must match' ;
goto PARAMDONE ;
}
if ( $pw1 ne 'FaKe PW' )
{
$pw1 =~ s/^ +// ;
$pw1 =~ s/ +$// ;
if ($pw1 =~ /\s/)
{
$errorMessage = 'No spaces allowed in passwords.' ;
goto PARAMDONE ;
}
$pw1 = qx( /usr/local/fireball/makeKey $pw1 ) ;
chomp $pw1 ;
$pppDialoutControls{'papPw'} = $pw1 ;
}
}
$pw1 = param( 'ChapPw1' ) || '' ;
$pw2 = param( 'ChapPw2' ) || '' ;
if ( $pw1 eq '' && $pw2 eq '' )
{
$pppDialoutControls{'chapPw'} = '' ;
}
else
{
if ($pw1 ne $pw2)
{
$errorMessage = 'Chap Passwords must match' ;
goto PARAMDONE ;
}
if ( $pw1 ne 'FaKe PW' )
{
$pw1 =~ s/^ +// ;
$pw1 =~ s/ +$// ;
if ($pw1 =~ /\s/)
{
$errorMessage = 'No spaces allowed in passwords.' ;
goto PARAMDONE ;
}
$pw1 = qx( /usr/local/fireball/makeKey $pw1 ) ;
chomp $pw1 ;
$pppDialoutControls{'chapPw'} = $pw1 ;
}
}
my $text = param( 'options' ) ;
$text =~ s/\r//g ;
$pppDialoutControls{'options'} = $text ;
$text = param( 'chatScript' ) ;
$text =~ s/\r//g ;
$pppDialoutControls{'chatScript'} = $text ;
savePppDialoutControls( \%pppDialoutControls ) ;
print h2( "New Configuration Accepted." ) ;
print <<EOF ;
<Script>
parent.loadAfterDelay( "/perl-scripts/portSummary.cgi", 2000) ;
</Script>
EOF
goto EXIT ;
}
else
{
param( 'options', $pppDialoutControls{'options'} ) ;
param( 'chatScript', $pppDialoutControls{'chatScript'} ) ;
}
PARAMDONE:
if ( $errorMessage )
{
print b( $errorMessage ),br(),br() ;
print << "EOF" ;
<Script>
alert( "$errorMessage" ) ;
</Script>
EOF
}
print startform( -name=>"theForm" ) ;
print '<table>' ;
my $default = ( $pppDialoutControls{'papPw'} )
? 'FaKe PW'
: '' ;
print Tr( td( {align=>'right'}, 'PAP password' ),
td( password_field( 'PapPw1', $default, 12, 28 ),
'<font size="-1">&nbsp;&nbsp;Verify</font>',
password_field( 'PapPw2', $default, 12, 28 ),
),
) ;
$default = ( $pppDialoutControls{'chapPw'} )
? 'FaKe PW'
: '' ;
print Tr( td( {align=>'right'}, 'CHAP password' ),
td( password_field( 'ChapPw1', $default, 12, 28 ),
'<font size="-1">&nbsp;&nbsp;Verify</font>',
password_field( 'ChapPw2', $default, 12, 28 ),
)
) ;
print Tr( td( {valign=>'top', align=>'right'}, 'PPP Options' ),
td(  textarea( -name=>'options',
-rows=>5,
-columns=>30,
-wrap=>'off',
)
)
) ;
print Tr( td( {valign=>'top', align=>'right'}, 'Chat Script' ),
td( textarea( -name=>'chatScript',
-rows=>10,
-columns=>30,
-wrap=>'off',
)
)
) ;
print '</table>' ;
print
"Accepting these parameters with <b>OK</b> will "
."restart any existing PPP Dialout session.",
br(),
"The Serial Port and baudrate to use for PPP Dialout "
."must be set from the Port Configuration pages."
;
print hr() ;
print p(),button( -name=>"OK",
-value=>"OK",
-onClick=>"submit() ;",
) ;
print "&nbsp;" ;
print button( -name=>"Cancel",
-value=>"Cancel",
-onClick=>
'parent.loadDataFrame( "/perl-scripts/portSummary.cgi" )'
) ;
print endform() ;
EXIT:
print end_html() ;
