#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'System Log Files',
'' # No Help
) ;
my $Rootdir='/var/log' ;
my $dirpath = param('dir') ;
if ( ! $dirpath ) {$dirpath = '/'} ;
$dirpath =~ s|[^/\w]|| ;
if ( $dirpath !~ '/$' )
{
$dirpath .= '/' ;
}
my $sortBy = param('sort') ;
if ( (! $sortBy)
|| ( $sortBy ne 'size'
&& $sortBy ne 'time'
&& $sortBy ne 'timer'
&& $sortBy ne 'sizer'
)
)
{
$sortBy = 'name' ;
}
print <<EOF ;
<style type="text/css">
<!--
a {color:blue ; text-decoration: none }
-->
</style>
EOF
print b( "Directory path $Rootdir$dirpath" ) ;
my $file ;
if ( ($file = param( 'erase' ))
&& $file !~ /[^\w.\/]/
&& -f $Rootdir.$file
)
{
open F, ">/tmp/emptyFile" ;
close( F );
system( "/usr/bin/sudo cp /tmp/emptyFile $Rootdir$file" ) ;
print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",
b("File $Rootdir$file has been erased." ) ;
}
print p() ;
print '<Table border="0">' ;
print Tr( td( "" ), # Nothing over the file icons
td( a( {href=>"syslogs.cgi?sort=name&dir=$dirpath" },
(($sortBy eq 'name') ? '<b>Name</b>' : 'Name')
)
),
td( {width=>"20"} ),  # Spacer Column
td( {align=>'center'},
a( {href=>( ($sortBy ne 'time')
? "syslogs.cgi?sort=time&dir=$dirpath"
: "syslogs.cgi?sort=timer&dir=$dirpath"
)
},
(($sortBy eq 'time' || $sortBy eq 'timer')
? '<b>Modified</b>'
: 'Modified')
)
),
td( {width=>"20"} ),  # Spacer Column
td( {align=>'center'},
a( {href=>( ($sortBy ne 'size')
? "syslogs.cgi?sort=size&dir=$dirpath"
: "syslogs.cgi?sort=sizer&dir=$dirpath"
)
},
(($sortBy eq 'size' || $sortBy eq 'sizer')
? '<b>Size</b>'
: 'Size')
)
),
td( {width=>"20"} ),  # Spacer Column
td("Erase"),
) ;
print Tr( td( {colspan=>8}, hr() ) ) ;
if (! chdir $Rootdir.$dirpath )
{
print "</Table>" ;
print "This directory does not exist, or cannot be read." ;
print end_html() ;
goto EXIT ;
}
my %types = () ;
open( TYPES, '-|', '/usr/bin/sudo /usr/bin/file * ..' ) ;
while (<TYPES>)
{
chomp ;
my ($name, $type ) = split ': *', $_, 2 ;
$type = 'wtmp' if ($name =~ /^wtmp/) ;
$types{$name} = $type ;
}
close( TYPES ) ;
my @dirfiles = () ;
my @regfiles = () ;
for my $f (glob '*')
{
if ($types{$f} =~ 'directory')
{
push @dirfiles, $f ;
}
else
{
push @regfiles, $f ;
}
}
if ($sortBy eq 'time')
{
@dirfiles = sort {(-M $b) <=> (-M $a)} @dirfiles
}
if ($sortBy eq 'size')
{
@regfiles = sort {(-s $b) <=> (-s $a)} @regfiles
}
elsif ($sortBy eq 'sizer')
{
@regfiles = sort {(-s $a) <=> (-s $b)} @regfiles
}
elsif ($sortBy eq 'time')
{
@regfiles = sort {(-M $b) <=> (-M $a)} @regfiles
}
elsif ($sortBy eq 'timer')
{
@regfiles = sort {(-M $a) <=> (-M $b)} @regfiles
}
if ($dirpath ne "/")
{
splice @dirfiles, 0, 0, ( '..' ) ;
}
for my $f (@dirfiles, @regfiles)
{
my $icon ;
my $isRegularFile = 1 ;
my $target ;
my $erase ;
if ($f eq '..')
{
$icon = '/icons/back.gif' ;
$isRegularFile = 0 ;
$target = $dirpath ;
$target =~ s|[^/]*/$|| ;
$target="syslogs.cgi?sort=$sortBy&dir=".$target ;
}
elsif ($types{$f} =~ 'directory')
{
$icon = '/icons/folder.gif' ;
$isRegularFile = 0 ;
$target="syslogs.cgi?sort=$sortBy&dir=".$dirpath.$f."/" ;
}
elsif ( $types{$f} =~ '(text)|(empty)|(wtmp)' )
{
$icon = '/icons/text.gif' ;
$target = "syslogs.cgi?dir=$dirpath&sort=$sortBy&view=$dirpath$f";
}
else
{
$icon = '/icons/binary.gif' ;
$target = "/syslogDownload".$dirpath.$f ;
$target = "syslogs.cgi?dir=$dirpath&sort=$sortBy&view=$dirpath$f";
}
my (undef, undef,undef, undef, undef, undef, undef,
$size, undef, $mtime, undef ) = stat( $Rootdir.$dirpath.$f ) ;
my (undef,$min,$hour,$day,$month,$year) = gmtime($mtime) ;
$month=("Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec")[$month] ;
my $date = sprintf( "%02d-%s-%04d&nbsp;%02d:%02d",
$day,
$month,
$year+1900,
$hour,
$min ) ;
$f = 'Parent Directory' if ($f eq '..') ;
print "<TR>\n" ;
print '<td> <a href ="',
$target,
'"> <img border="0" src="',
$icon,
'"> </a> </td> <td> <a href ="',
$target,
'"> <code>',
$f,
'</code> </a> </td> <td></td> <td> <code>',
$date,
'</code> </td>',
;
if ( $isRegularFile )
{
print '<td></td> <td align="right"> <code>',
$size,
'</code> </td> <td></td> <td align="center"> <a href="syslogs.cgi?sort=',
$sortBy,
'&erase=',
$dirpath,$f,
'"> <img border="0" alt="erase" src="/images/redX.gif"> </a> </td>' ;
}
print "</TR>\n" ;
}
print "</Table>\n", hr() ;
$file = param('view') || '/error_log' ;
$file =~ s/[^\w\.\/]// ;
if ( $file !~ /\.\./ )
{
$dirpath =~ s|[^/\w]|| ;
my $target = "/syslogDownload".$file ;
print startform(),
table( {width=>"100%"},
Tr( td( b( ($file =~ /\.gz$/)
? "Gunzipped "
: "",
"Contents of ",
a( {href=>$target},
$Rootdir.$file
),
" :"
)
),
td(  {align=>'right'},
button( -value=>'To End',
-onClick=> "scrollTo( 0,10000000) "
),
)
)
),
endform() ;
print "<pre>" ;
if ($file =~ /^\/wtmp/)
{
open THEFILE,  "-|", "/usr/bin/last -f $Rootdir$file"  ;
}
elsif($file =~ /\.gz$/)
{
open THEFILE,  "-|", "/bin/gunzip -c $Rootdir$file"  ;
}
else
{
open THEFILE,  "-|", "/usr/bin/sudo /bin/cat $Rootdir$file"  ;
}
print while <THEFILE> ;
close THEFILE ;
print "</pre>" ;
print b( "End of Contents of $Rootdir$file" ),
startform(),
table( {width=>"100%"},
Tr( td( button( -value=>'Refresh',
-onClick=> "parent.loadDataFrame( "
."'/perl-scripts/syslogs.cgi"
."?dir=$dirpath&view=$file#end' )"
)
),
td( {align=>'right'},
button( -value=>'To Top',
-onClick=> "scrollTo( 0,0) "
)
)
),
),
endform(),
a( {name=>"end"} ) ;
}
print end_html() ;
EXIT:
