#!/usr/bin/perl -w
use strict ;
use CGI qw/:standard/;
use Fireball ;
titleWithHelp( 'Satellites - WAAS Controls',
'/satWAASEnaDisInfo.html'
) ;
$_ = qx( /usr/local/fireball/sysinfo -p waas_sv_masks ) ;
my @state = split( " ", $_ ) ;
splice( @state, 0, 2 ) ;
my $waasCount = scalar( @state ) ;
$_ = qx( /usr/local/fireball/sysinfo -p waas_mode ) ;
my $WaasEnabled = ( (split)[2] eq 'on') ? 'On' : 'Off' ;
for ( my $i = 0 ; $i < $waasCount ; ++$i )
{
param( 'Enable'.($i+120),
($state[$i] ne 'D') ? 1 : 0
) ;
param( 'Ignore'.($i+120),
($state[$i] eq 'I') ? 1 : 0
) ;
}
print startform( -name=>'theForm',
-action=>'/perl-scripts/gpsadmin/setWaas.cgi'
) ;
my @WaasControl = radio_group( -name=>'WaasControl',
-value=>[ 'On', 'Off' ],
-default=>$WaasEnabled,
) ;
print table(
Tr( th( {colspan=>'2'}, 'WAAS Tracking:' ) ),
Tr( {align=>'center'},td( $WaasControl[0] ), td( $WaasControl[1] ) ),
) ;
print hr() ;
print '<table border="0">' ;
print th( "Satellite" ),
th( "&nbsp;&nbsp;Enable&nbsp;&nbsp;" ),
th( "Ignore<br />Health" ),
th( "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" ),
th( "Satellite" ),
th( "&nbsp;&nbsp;Enable&nbsp;&nbsp;" ),
th( "Ignore<br />Health" ),
;
for ( my $i = 0 ; $i < 10 ; ++$i )
{
print "<tr>" ;
for my $prn ( $i+120, $i+130 )
{
last if ($prn >= 120+$waasCount ) ;
my $name = $waasStrings{$prn} ;
print td( {align=>'center'},$name )  ;
print td( {align=>'center'},
checkbox( -name=>"Enable$prn",
-value=>'1',
-label=>'',
-onClick=>"enClick($prn)"
)
) ;
print td( {align=>'center'},
checkbox( -name=>"Ignore$prn",
-value=>'1',
-label=>'',
-onClick=>"igClick($prn)"
)
) ;
print td() ;
}
print "</tr>" ;
}
print '</table>' ;
print hr() ;
print button( -name=>'OK',
-value=>'OK',
-onClick=>'parent.submitForm( document.theForm, "" )',
) ;
print '&nbsp;' ;
print button( -name=>'Cancel',
-value=>'Cancel',
-onClick=>
'parent.loadDataFrame( "/perl-scripts/rconfigDisplay.cgi")'
) ;
print endform() ;
print <<EOF ;
<Script>
/**********************************************************************/
function igClick( prn )
/**********************************************************************/
/* Called when an ignore checkbox is clicked, with the prn number as
* a parameter.  If the Ignore button is being enabled, we automatically
* click the matching Enabled button as well.
*/
{
en = document.theForm[ "Enable" + prn ] ;
ig = document.theForm[ "Ignore" + prn ] ;
if (ig.checked)
en.checked = true ;
} /* end of Update() */
/**********************************************************************/
function enClick( prn )
/**********************************************************************/
/* Called when an Enable checkbox is clicked, with the prn number as
* a parameter.  If the Enable button is being disabled, we automatically
* uncheck the matching IgnoreHealth button as well.
*/
{
en = document.theForm[ "Enable" + prn ] ;
ig = document.theForm[ "Ignore" + prn ] ;
if (! en.checked)
ig.checked = false ;
} /* end of Update() */
</Script>
EOF
print end_html() ;
